PROGRAM DMFT2
  USE param
  USE defs
  USE reallocate
  USE ams
  USE normal
  USE bandm
  USE kpp1
  USE struk
  USE xa2
  USE com
  USE char
  USE dmf
  USE com_mpi
  IMPLICIT REAL*8 (A-H,O-Z)
  REAL*8, allocatable       ::  ZZ(:)
  REAL*8,PARAMETER       :: Ry2eV= 13.60569193
  REAL*8           GMAX
  CHARACTER*4      IREL,RELA,cform,RCFILE
  CHARACTER*5      COORD, CHARS
  CHARACTER*10    KNAME
  CHARACTER*11     STATUS,FORM                                      
  CHARACTER*67       ERRMSG
  CHARACTER*80       DEFFN, ERRFN
  CHARACTER*77     RMARGN                                           
  CHARACTER*180     FNAME,FNAME1,fnamehelp
  LOGICAL         SO,vresp_write, helpfiles, Qident
  INTEGER :: imatsubara, irenormalize, latom, loro, locrot, i, icix, wicix, wndim, size, minsigind, recomputeEF
  REAL*8  :: xx(3), xz(3), thetaz, phiz, ddd, check, sw(3), sumw
  REAL*8, allocatable :: wtmpx(:)
  common /mkef/delef,ts2
  DATA             RELA/'RELA'/,SO/.false./                           
  save TTOTAL,TFERMI,TCLM,TFOUR,tstart,errfn                          

  CALL start_MPI()

  Qcomplex=.FALSE.
  nspin1=2
  nlo=0
  RCFILE='NOFI'
  fnamehelp=''
  vresp_write=.false.
  helpfiles=.false.
  iso=1
!-----------------------------------------------------------------------  
!                                                                       
  CALL init_ams
  CALL GTFNAM(DEFFN,ERRFN,iproc)
  CALL ERRFLG(ERRFN,'Error in DMFT2')
  OPEN (1,FILE=DEFFN,STATUS='OLD',ERR=910)

  !100 cdos3
  !xx  EF.dat
  !8   clmval
  !21  scf2
  !26, 27 weigh
  
  DO
     READ (1,*,END=20,ERR=960) IUNIT,FNAME,STATUS,FORM,IRECL

     IF (IUNIT.EQ.6) then
        CALL FilenameMPI(FNAME)    ! Each processor will have different information file 
        OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)            
     else if (iunit.eq.8.or.iunit.eq.21.or.iunit.eq.100) then 
        if (myrank.eq.master) OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)
     else
        OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)                  
     endif
     
     !IF(iunit.NE.6.AND.iunit.NE.8.and.iunit.ne.21) THEN
     !   OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)                  
     !ELSE IF (IUNIT.EQ.6) then
     !   CALL FilenameMPI(FNAME)    ! Each processor will have different information file 
     !   !OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)            
     !else if (iunit.eq.8.or.iunit.eq.21.or.iunit.eq.100) then 
     !   OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM,ERR=920)
     !ENDIF
     
     if(iunit.eq.18) then
        do i=180,5,-1
           if(fname(i:i).ne.' ') then
              if(fname(i-2:i).eq.'vsp') nspin1=1
              CYCLE
           endif
        enddo
     endif
     if(iunit.eq.12) then
        do i=180,6,-1
           if(fname(i:i).ne.' ') then
              if(fname(i-5:i).eq.'normso') then
                 SO=.true.
                 Qcomplex=.TRUE.
                 iso=2
              endif
           endif
        enddo
     endif
     if(iunit==28) vresp_write=.true.
     if(iunit==31) then
        fnamehelp=fname
        helpfiles=.true.
     endif
     if(iunit.eq.13) fname1=fname
     close(13)
     if(iunit.eq.3) then
        read(iunit,'(A5)',end=12) CHARS
        Qcomplex=.true. ! switches Qcomplex  on if case.in1c exists and is nonzero
12      continue
     end if
  ENDDO
20 CONTINUE
  CLOSE (1)

  write(6,*)'Running DMFT2 in single processor mode'
  write(6,*)' '
  
  !                                                                       
  !.....READ STRUCT                                                       
  READ(20,1000) TITLE                                               
  READ(20,1010) LATTIC,NAT,cform,IREL    
  allocate (rmt(nat),v(nat),iatnr(nat),mult(nat),isplit(nat))
  allocate (rotloc(3,3,nat))
  allocate (r0(nat),dx(nat),jri(nat))
  allocate (aname(nat))
  allocate (ZZ(nat))
  allocate ( pos(3,48*nat) )
  !.....READ IN LATTICE CONSTANTS                                         
  READ(20,1020) AA,BB,CC,ALPHA(1),ALPHA(2),ALPHA(3)
  IF(ABS(ALPHA(1)).LT.TEST) ALPHA(1)=NINETY
  IF(ABS(ALPHA(2)).LT.TEST) ALPHA(2)=NINETY
  IF(ABS(ALPHA(3)).LT.TEST) ALPHA(3)=NINETY
  IF(IREL.EQ.'RELA') REL=.TRUE.                                     
  IF(IREL.EQ.'NREL') REL=.FALSE.                                    
  !
  !  read crystal-structure (atompositions, symmetry-parameters,
  !                                muffin-tin radius, ...)
  !  'INDEX' counts all atoms in the unit cell,
  !  'JATOM' counts only the non-equivalent atoms
  INDEX=0                                                           
  DO JATOM = 1,NAT                                               
     INDEX=INDEX+1
     READ(20,1030) IATNR(JATOM),( POS(J,INDEX),J=1,3 ),MULT(JATOM),ISPLIT(JATOM)
     if(isplit(jatom).eq.99)    lxdos=   3           
     if(isplit(jatom).eq.88)    lxdos=   3          
     IF (MULT(JATOM) .EQ. 0) THEN
        !...illegal number of equivalent atoms
        WRITE (6,6000) JATOM, INDEX, MULT(JATOM)
        GOTO 930
     ENDIF
     DO M=1,MULT(JATOM)-1                                     
        INDEX=INDEX+1                                            
        READ(20,1031) IATNR(JATOM),( POS(J,INDEX),J=1,3)         
     ENDDO
     READ(20,1050) ANAME(JATOM),JRI(JATOM),R0(JATOM),RMT(JATOM),ZZ(JATOM)
     DX(JATOM)=LOG(RMT(JATOM)/R0(JATOM)) / (JRI(JATOM)-1)           
     RMT(JATOM)=R0(JATOM)*EXP( DX(JATOM)*(JRI(JATOM)-1) )           
     READ(20,1051) ((ROTLOC(I,J,JATOM),I=1,3),J=1,3)                
  ENDDO


  allocate (pu1u1(0:lxdos,0:lxdos),pu1ue(0:lxdos,0:lxdos),pu1u2(0:lxdos,0:lxdos,nloat),pueue(0:lxdos,0:lxdos),pueu2(0:lxdos,0:lxdos,nloat),pu2u2(0:lxdos,nloat,0:lxdos,nloat))
  ALLOCATE (rotij(3,3,index),tauij(3,index))
  ndif=index
  CALL doreallocate(pos, 3, ndif)
  !.....READ INPUT AND POTE                                               
  READ(5,1003)  MODUS,MODUS1,coord                                        
  write(6,*)  ' Modus: ', MODUS
  !IF(MODUS1.eq.'EECE ') write(6,*)' Density for selected electrons only'
  esepermin=0.5d0
  eseper0=0.05d0

  READ(5,*,err=4716)  EMIN,ELECN,esepermin,eseper0
  write(6,*) 'no read error'
4716 continue

  if(esepermin.lt.1.d-3)   esepermin=0.5d0

  READ(5,1004) efmod,ef
  DO I=1,NAT
     READ(5,*) IDUMMY
  ENDDO
  READ(5,*,END=4715) GMAX

  READ(5,'(A4)',END=4715) RCFILE
4715 CONTINUE
  
  REWIND 5

  READ(5,1234) DUMMY
  write(21,720)gmax
  
  WRITE(6,*) 'RECPR LIST: ',RCFILE
     
  ts2=0.d0
  WRITE(6,800)                                                      
  WRITE(6,805)  TITLE                                               
  WRITE(6,810)  LATTIC                                              
  WRITE(6,820)  AA,BB,CC                                            
  WRITE(6,840)  NAT                                                 
  WRITE(6,850)  IREL                                                
  WRITE(6,870)  COORD
  REL=.FALSE.                                                       
  IF(IREL.EQ.RELA) REL=.TRUE.                                       

  CALL LATGEN(NAT)
  CALL CPUTIM(TTIME)
  TSTART=TTIME
  call walltim(TTIME)
  Tstart_w=TTIME
  
  CALL RECFIL(FNAME1,GMAX,RCFILE,KXMAX,KYMAX,KZMAX,NWAVE)


  !!!! STUF FROM DMFT ????

  ! Reads current input file case.indmf3
  ! 7 is connected to current input file case.indmf3
  ! print *, 'Start reading 7'
  READ(7,*) DM_EMIN,DM_EMAX,irenormalize,projector
  DM_EMIN = DM_EMIN/Ry2eV
  DM_EMAX = DM_EMAX/Ry2eV
  WRITE(*,'(A,1x,f15.10,1x,f15.10)') 'Emin,Emax=', DM_Emin, DM_Emax
  READ(7,*) imatsubara, gammac, gamma, nom_default, aom_default, bom_default
  WRITE(*,'(A,I2,1x,A,f10.5,1x,A,f10.5,1x)') 'imatsubara=', imatsubara, 'gammac=', gammac, 'gamma=', gamma
  read(7,*) natom
  matsubara = imatsubara
  Qrenormalize = irenormalize
  
  write(6, 877) DM_Emin,DM_Emax  ! Energy window
  write(6, 887) natom      ! Projected density of states calculation for xxx atoms
  
  ALLOCATE(nl(natom))
  allocate(ll(natom,4), qsplit(natom,4), cix(natom,4), iatom(natom))
  ALLOCATE(shft(natom,3), crotloc(3,3,natom))
  crotloc=0
  shft = 0

  natm = sum(mult)
  ALLOCATE( isort(natm) )
  wfirst  = 1          ! first atom of this particular sort
  do iat=1,nat         ! over all sorts
     do im=1,MULT(iat) ! over all atoms of this sort
        wat = wfirst + im-1  ! atom number
        isort(wat)=iat       ! sort of each atom
     enddo
     wfirst = wfirst + MULT(iat)
  enddo

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  DO i=1,natom
     READ(7,*) latom,nL(i),locrot ! read from case.inq
     
     iatom(i) = latom       ! The succesive number of atom (all atoms counted)
     jatom = isort(latom)   ! The sort of the atom

     loro = MOD(locrot, 3)
     shift = locrot/3
     
     WRITE(6,'(A,I2,A)'), '--------- atom ', i, ' -------------'

     ! loro can be (0 -original coordinate system), (1 - new z-axis), (2 - new z-axis, x-axis)
     do j=1,nL(i)
        read(7,*) LL(i,j), qsplit(i,j), cix(i,j) ! LL contains all L-quantum numbers which need to be computed.
     enddo

     do j=1,nL(i)
        write(6, '(A,I3,2x,A,I3)') 'l=', LL(i,j), 'qsplit=', qsplit(i,j)
     enddo
     write(6,*)'No symmetrization over eq. k-points is performed'
     
     crotloc(:,:,i) = rotloc(:,:,jatom)  ! Rotation for this type from the struct file

     !print *, 'i=', i, 'jatom=', jatom
     !print *, 'rotloc=', crotloc(:,:,i)

     ! Rotation matrix in case the coordinate system is changed!
     if(loro.gt.0)then        ! change of local rotation matrix
        read(7,*)(xz(j),j=1,3)  ! new z-axis expressed in unit cell vectors
        write(6,120)(xz(j),j=1,3)
        !write(21,120)(xz(j),j=1,3)
        call angle(xz,thetaz,phiz)
        crotloc(1,3,i)=sin(thetaz)*cos(phiz)
        crotloc(2,3,i)=sin(thetaz)*sin(phiz)
        crotloc(3,3,i)=cos(thetaz)          
        if(loro.eq.1)then       ! only z-axis fixed
           crotloc(3,1,i)= 0.     ! new x perpendicular to new z       
           ddd=abs(crotloc(3,3,i)**2-1.)
           if(ddd.gt.0.000001)then
              crotloc(1,1,i)=-crotloc(2,3,i)
              crotloc(2,1,i)= crotloc(1,3,i)
           else
              crotloc(1,1,i)=1.
              crotloc(2,1,i)=0.
           endif
           ddd=0.                 ! normalize new x
           do j=1,3
              ddd=ddd+crotloc(j,1,i)**2
           enddo
           do j=1,3
              crotloc(j,1,i)=crotloc(j,1,i)/sqrt(ddd)
           enddo
        elseif(loro.eq.2)then   ! also new x-axis fixed
           read(7,*)(xx(j),j=1,3)
           write(6,121)(xx(j),j=1,3)
           !write(21,121)(xx(j),j=1,3)
           call angle(xx,thetax,phix)
           crotloc(1,1,i)=sin(thetax)*cos(phix)
           crotloc(2,1,i)=sin(thetax)*sin(phix)
           crotloc(3,1,i)=cos(thetax)          
           !  check orthogonality of new x and z axes
           check=0.
           do j=1,3
              check=check+crotloc(j,1,i)*crotloc(j,3,i)
           enddo
           if(abs(check).gt.0.00001)then
              write(6,*)' new x and z axes are not orthogonal'
              print *,' new x and z axes are not orthogonal'
              stop
           endif
        endif
        crotloc(1,2,i)=crotloc(2,3,i)*crotloc(3,1,i)-crotloc(3,3,i)*crotloc(2,1,i)
        crotloc(2,2,i)=crotloc(3,3,i)*crotloc(1,1,i)-crotloc(1,3,i)*crotloc(3,1,i)
        crotloc(3,2,i)=crotloc(1,3,i)*crotloc(2,1,i)-crotloc(2,3,i)*crotloc(1,1,i)
        write(6,*)' New local rotation matrix in global orthogonal system'
        write(6,*)'                      new x     new y     new z'
        write(6,1013)((crotloc(j,j1,i),j1=1,3),j=1,3)  !written as in .struct
     endif   !change of loc.rot. end
     ! end Rotation matrix loro

     if (shift.gt.0) then
        read(7,*)(shft(i,j),j=1,3)
        write(6,'(A,1x,I2,A,2x,I3,I3,I3)') '** atom', i, ' has nonzero shift: ', shft(i,1), shft(i,2), shft(i,3)
     endif

     write(6,'(A,I2,A)') 'The actual position of the atom ', i, ' is:'
     write(6,'(f10.6,2x,f10.6,2x,f10.6)') POS(1,latom)+shft(i,1), POS(2,latom)+shft(i,2), POS(3,latom)+shft(i,3)
  enddo

  READ(2,*) ! comment: mode and the current chemical potential 
  READ(2,*) mode, DM_EF, recomputeEF, mixEF
  DM_EF = DM_EF/Ry2eV

  READ(7,*) ! comment: Next few lines contain instructions (transformation,index) for all correlated orbitals
  READ(7,*) ncix, maxdim, maxsize ! number of independent cix blocks
  WRITE(6,*) '********** Start Reading Cix file *************'
  ALLOCATE(CF(maxdim,maxdim,ncix))      ! transformation matrix
  ALLOCATE(Sigind(maxdim,maxdim,ncix))  ! correlated index
  ALLOCATE(legend(maxsize, ncix))       ! names of correlated orbitals
  ALLOCATE(csize(ncix))                 ! independent components
  ALLOCATE(wtmpx(2*maxdim))              ! temp
  
  CF=0
  Sigind=0  
  Qident=.True.
  do icix=1,ncix
     READ(7,*) wicix, wndim, size  ! icix, size-of-matrix, L, number of independent components of the matrix

     csize(icix)=size
     if (wicix.ne.icix) then
        print *, 'Something wrong reading case.indmf0 file. Boilig out...'
        goto 999
     endif
     READ(7,*) ! Comment: Independent components are
     READ(7,*) (legend(i,icix),i=1,size)

     READ(7,*) ! Comment: Sigind follows
     do i=1,wndim
        READ(7,*) (Sigind(i,j,icix),j=1,wndim)
     enddo

     minsigind=100
     do i=1,wndim
        do j=1,wndim
           if (Sigind(i,j,icix).ne.0) then
              minsigind = min(minsigind,Sigind(i,j,icix))
           endif
        enddo
     enddo

     if (minsigind.ne.1) then
        do i=1,wndim
           do j=1,wndim
              if (Sigind(i,j,icix).ne.0) then
                 Sigind(i,j,icix) = Sigind(i,j,icix)-minsigind+1
              endif
           enddo
        enddo

        WRITE(6,*) 'Sigind corrected to'
        WRITE(6,*) Sigind(:,:,icix)
     endif
     
     READ(7,*) ! Comment: Transformation matrix follows
     do i=1,wndim
        READ(7,*) (wtmpx(j),j=1,2*wndim)
        do j=1,wndim
           CF(i,j,icix) = dcmplx(wtmpx(2*j-1),wtmpx(2*j))
        enddo
     enddo

     do i=1,wndim
        if (.not.Qident) exit
        do j=1,wndim
           if (i.eq.j) then
              ident=1
           else 
              ident=0
           endif
           if (abs(CF(i,j,icix)-ident)>1e-5) then
              Qident=.False.
              exit
           endif
        enddo
     enddo

     write(6,*)' Correlated block number', icix
     write(6,*)' Correlated index='
     do m1=1,wndim
        do m2=1,wndim
           write(6,'(I3)',advance='no') Sigind(m1,m2,icix)
        enddo
        write(6,*)
     enddo
     write(6,*)' Real part of unitary matrix='
     do m1=1,wndim
        do m2=1,wndim
           write(6,'(F8.4)',advance='no') dble(cf(m1,m2,icix))
        enddo
        write(6,*)
     enddo
     write(6,*)' Imaginary part of unitary matrix='
     do m1=1,wndim
        do m2=1,wndim
           write(6,'(F8.4)',advance='no') aimag(cf(m1,m2,icix))
        enddo
        write(6,*)
     enddo
  enddo
  DEALLOCATE(wtmpx)
  
  if (Qident) then
     write(6,*)' All transformation matrices are Identity'
  else
     write(6,*)' At least one transformation matrix is not Identity'
  endif

  ! For spin-orbit coupling crates transformation "rotloc"      
  !....reading *.inso
  if (so) then
     do i=1,3
        read(4,*)
     end do
     read(4,*)sw(1),sw(2),sw(3)
     WRITE(6,*) 'so-dir=', sw(:)
     call angle(sw,theta,fi)

     write(6,126)theta,fi
     !write(21,126)theta,fi
     !.... test of collinearity of the z-axis with spin quantization axis
     cost=cos(theta)
     cosf=cos(fi)
     sint=sin(theta)
     sinf=sin(fi)
     xz(1)=sint*cosf
     xz(2)=sint*sinf
     xz(3)=cost
     do i=1,natom
        dsum=crotloc(3,1,i)*xz(1)+crotloc(3,2,i)*xz(2)+crotloc(3,3,i)*xz(3)
        if(abs(dsum-1.).gt.0.00001)then  ! old z not along M, new rotloc
           crotloc(1,1,i)=cosf*cost
           crotloc(2,1,i)=-sinf
           crotloc(3,1,i)=cosf*sint
           crotloc(1,2,i)=sinf*cost
           crotloc(2,2,i)=cosf
           crotloc(3,2,i)=sinf*sint
           crotloc(1,3,i)=-sint
           crotloc(2,3,i)=0
           crotloc(3,3,i)=cost
           write(6,*)' New local rotation matrix with z || M'
           !write(21,*)' New local rotation matrix with z || M'
           write(6,1013)((crotloc(j,j1,i),j1=1,3),j=1,3)  ! written as in .struct
           !write(21,1013)((rotloc(j,j1,i),j1=1,3),j=1,3)
        endif
     end do
  end if  ! spin-orbit
  
  ! If 'EF.dat' exists, we should use it instead of case.indm2
  OPEN(1000,FILE='EF.dat',STATUS='OLD',ERR=991)
  READ(1000,*) DM_EF
  print *, 'Found EF.dat and EF is ', DM_EF
  DM_EF = DM_EF/Ry2eV
991 CONTINUE

  nbmax=-5
  sumw=0.0
  ! This computes weights and also reads all k-points
  ! sets nkpt
  CALL FERMI(nbmax,sumw)
  print *, 'sumw=', sumw
  
  eseper=-999.
  eftest=ef 
  if(efmod.eq.'TETRA') eftest=ef-0.5d0
  if(efmod.eq.'GAUSS') eftest=ef-0.5d0
  !     Added TEMPS mode
  if(efmod(1:4).eq.'TEMP') then
     eftest=ef+delef
     do i=1,nume
        wtmp=0
        do i1=1,nkpt-1
           wtmp=wtmp+weigh(i1,i)
        enddo
        if(wtmp .lt. 1.d-4) then
           nbmax=i-1
           exit
        endif
     enddo
  endif

  write(6,*)
  write(6,*) 'Bandranges (emin - emax) and occupancy:'
  write(21,*) '        Bandranges (emin - emax) and occupancy:'
  do i=1,nume
     if(ebmax(i).lt.-990.d0) exit
     wtmp=0
     do i1=1,nkpt-1
        wtmp=wtmp+weigh(i1,i)
     enddo
     write(6,901) 'band',i,ebmin(i),ebmax(i),wtmp
     if(i.le.nbmax+5.and.i.ge.nbmax-10) write(21,'(a4,i5.5,a1,i4,2f12.6,f12.8)') ':BAN',i,':',i,ebmin(i),ebmax(i),wtmp
  enddo
  write(6,*)
  write(6,*) 'eseper below EF',esepermin
  write(6,*) 'eseper minimum gap',eseper0

  do i=nume-1,2,-1
     if(ebmax(i).lt.-990.d0) cycle
     if(ebmax(i-1).lt.eftest - esepermin ) then
        !... requires band gaps of more than eseper0 and Esepermin below EF for e-seperation
        if(ebmin(i)-eseper0 .gt. ebmax(i-1)) then
           eseper=ebmin(i)-eseper0
           exit
        endif
     endif
  enddo
  write(6,*) 'Energy to separate semicore and valence states:',eseper
  write(21,121) eseper
  IF(SO) then
     do i1=1,nkpt-1   ! 110
        do i2=1,nume  ! 110
           WEIGH(i1,i2)=WEIGH(i1,i2)*2.0d0/NSPIN1
        enddo         ! 110
     enddo            ! 110
  ENDIF
     

  if(efmod.eq.'TETRA') then
     WRITE(6,1061)  ELECN,EF-0.5d0 
     WRITE(21,1061) ELECN,EF-0.5d0
     DELEF=-0.5d0
  elseif(efmod.eq.'GAUSS') then
     WRITE(6,1062)  ELECN,EF-0.5d0 
     WRITE(21,1062) ELECN,EF-0.5d0 
     DELEF=-0.5d0
  elseif(efmod(1:4).eq.'TEMP') then
     WRITE(6,1063)  ELECN,EF+delef
     WRITE(21,1063) ELECN,EF+delef 
  else
     WRITE(6,1060)  ELECN,EF
     WRITE(21,1060) ELECN,EF    
     DELEF=0.d0                                       
  endif
         
  write(26)EF,eseper
  wmist=0.d0
  do j=1,nkpt-1
     write(26)NE(J)
     write(26)(WEIGH(J,N), N=1,NE(J))
     do n=1,ne(j)
        wmist=wmist+WEIGH(J,N)
     enddo
  enddo
  write(6,*) 'wmist',wmist
  
  CALL CPUTIM(TTIME)
  TFERMI=TTIME                                        
  call walltim(TTIME)
  TFermi_w=TTIME

  
  !.....CALCULATE CHARGE DENSITY CLM(R) IN SPHERES,  PARTIAL CHARGES      
  call l2main(cform,nlo,coord,zz,so,NSPIN1,vresp_write,sumw,nwave,recomputeEF,TCLM,TCLM_w,TFOUR,TFOUR_w)
  
  !CALL CPUTIM(TTIME)
  !TCLM=TTIME
  !call walltim(TTIME)
  !Tclm_w=TTIME
     
  !.....CALCULATE CHARGE DENSITY RHOK(K) IN INTERSTITIAL                  
  !CALL FOURIR(nlo,nwave,vresp_write)
  
  !CALL CPUTIM(TTIME)
     
  !TFOUR=TTIME                                          
  !call walltim(TTIME)
  !TFOUR_w=TTIME


  DEALLOCATE(CF)      ! transformation matrix
  DEALLOCATE(Sigind)  ! correlated index
  DEALLOCATE(legend)       ! names of correlated orbitals
  DEALLOCATE(csize)                 ! independent components
  DEALLOCATE(nl, ll, qsplit, cix, iatom)
  DEALLOCATE(shft, crotloc, isort)


  
  !.....CALCULATE CPUTIME REQUIRED                                        
  TTOTAL=TFOUR-TSTART                                               
  TFOUR=TFOUR-TCLM                                                  
  PFOUR=TFOUR/TTOTAL*100.                                           
  TCLM=TCLM-TFERMI                                                  
  PCLM=TCLM/TTOTAL*100.                                             
  TFERMI=TFERMI-TSTART                                              
  PFERMI=TFERMI/TTOTAL*100.                                         
  WRITE(6,2000)                                                     
  WRITE(6,2010) TTOTAL,100.0
  WRITE(6,2020) TFERMI,PFERMI
  WRITE(6,2030) TCLM,PCLM
  WRITE(6,2040) TFOUR,PFOUR

  TTOTAL_w=TFOUR_w-TSTART_w                                               
  TFOUR_w=TFOUR_w-TCLM_w                                                  
  PFOUR_w=TFOUR_w/TTOTAL_w*100.                                           
  TCLM_w=TCLM_w-TFERMI_w                                                  
  PCLM_w=TCLM_w/TTOTAL_w*100.                                             
  TFERMI_w=TFERMI_w-TSTART_w                                              
  PFERMI_w=TFERMI_w/TTOTAL_w*100.                                         
  WRITE(6,2001)                                                     
  WRITE(6,2010) TTOTAL_w,100.0
  WRITE(6,2020) TFERMI_w,PFERMI_w
  WRITE(6,2030) TCLM_w,PCLM_w
  WRITE(6,2040) TFOUR_w,PFOUR_w
  CALL ERRCLR(ERRFN)

  CALL stop_MPI()
  
  STOP ' DMFT2 END'                                                 
!
!        error handling
!
910 INFO = 1
!
!        'lapw2.def' couldn't be opened
!
  WRITE (ERRMSG,9000) FNAME
  CALL OUTERR('DMFT2',ERRMSG)
  GOTO 999
920 INFO = 2
!
!        file FNAME couldn't be opened
!
  WRITE (ERRMSG,9010) IUNIT
  CALL OUTERR('DMFT2',ERRMSG)
  WRITE (ERRMSG,9020) FNAME
  CALL OUTERR('DMFT2',ERRMSG)
  WRITE (ERRMSG,9030) STATUS, FORM
  CALL OUTERR('DMFT2',ERRMSG)
  GOTO 999
930 INFO = 3
!
!        illegal number of equivalent atoms
!
  CALL OUTERR('DMFT2','MULT .EQ. 0')
  GOTO 999
956 INFO = 56
  CALL OUTERR('DMFT2','LXDOS must be 3 for ISPLIT=99 or 88')
  CALL OUTERR('DMFT2','LXDOS must be 3 for ISPLIT=99 or 88')
  GOTO 999
960 INFO = 7
!
!        Error reading file 'lapw2.def'
!
  WRITE (ERRMSG,9040) FNAME
  CALL OUTERR('DMFT2',ERRMSG)
  GOTO 999
999 STOP 'DMFT2 - Error. Check file lapw2.error'
!                                                                       
!                                                                       
78 FORMAT('K-PNT',I6,':',2x,I4,' BANDS')
79 FORMAT(2(F16.12))
80 FORMAT('FERMI ENERGY: ',F12.9,I8,' K-POINTS')
81 FORMAT(A30)
43 FORMAT(3X,A77)                                                    
44 FORMAT(I3,A77)                                                    
121 format('        Energy to separate low and high energy','states: ',f10.5)
700 FORMAT(I3,A77)                                                    
720 FORMAT(':GMA  :',' POTENTIAL AND CHARGE CUT-OFF',f7.2,' Ry**.5')
800 FORMAT(////,30X,50(1H-),/,33X,'S T R U C T U R A L   ','I N F O R M A T I O N',/,30X,50(1H-),//)                  
805 FORMAT(3X,'SUBSTANCE',20X,'= ',A80,/)                             
810 FORMAT(3X,'LATTICE',22X,'= ',A4)                                  
820 FORMAT(3X,'LATTICE CONSTANTS ARE',8X,'= ',3F12.7)                 
830 FORMAT(3X,'SYMMETRY ATTITUDE IS',9X,'= ',A4)                      
840 FORMAT(3X,'NUMBER OF ATOMS IN UNITCELL  = ',I3)                   
850 FORMAT(3X,'MODE OF CALCULATION IS',7X,'= ',A4)                    
860 FORMAT(3X,'SELFCONSISTENT CYCLE-NUMBER  = ',I3,/)                 
870 FORMAT(3X,'TYPE OF COORDINATES IN DSPLIT= ',A5)                   
901 format(a,i8,2F16.10,D18.6)
1000 FORMAT(A80)                                                       
1010 FORMAT(A4,23X,I3,1x,a4,/,13X,A4,18X,A4)                                 
1020 FORMAT(6F10.7,10X,F10.7)                                          
1030 FORMAT(4X,I4,4X,F10.7,3X,F10.7,3X,F10.7,/,15X,I2,17X,I2)          
1031 FORMAT(4X,I4,4X,F10.7,3X,F10.7,3X,F10.7)                          
1040 FORMAT(///,3X,'ERROR IN DMFT2 : MULT(JATOM)=0 ...',/, 20X,'JATOM=',I3,3X,'INDEX=',I3,3X,'MULT=',I3)           
1050 FORMAT(A10,5X,I5,5X,F10.9,5X,F10.5,5X,F10.5)                      
1051 FORMAT(20X,3F10.8)                                             
1002 FORMAT(3F10.5,I5)                                                 
1003 FORMAT(A5,a5,a5)                                                        
1004 FORMAT(A5,f10.5)                                                        
1060 FORMAT(//,':NLDA  :',1X,'NUMBER OF ELECTRONS',10X,'=',F8.3,//   ,':FLDA  :',1X,'F E R M I - ENERGY',11X,'= ',F9.5)            
1061 FORMAT(//,':NLDA  :',1X,'NUMBER OF ELECTRONS',10X,'=',F8.3,//   ,':FLDA  :',1X,'F E R M I - ENERGY(TETRAH.M.)','= ',F9.5)           
1062 FORMAT(//,':NLDA  :',1X,'NUMBER OF ELECTRONS',10X,'=',F8.3,//   ,':FLDA  :',1X,'F E R M I - ENERGY(GAUSS-.M.)','= ',F9.5)           
1063 FORMAT(//,':NLDA  :',1X,'NUMBER OF ELECTRONS',10X,'=',F8.3,//   ,':FLDA  :',1X,'F E R M I - ENERGY(FERMI-SM.)','= ',F9.5)           
1234 FORMAT(//,1A)
2000 FORMAT(//,3X,'=====>>> CPU TIME SUMMARY',/)                       
2001 FORMAT(//,3X,'=====>>> WALL TIME SUMMARY',/)                       
2010 FORMAT(12X,'TOTAL       : ',F8.1,5X,'... ',F4.0,' PERCENT')       
2020 FORMAT(12X,'PART FERMI  : ',F8.1,5X,'... ',F4.0,' PERCENT')       
2030 FORMAT(12X,'PART CLM    : ',F8.1,5X,'... ',F4.0,' PERCENT')       
2040 FORMAT(12X,'PART FOURIR : ',F8.1,5X,'... ',F4.0,' PERCENT')       
2061 FORMAT(1X,'        ',I10,1X,'NUMBER OF PW')    !EECE
6000 FORMAT(///,3X,'ERROR IN DMFT2 : MULT(JATOM)=0 ...',/, 20X,'JATOM=',I3,3X,'INDEX=',I3,3X,'MULT=',I3)
9000 FORMAT('can''t open definition file ',A40)
9010 FORMAT('can''t open unit: ',I2)
9020 FORMAT('       filename: ',A50)
9030 FORMAT('         status: ',A,'  form: ',A)
9040 FORMAT('Error reading file: ',A47)
877 FORMAT(' Energy window:',f10.4,' < E < ',f10.3)
887 FORMAT(' Greens function calculation for',i3,' atoms')
120 FORMAT(' New z axis || ',3f9.4)
1013 FORMAT('LOCAL ROT MATRIX:   ',3f10.7,/,20x,3f10.7,/,20x,3f10.7)
126 FORMAT(' Magnetic system with s-o coupling; M theta, phi:',2f8.4) 
END PROGRAM DMFT2
