SUBROUTINE Read_Vec_Spin(ikp, E, wgh, As, As_lo, kx, ky, kz, kxlo, kylo, kzlo, bkx, bky, bkz, bkxlo, bkylo, bkzlo, nemin, nemax, DM_nemin, DM_nemax, more_kpoints, n0, emin, emax, DM_Emin, DM_Emax, iso, nmat, nume, nnlo)
  use com, ONLY: weigh
  use dmf, ONLY: Qcomplex
  IMPLICIT NONE
  INTEGER, intent(in)  :: ikp
  REAL*8,  intent(out) :: E(nume), wgh !, weight(nume)
  !  !_REAL REAL*8,intent(out)        :: As(nmat,nume,iso)
  !  !_REAL REAL*8,intent(out)        :: As_lo(nnlo,nume,iso)
  !  !_COMPLEX COMPLEX*16,intent(out) :: As(nmat,nume,iso)
  !  !_COMPLEX COMPLEX*16,intent(out) :: As_lo(nnlo,nume,iso)
  !
  COMPLEX*16,intent(out) :: As(nmat,nume,iso)
  COMPLEX*16,intent(out) :: As_lo(nnlo,nume,iso)
  INTEGER, intent(out) :: kx(nmat), ky(nmat), kz(nmat), kxlo(nnlo), kylo(nnlo), kzlo(nnlo)
  REAL*8,  intent(out) :: bkx(nmat), bky(nmat), bkz(nmat), bkxlo(nnlo), bkylo(nnlo), bkzlo(nnlo)
  INTEGER, intent(out) :: nemin, nemax, DM_nemin, DM_nemax
  LOGICAL, intent(out) :: more_kpoints
  INTEGER, intent(out) :: n0
  REAL*8,  intent(in)  :: emin, emax, DM_Emin, DM_Emax
  INTEGER, intent(in)  :: iso, nmat, nume, nnlo
  ! locals
  REAL*8  :: As_tmp(nmat)
  INTEGER :: i, is, itape, ios, ne, num, nlov
  REAL*8  :: s,t,z, vnorm1
  CHARACTER*10 :: bname
  
  DO is=1,iso
     itape=8+is
     READ(itape,IOSTAT=ios) s,t,z,bname,n0,ne,wgh
     more_kpoints=.FALSE.
     IF (ios /= 0) EXIT
     more_kpoints=.TRUE.
     
     READ(itape) (kx(i),ky(i),kz(i),i=1,n0-nnlo),(kxlo(i),kylo(i),kzlo(i),i=1,nnlo)
     
     DO i=1,n0-nnlo
        bkx(i)=(s+kx(i))
        bky(i)=(t+ky(i))
        bkz(i)=(z+kz(i))
     ENDDO
     DO i=1,nnlo
        bkxlo(i)=(s+kxlo(i))
        bkylo(i)=(t+kylo(i))
        bkzlo(i)=(z+kzlo(i))
     ENDDO
     nemin=1
     nemax=0
     DM_nemin=1
     DM_nemax=0
     DO
        READ(itape) num,E(num)
        if (Qcomplex) then
           READ(itape) (As(i,num,is),i=1,n0)
        else
           READ(itape) (As_tmp(i),i=1,n0)
           As(:n0,num,is) = As_tmp(:n0)
        endif
        As_lo(:nnlo,num,is) = As(n0-nnlo+1:n0,num,is)
        IF(e(num).LT.DM_Emin) DM_nemin=DM_nemin+1                           
        IF(e(num).LE.DM_Emax) DM_nemax=DM_nemax+1     
        IF(e(num).LT.emin) nemin=nemin+1                           
        IF(e(num).LE.emax) nemax=nemax+1     
        IF(num.EQ.ne) EXIT
     ENDDO
  ENDDO     
  RETURN
END SUBROUTINE Read_Vec_Spin


SUBROUTINE Read_Vec_Spin_DontStore(nemin, DM_nemin, DM_nemax, more_kpoints, n0)
  use com, ONLY: weigh, emin
  use dmf, ONLY: DM_Emin, DM_Emax, iso, Qcomplex
  IMPLICIT NONE
  INTEGER, intent(out) :: nemin, DM_nemin, DM_nemax, n0
  LOGICAL, intent(out) :: more_kpoints
  REAL*8     :: wAsr
  COMPLEX*16 :: wAsc
  REAL*8   :: wE, wgh
  INTEGER :: wkx, wky, wkz
  ! locals
  INTEGER :: i, is, itape, ios, ne, num, nlov
  REAL*8  :: s,t,z
  CHARACTER*10 :: bname
  
  itape=9
  READ(itape,IOSTAT=ios) s,t,z,bname,n0,ne,wgh
  more_kpoints=.FALSE.
  IF (ios /= 0) RETURN
  more_kpoints=.TRUE.
  
  READ(itape) (wkx,wky,wkz,i=1,n0)
     
  nemin=1
  DM_nemin=1
  DM_nemax=0
  DO
     READ(itape) num,wE
     if (Qcomplex) then
        READ(itape) (wAsc,i=1,n0)
     else
        READ(itape) (wAsr,i=1,n0)
     endif
     IF(wE.LT.DM_Emin) DM_nemin=DM_nemin+1                           
     IF(wE.LE.DM_Emax) DM_nemax=DM_nemax+1     
     IF(wE.LT.emin) nemin=nemin+1                           
     IF(num.EQ.ne) EXIT
  ENDDO

  RETURN
END SUBROUTINE Read_Vec_Spin_DontStore

SUBROUTINE CompressSigmaTransformation2(STrans, DMFTU, Sigind, iSx, cix, csize, iorbital, ll, nl, natom, iso, ncix, maxdim, maxdim2, lmax2, norbitals, nbands, maxsize)
  IMPLICIT NONE
  COMPLEX*16, intent(out) :: STrans(maxsize,ncix,nbands,nbands)
  COMPLEX*16, intent(in)  :: DMFTU(nbands,maxdim2,norbitals)
  INTEGER, intent(in)     :: iSx(maxdim2, norbitals)
  INTEGER, intent(in)     :: Sigind(maxdim,maxdim,ncix), cix(natom,4), csize(ncix)
  INTEGER, intent(in)     :: iorbital(natom,lmax2+1), ll(natom,4), nl(natom)
  INTEGER, intent(in)     :: natom, iso, ncix, maxdim, maxdim2, lmax2, norbitals, nbands, maxsize
  !----- locals
  INTEGER    :: i, j, icase, jcase, lcase, l1case, l2case, iorb, iorb1, iorb2, it, ind1, nind1, ind2, nind2, icix, l1, l2, ip1, ip2
  STrans=0
  DO icase=1,natom      
     do l1case=1,nl(icase) 
        icix = cix(icase,l1case)
        if ( icix.EQ.0 ) CYCLE
        l1 = ll(icase,l1case)
        nind1 = (2*l1+1)*iso
        iorb1 = iorbital(icase,l1case)
        DO jcase=1,natom
           do l2case=1,nl(jcase)
              if ( cix(jcase,l2case).NE.icix ) CYCLE
              l2 = ll(jcase,l2case)
              nind2 = (2*l2+1)*iso
              iorb2 = iorbital(jcase,l2case)
              do ind1=1,nind1
                 do ind2=1,nind2
                    it = Sigind( iSx(ind1,iorb1),iSx(ind2,iorb2), icix )
                    
                    if (it.gt.0) then
                       DO i=1,nbands                     ! over bands-1
                          do j=1,nbands                  ! over bands-2
                             STrans(it,icix,i,j) = STrans(it,icix,i,j) + conjg(DMFTU(j,ind2,iorb2))*DMFTU(i,ind1,iorb1)
                          enddo
                       ENDDO
                    endif
                 enddo
              enddo
           enddo
        ENDDO
     enddo
  ENDDO
END SUBROUTINE CompressSigmaTransformation2

SUBROUTINE AddSigma_optimized2(gij, sigma, STrans, csize, sign, nbands, ncix, maxsize)
  !-- Add's self-energy to inverse of the Green's function in band representation
  !-- 50% of all time is spend in this subroutine, the rest 50 % in CmpGk
  IMPLICIT NONE
  COMPLEX*16, intent(inout):: gij(nbands,nbands)
  COMPLEX*16, intent(in)   :: sigma(maxsize,ncix)
  COMPLEX*16, intent(in)  :: STrans(maxsize,ncix,nbands,nbands)
  INTEGER, intent(in)      :: csize(ncix), sign, nbands, ncix, maxsize
  !----- locals
  COMPLEX*16 :: Sigmaij
  INTEGER    :: i, j, icix, it
  
  DO i=1,nbands                     ! over bands-1
     do j=1,nbands                  ! over bands-2
        Sigmaij=0
        DO icix=1,ncix
           do it=1,csize(icix)
              Sigmaij = Sigmaij + STrans(it,icix,i,j)*sigma(it,icix)
           enddo
        ENDDO
        gij(i,j) = gij(i,j) + sign*Sigmaij
     enddo
  ENDDO
END SUBROUTINE AddSigma_optimized2



SUBROUTINE Get_A_Dimensions(norbitals, maxdim2, iso, natom, nl, ll)
  IMPLICIT NONE
  INTEGER, intent(out) :: norbitals, maxdim2
  INTEGER, intent(in)  :: iso, natom, nl(natom), ll(natom,4) 
  ! locals
  INTEGER::  icase, lcase, l1, nind
  norbitals=0 !-- number of atom/l cases, called orbitals -------------------------------------!
  maxdim2=0
  do icase=1,natom
     do lcase=1,nl(icase)
        norbitals = norbitals+1
        l1 = ll(icase,lcase)
        nind=(2*l1+1)*iso
        maxdim2 = max(maxdim2, nind )
     enddo
  enddo
END SUBROUTINE Get_A_Dimensions



SUBROUTINE Set_A_Arrays(iorbital, nindo, cix_orb, iSx, noccur, cixdim, cfX, CF, norbitals, iso, natom, nl, ll, cix, ncix, maxdim, maxdim2, lmax2, Sigind, csize, maxsize)
  IMPLICIT NONE
  INTEGER, intent(out)   :: iorbital(natom,lmax2+1), nindo(norbitals), cix_orb(norbitals), iSx(maxdim2,norbitals), noccur(maxsize,ncix), cixdim(ncix)
  COMPLEX*16, intent(out):: cfX(maxdim2,maxdim2,norbitals,norbitals)
  COMPLEX*16, intent(in) :: CF(maxdim,maxdim,ncix)
  INTEGER, intent(in)    :: norbitals, iso, natom, nl(natom), ll(natom,4), cix(natom,4), ncix, maxdim, maxdim2, lmax2, Sigind(maxdim,maxdim,ncix), csize(ncix), maxsize
  ! locals
  INTEGER :: iorb, icase, lcase, l1, nind, icix
  INTEGER :: iorb1, iorb2, nind1, nind2, ip1, ind1, ind2, ip, iq, it

  iorbital=0
  cixdim=0
  iorb=0
  do icase=1,natom
     do lcase=1,nl(icase)
        iorb = iorb+1
        iorbital(icase,lcase)=iorb  !-- index to the orbital number ----!
        l1 = ll(icase,lcase)
        nind=(2*l1+1)*iso
        nindo(iorb) = nind
        icix = cix(icase,lcase)
        cix_orb(iorb) = icix
        do ip1=1,nind
           cixdim(icix) = cixdim(icix) + 1
           iSx(ip1,iorb) = cixdim(icix)
           WRITE(6,'(A,7I5)') 'icase,lcase,icix,iorb,nind1,ip1,iSx=', icase, lcase, icix, iorb, nind, ip1,cixdim(icix)
        enddo
     enddo
  enddo

  noccur=0
  DO icix=1,ncix
     DO ip=1,cixdim(icix)
        DO iq=1,cixdim(icix)
           it = Sigind(ip,iq,icix)
           if (it.gt.0)  noccur(it,icix) = noccur(it,icix) + 1
        ENDDO
     ENDDO
  ENDDO

  do icix=1,ncix
     WRITE(6,'(A,I2,A,I2)') 'cixdim(', icix, ')=', cixdim(icix)
     DO it=1,csize(icix)
        WRITE(6,'(A,I2,A,I2,A,I4)') 'noccur(',it,',',icix,')=', noccur(it,icix)
     ENDDO
  enddo

  do iorb=1,norbitals
     do ip1=1,nindo(iorb)
        WRITE(6,'(A,I2,A,I2,A,I3)') 'iSx(', ip1, ',', iorb, ')=', iSx(ip1,iorb)
     enddo
  enddo
  do iorb=1,norbitals
     WRITE(6,'(A,I2,A,I3)') 'nindo(', iorb, ')=', nindo(iorb)
  enddo

  DO iorb1=1,norbitals
     nind1 = nindo(iorb1)
     if ( cix_orb(iorb1).EQ.0 ) CYCLE
     DO iorb2=1,norbitals
        nind2 = nindo(iorb2)
        if ( cix_orb(iorb1).NE.cix_orb(iorb2) ) CYCLE
        icix = cix_orb(iorb1)
        do ind1=1,nind1
           do ind2=1,nind2
              cfX(ind1,ind2,iorb1,iorb2) = CF( iSx(ind1,iorb1),iSx(ind2,iorb2), icix )
           enddo
        enddo
     ENDDO
  ENDDO
  do iorb1=1,norbitals
     do iorb2=1,norbitals
        if ( cix_orb(iorb1).EQ.0 ) CYCLE
        if ( cix_orb(iorb1).NE.cix_orb(iorb2) ) CYCLE
        WRITE(6,'(A,I2,A,I2)') 'CF for iorb1=', iorb1, ' iorb2=', iorb2
        do ind1=1,nind1
           do ind2=1,nind2
              WRITE(6,'(f14.8,1x,f14.8,3x)', advance='no') dble(cfX(ind1,ind2,iorb1,iorb2)), aimag(cfX(ind1,ind2,iorb1,iorb2))
           enddo
           WRITE(6,*)
        enddo
     enddo
  enddo
END SUBROUTINE Set_A_Arrays




SUBROUTINE Build_DMFT_Projection(DMFTU, alm, blm, clm, h_yl, h_alyl, h_blyl, cfX, iorbital, norbitals, n0, nnlo, nbands, cix_orb, nindo, DM_nemin, DM_nemax, maxdim2)
  USE w_atpar
  USE dmf, ONLY: DM_Emin, DM_Emax, iso, projector, natom, nl, ll, cix, iatom, shft, isort, crotloc, ncix, maxdim, maxsize, CF, Sigind, csize, Qcomplex
  USE defs, ONLY: PI
  USE param, ONLY: lomax, nloat, iblock, nmat, lmax2, nume
  USE lo, ONLY: alo, blo, clo, nlo, nlov, nlon, loor, ilo, lapw, pi12lo, pe12lo, pr12lo
  USE atspdt,ONLY: P, DP, PE, DPE, PEI
  USE xa, ONLY: fj, dfj
  USE xa3, ONLY: bkx, bky, bkz, As
  USE struk, ONLY: rotij, tauij, BR1, POS, RMT, VOL
  IMPLICIT NONE
  complex*16, intent(out)  :: DMFTU(nbands,maxdim2,norbitals)
  complex*16, intent(in)   :: cfX(maxdim2,maxdim2,norbitals,norbitals)
  INTEGER, intent(in)      :: n0, nnlo, DM_nemin, DM_nemax, iorbital(natom,lmax2+1), maxdim2, nbands, cix_orb(norbitals), nindo(norbitals), norbitals
  COMPLEX*16, intent(inout):: alm((lmax2+1)*(lmax2+1),nume),blm((lmax2+1)*(lmax2+1),nume),clm((lmax2+1)*(lmax2+1),nume,nloat)
  complex*16, intent(inout):: h_yl((LMAX2+1)*(LMAX2+1),iblock), h_alyl((LMAX2+1)*(LMAX2+1),iblock), h_blyl((LMAX2+1)*(LMAX2+1),iblock)
  ! locals
  INTEGER   :: icase, lcase, latom, jatom, lfirst, is, ii, i3, l, M, index, ibb, lda, ldb, ldc, isize, jlo, jlop, num, iorb, ind, i, nind, icix, num1, m1, iorb1, nind1, nind2, iorb2
  REAL*8    :: BK(3), BKROT2(3), BKROT3(3), BKRLOC(3), sm1, sm2, ff
  REAL*8    :: ARG1, ARG2, ARG3, ARGT, ARGT2, rmt2, h_al(iblock), h_bl(iblock), dff, TWOPI
  COMPLEX*16:: FAC, PHSHEL, CFAC, CC
  COMPLEX*16:: YL((LMAX2+1)*(LMAX2+1))
  COMPLEX*16, ALLOCATABLE :: URx(:,:,:), tmp(:,:), alm0(:,:), blm0(:,:)
  COMPLEX*16, PARAMETER:: IMAG=   (0.0D0,1.0D0)

  TWOPI=2.0*PI

  ALLOCATE( URx(DM_nemax-DM_nemin+1,maxdim2,norbitals), tmp(DM_nemax-DM_nemin+1,maxdim2) )
  ALLOCATE( alm0(2*lmax2+1,nume),blm0(2*lmax2+1,nume))

  URx = 0
  !-------------------------------------------------!
  !--------- Building DMFT Transformation ----------!
  !-------------------------------------------------!
  do icase=1,natom
     latom = iatom(icase)   ! The succesive number of atom (all atoms counted)
     jatom = isort(latom)   ! The sort of the atom  ( == w_jatom(iucase) )
     !----  Setting all values of common-blocks which depend on atom and were computed by atpar ---!
     alo(0:lomax,1:nloat) = w_alo(0:lomax,1:nloat,jatom)
     blo(0:lomax,1:nloat) = w_blo(0:lomax,1:nloat,jatom)
     clo(0:lomax,1:nloat) = w_clo(0:lomax,1:nloat,jatom)
     nlo = w_nlo(jatom)
     nlov = w_nlov(jatom)
     nlon = w_nlon(jatom)

     loor(1:nloat,0:lomax) = w_loor(1:nloat,0:lomax,jatom)
     ilo(0:lmax2) = w_ilo(0:lmax2,jatom)
     lapw(0:lmax2) = w_lapw(0:lmax2,jatom)
     P(0:LMAX2) = w_P(0:LMAX2,jatom)
     DP(0:LMAX2) = w_DP(0:LMAX2,jatom)
     PE(0:LMAX2) = w_PE(0:LMAX2,jatom)
     DPE(0:LMAX2) = w_DPE(0:LMAX2,jatom)
     lfirst = w_lfirst(jatom)

     PEI(0:LMAX2) = w_PEI(0:LMAX2,jatom)
     pi12lo(1:nloat,0:lomax) = w_pi12lo(1:nloat,0:lomax,jatom)
     pe12lo(1:nloat,0:lomax) = w_pe12lo(1:nloat,0:lomax,jatom)
     pr12lo(1:nloat,1:nloat,0:lomax) = w_pr12lo(1:nloat,1:nloat,0:lomax,jatom)

     FAC=4.0D0*PI*RMT(jatom)**2/SQRT(VOL)

     DO is=1,iso  !--- over both spins
        alm(:,:) = 0.0         !------  ALM(m,band,nrf,is) will hold product of eigenvectors and a/b expansion coefficients --!
        blm(:,:) = 0.0
        clm(:,:,:) = 0.0
        alm0(:,:)=0
        blm0(:,:)=0
        !--------- blocks are for efficiency. Matrix is multiplied in block form. This must be important in the past, while modern BLAS should do that better. I think it is obsolete.
        DO ii=1,n0-nnlo,iblock !------ iblock is 128 for 32-bit system -------!
           !-------- nlo-number of local orbitals -----!
           h_yl=0
           i3=0                   
           do i=ii,min(ii+iblock-1,n0-nnlo)  
              !---------  rotates ylm(k+K) to ylm(k'+K) where k' is in star of irreducible k. ------------!
              i3=i3+1
              BK(1)=BKX(I) !-----  reciprocal vector and irreducible vector: G=K+k ----!
              BK(2)=BKY(I)
              BK(3)=BKZ(I)
              ! BKROT = R_g.(k+K)
              CALL ROTATE (BK,rotij(1,1,latom),BKROT2)  ! apply one of the symmetry operations to BKROT=R.(k+K)
              !---- BR1 transforms integer reciprocal lattice vectors, as given in the VECTORLIST of LAPW1, into cartesian system ----!
              BKROT3(1)=BKROT2(1)*BR1(1,1)+BKROT2(2)*BR1(1,2)+BKROT2(3)*BR1(1,3) 
              BKROT3(2)=BKROT2(1)*BR1(2,1)+BKROT2(2)*BR1(2,2)+BKROT2(3)*BR1(2,3)
              BKROT3(3)=BKROT2(1)*BR1(3,1)+BKROT2(2)*BR1(3,2)+BKROT2(3)*BR1(3,3)
              !---- BKRLOC = Rotloc.R_g.(k+K),  is rotates Rotloc.R.(k+K) . Rotation Rotloc entered by user
              CALL ROTATE (BKROT3,crotloc(1,1,icase),BKRLOC)
              !---- YLM = Y_{L}(Rotloc.R_g.(k+K))
              CALL YLM (BKRLOC,LMAX2,YL)  ! 
              ! ARG1 + ARG2 + ARG3 = (R_g.(k+K)) *  R(lfirst) * 2pi
              ARG1=BKROT2(1)*(POS(1,lfirst)+shft(icase,1))*TWOPI !???? Is there latom of lfirst!???
              ARG2=BKROT2(2)*(POS(2,lfirst)+shft(icase,2))*TWOPI
              ARG3=BKROT2(3)*(POS(3,lfirst)+shft(icase,3))*TWOPI
              ! ARGT = (K+k)*tau(isym) 
              ARGT2=(BKX(i)*tauij(1,latom)+BKY(i)*tauij(2,latom)+BKZ(i)*tauij(3,latom))*twopi
              !ARGT=(BKX(I)*TAU(1,isym)+BKY(I)*TAU(2,isym)+BKZ(I)*TAU(3,isym))*TWOPI
              ! PHSEHL = e^{I*2pi*( (R_g.(k+K)) *  R(iatom) + (K+k)*tau(isym))}
              PHSHEL=EXP(IMAG*(ARG1+ARG2+ARG3+ARGT2))
              do lcase=1,nl(icase) !----------- loop over L(jatom) requested in the ionput ---------------!
                 l=ll(icase,lcase) !------ current L --!
                 DO  M=1,2*l+1
                    index = M+l*l
                    h_yl(index,i3)=conjg(yl(index))*phshel !----- h_yl is rotated yl when k is rotated to k' -----!
                 END DO
              enddo
           enddo

           rmt2=1.D0/(rmt(jatom)**2)
           h_alyl=0
           h_blyl=0
           do lcase=1,nl(icase) !----------- loop over L(jatom) requested in the ionput ---------------!
              l=ll(icase,lcase) !------ current L --!
              i3=0
              do i=ii,min(ii+iblock-1,n0-nnlo)
                 i3=i3+1
                 if (lapw(l)) then
                    h_al(i3)=dfj(l,i,jatom)*PE(l)-fj(l,i,jatom)*DPE(l) 
                    h_bl(i3)=fj(l,i,jatom)*DP(l)-dfj(l,i,jatom)*P(l)
                 else
                    h_al(i3) = rmt2*fj(l,i,jatom)/P(l)
                    h_bl(i3) = 0.0
                 end if
              enddo
              i3=0
              do i=ii,min(ii+iblock-1,n0-nnlo)
                 i3=i3+1
                 DO m=1,2*l+1
                    index = l*l+m
                    h_alyl(m,i3)=h_al(i3)*h_yl(index,i3)
                    h_blyl(m,i3)=h_bl(i3)*h_yl(index,i3)
                 enddo
              ENDDO

              !---- h_alyl(2*lmax+1,iblock,is)  contains rotated Apw's, such that chi(r) = (Apw*u(r) + Bpw*udot(r))*Ylm(r)
              !---- h_blyl(2*lmax+1,iblock,is)  contains rotated Bpw's
              !---- A(:N,iband,is)              contains eigenvectors, also named C(k+G,inad,is)
              !---- alm[2*l+1,iband][irf=1,is] += sum_{iK\in block} h_alyl[2*l+1,iK][is]*A[iK,iband][is]
              !---- alm[2*l+1,iband][irf=2,is] += sum_{iK\in block} h_blyl[2*l+1,iK][is]*A[iK,iband][is]
              !---- 
              !---- The results is:
              !---- alm[lm,iband][1,is] = sum_G Apw(lm,is,K+G) * C(k+G,iband,is)
              !---- alm[lm,iband][2,is] = sum_G Bpw(lm,is,K+G) * C(k+G,iband,is)
              !---- Where C(k+G,iband,is) are eigenvectors, and Apw and Bpw are expansion coefficients defined in Shick et.al., PRB 60, 10763 (1999).
              ibb=min(iblock,n0-nnlo-ii+1)
              !!if(ibb.le.0) EXIT

              ldb=nmat
              !  !_REAL        lda=2*(LMAX2+1)*(LMAX2+1)
              !  !_REAL        ldc=2*(2*LMAX2+1)
              !  !_REAL        isize = 2*(2*l+1)
              !  !_REAL        CALL dgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,1.d0,h_alyl,lda,As(ii,DM_nemin,is),ldb,1.d0,alm0(1,DM_nemin),ldc)
              !  !_REAL        CALL dgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,1.d0,h_blyl,lda,As(ii,DM_nemin,is),ldb,1.d0,blm0(1,DM_nemin),ldc)
              !  
              !  !_COMPLEX     lda=(LMAX2+1)*(LMAX2+1)
              !  !_COMPLEX     ldc=(2*LMAX2+1)                 
              !  !_COMPLEX     isize = (2*l+1)
              !  !_COMPLEX     CALL zgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,(1.d0,0.d0),h_alyl,lda,As(ii,DM_nemin,is),ldb,(1.d0,0.d0),alm0(1,DM_nemin),ldc)
              !  !_COMPLEX     CALL zgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,(1.d0,0.d0),h_blyl,lda,As(ii,DM_nemin,is),ldb,(1.d0,0.d0),blm0(1,DM_nemin),ldc)
              

              lda=(LMAX2+1)*(LMAX2+1)
              ldc=(2*LMAX2+1)                 
              isize = (2*l+1)
              CALL zgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,(1.d0,0.d0),h_alyl,lda,As(ii,DM_nemin,is),ldb,(1.d0,0.d0),alm0(1,DM_nemin),ldc)
              CALL zgemm('N','N',isize,DM_nemax-DM_nemin+1,ibb,(1.d0,0.d0),h_blyl,lda,As(ii,DM_nemin,is),ldb,(1.d0,0.d0),blm0(1,DM_nemin),ldc)

              DO m=1,2*l+1
                 index = l*l+m
                 alm(index,DM_nemin:DM_nemax)=alm0(m,DM_nemin:DM_nemax)
                 blm(index,DM_nemin:DM_nemax)=blm0(m,DM_nemin:DM_nemax)
              ENDDO
           enddo !----------- over lcase --------------!
        ENDDO    !----------- over iblock -------------!

        !-------------- Adds localized orbitals to alm. -------------------!

        if (nlo.ne.0) call lomain (crotloc(:,:,icase),shft(icase,:),is,DM_nemin,DM_nemax,lfirst,latom,n0,jatom,alm,blm,clm)


        do lcase=1,nl(icase) !----------- loop over L(jatom) requested in the ionput ---------------!
           l=ll(icase,lcase) !------ current L --!
           cfac=imag**l
           DO m=1,2*l+1
              index = l*l+m
              DO num=DM_nemin,DM_nemax
                 alm(index,num)=alm(index,num)*cfac*fac
                 blm(index,num)=blm(index,num)*cfac*fac
              ENDDO

              DO jlo=1,ilo(l)
                 DO num=DM_nemin,DM_nemax
                    clm(index,num,jlo)=clm(index,num,jlo)*cfac*fac
                 ENDDO
              ENDDO
           ENDDO
        enddo


        !---------- Computing the DMFT transformation --------------!
        do lcase=1,nl(icase)
           ! connection between ri_mat and quantities in lapw2
           !       
           !  rf1    rf2       ri_mat
           !   1      1         1.0                 RRADx * RRADx
           !   1      2         0.0                 RRADx * RADEx
           !   1      2+jlo     pi12lo(jlo,l)       RRADx * a1lo
           !   2      2         PEI(l)              RADEx * RADEx
           !   2      2+jlo     pe12lo(jlo,l)       RADEx * a1lo
           !   2+jlo  2+jlop    pr12lo(jlo,jlop,l)  a1lo  * a1lo
           !
           L=ll(icase,lcase)
           nind=(2*L+1)*iso
           icix = cix(icase,lcase)

           iorb = iorbital(icase,lcase)
           do num1=DM_nemin,DM_nemax
              do m1=-L,L           ! over m-1
                 index=L*(L+1)+m1+1
                 ind = L+1+m1+(2*L+1)*(is-1)
                 dff = 1.0
                 if (abs(projector).eq.2) then
                    sm1=0
                    sm2=0
                    !! 1,1
                    !ff = alm(index,num1)*conjg(alm(index,num1))
                    ff = abs(alm(index,num1))**2
                    sm1 = sm1 + ff * 1.0
                    sm2 = sm2 + ff * 1.0
                    !! 2,2
                    !ff = blm(index,num1)*conjg(blm(index,num1))
                    ff = abs(blm(index,num1))**2
                    sm1 = sm1 + ff * PEI(L)
                    sm2 = sm2 + ff * 0.0
                    DO jlo=1,ilo(l)
                       IF(loor(jlo,l)) THEN
                          !! 1,3 and 3,1
                          !ff = alm(index,num1)*conjg(clm(index,num1,jlo))+clm(index,num1,jlo)*conjg(alm(index,num1))
                          ff = 2*dble(alm(index,num1)*conjg(clm(index,num1,jlo)))
                          sm1 = sm1 + ff * PI12lo(jlo,L)
                          sm2 = sm2 + ff * PI12lo(jlo,L)
                          !! 2,3 and 3,2
                          !ff = blm(index,num1)*conjg(clm(index,num1,jlo))+clm(index,num1,jlo)*conjg(blm(index,num1))
                          ff = 2*dble(blm(index,num1)*conjg(clm(index,num1,jlo)))
                          sm1 = sm1 + ff * PE12lo(jlo,L)
                          sm2 = sm2 + ff * 0.0
                       ENDIF
                    ENDDO
                    !! 3,3
                    DO jlo=1,ilo(l)
                       DO jlop=1,ilo(l)
                          IF(loor(jlo,l).AND.loor(jlop,l)) THEN
                             !ff = 0.5*( clm(index,num1,jlo)*conjg(clm(index,num1,jlop))+clm(index,num1,jlop)*conjg(clm(index,num1,jlo)))
                             ff = dble(clm(index,num1,jlo)*conjg(clm(index,num1,jlop)))
                             sm1 = sm1 + ff * PR12lo(jlo,jlop,L)
                             sm2 = sm2 + ff * PI12lo(jlo,L) * PI12lo(jlop,L)
                          ENDIF
                       ENDDO
                    ENDDO
                    
                    dff=0.0
                    if (abs(sm2)>0.0) dff = sqrt(abs(sm1/sm2))
                 endif
                 ! Common part for projection-1 and Projecttion-2
                 ! 1,1
                 cc = alm(index,num1)
                 ! 1,3
                 DO jlo=1,ilo(l)
                    IF(loor(jlo,l)) THEN
                       cc = cc + clm(index,num1,jlo)*PI12lo(jlo,L)
                    ENDIF
                 ENDDO

                 URx(num1-DM_nemin+1,ind,iorb) = cc * dff
              enddo
           enddo
        enddo
     enddo !----------- over both spins ---------!
  ENDDO    !----------- over all atoms  ---------!


  !nbands = DM_nemax-DM_nemin+1
  !allocate( DMFTU(nbands,maxdim2,norbitals) )
  DMFTU = 0
  DO iorb1=1,norbitals
     icix = cix_orb(iorb1)
     if (icix.EQ.0) CYCLE
     nind1 = nindo(iorb1)
     DO iorb2=1,norbitals
        if ( cix_orb(iorb2).NE. icix ) CYCLE
        nind2 = nindo(iorb2)

        call zgemm('N','C', nbands, nind2, nind1, (1.d0,0.d0), URx(:,:,iorb1), nbands, cfX(:,:,iorb2,iorb1),maxdim2, (0.d0,0.d0), tmp,nbands)
        DMFTU(:,:nind2,iorb2) = DMFTU(:,:nind2,iorb2) + conjg(tmp(:,:nind2))
     ENDDO
  ENDDO

  DEALLOCATE( alm0, blm0 )
  DEALLOCATE( URx, tmp )

END SUBROUTINE Build_DMFT_Projection


SUBROUTINE DMFT_WEIGHTS(zw2, Aweight, nbands, debug)
  IMPLICIT NONE
  REAL*8,     intent(out)  :: zw2(nbands)
  COMPLEX*16, intent(inout):: Aweight(nbands,nbands)
  INTEGER,    intent(in)   :: nbands
  LOGICAL,    intent(in)   :: debug
  ! locals
  INTEGER    :: imx(nbands), timx, i, j, l, n
  INTEGER    :: idxarr(nbands)
  COMPLEX*16 :: zweight(nbands,nbands), tt(nbands), cc
  INTEGER    ::  lwork, lrwork, liwork
  complex*16, allocatable :: work(:)
  real*8,     allocatable :: rwork(:)
  integer,    allocatable :: iwork(:)
  integer :: info
  
  lwork = 2*nbands+nbands*nbands
  lrwork =  5*nbands + 2*nbands*nbands + 1
  liwork = 3+5*nbands
  ALLOCATE ( work(lwork), rwork(lrwork), iwork(liwork) )
     
  ! Aweight = Aw . zw2 . Aw^+
  zweight(:,:) = Aweight(:,:)
  Aweight(:,:) = -Aweight(:,:)

  CALL ZHEEVD('V','U', nbands, Aweight, nbands, zw2, work, lwork, rwork, lrwork, iwork, liwork, info )

  if (info .ne. 0) then
     print *, 'Diagonalization of weights failed. Info-zheevd=', info
  endif
  
  ! We defines zw2 with minus before to sort eigenvalues from largest to smallest
  ! To make them positive, change sign here
  zw2 = -zw2

  CALL eig_order_abs_val(zw2, idxarr, nbands)

  CALL permute_eigensystem1(idxarr, zw2, Aweight, nbands)
     
  ! Sort degenerate eigenvalues to make it similar to identity
  do i=1,nbands
     timx=1
     do l=2,nbands
        if (abs(Aweight(l,i)).gt.abs(Aweight(timx,i))) timx=l
     enddo
     imx(i)=timx
  enddo
  do i=1,nbands
     do j=i+1,nbands
        if (abs(zw2(i)-zw2(j)).LT.1e-9 .and. imx(i).gt.imx(j)) then
           tt(:) = Aweight(:,i)
           Aweight(:,i) = Aweight(:,j)
           Aweight(:,j) = tt(:)
        endif
     enddo
  enddo
  
  if (debug) then
     ! checking exact diagonalization
     do i=1,nbands
        do j=1,nbands
           cc=0
           do n=1,nbands
              cc = cc + Aweight(i,n)*zw2(n)*conjg(Aweight(j,n))
           enddo
           if (abs(zweight(i,j)-cc).GT.1e-8) print *, 'd',i,j,abs(zweight(i,j)-cc)
        enddo
     enddo
  endif
  DEALLOCATE ( work, rwork, iwork )
  
END SUBROUTINE DMFT_WEIGHTS

!---------------------------------------------
! To compute overlap needed by renormalization
!---------------------------------------------
SUBROUTINE cmp_overlap(Olapm, max_nbands, nkpt, nnlo, norbitals, natom, maxdim2, emin, emax, iorbital, cix_orb, iSx, nindo, noccur, cixdim, cfX, sumw, time_dmf0, time_dmf0w)
  USE xa,    ONLY: fj, dfj
  USE xa3,   ONLY: bkx, bky, bkz, bkxlo, bkylo, bkzlo, kx, ky, kz, kxlo, kylo, kzlo, As, As_lo
  USE param, ONLY: lmax2, nume, nmat, nloat, iblock
  USE struk, ONLY: rmt
  USE com,   ONLY: nat
  USE defs,  ONLY: PI, IMAG
  USE dmf,   ONLY: DM_Emin, DM_Emax, DM_EF, maxsize, iso, ncix, Sigind, iSx, cix, csize, ll, nl, maxdim
  USE com_mpi,ONLY: nprocs, myrank, master, FilenameMPI, Reduce_MPI, FindMax_MPI, cpuID, reduce_MPI0
  IMPLICIT NONE
  COMPLEX*16, intent(out):: Olapm(maxdim,maxdim,ncix)
  INTEGER,    intent(out):: max_nbands
  REAL*8,     intent(out):: time_dmf0, time_dmf0w
  INTEGER,    intent(in) :: nkpt, nnlo, norbitals, natom, maxdim2
  REAL*8,     intent(in) :: emin, emax, sumw
  INTEGER,    intent(in) :: iorbital(natom,lmax2+1), cix_orb(norbitals), iSx(maxdim2, norbitals), nindo(norbitals), noccur(maxsize,ncix), cixdim(ncix)
  complex*16, intent(in) :: cfX(maxdim2,maxdim2,norbitals,norbitals)
  ! locals
  COMPLEX*16 :: alm((lmax2+1)*(lmax2+1),nume),blm((lmax2+1)*(lmax2+1),nume),clm((lmax2+1)*(lmax2+1),nume,nloat)
  complex*16 :: h_yl((LMAX2+1)*(LMAX2+1),iblock), h_alyl((LMAX2+1)*(LMAX2+1),iblock), h_blyl((LMAX2+1)*(LMAX2+1),iblock)
  complex*16, ALLOCATABLE :: DMFTU(:,:,:), Olapmk(:,:,:), olp(:,:)
  INTEGER    :: ikp, nemin, nemax, DM_nemin, DM_nemax, n0, num
  REAL*8     :: E(nume), wgh(nkpt), emist, Olapc(maxsize,ncix)
  LOGICAL    :: more_kpoints, Tcompute
  INTEGER    :: jatom, isize, nbands, itape, is, i, iorb1, iorb2, icix, nind1, nind2, ind1, ind2, cixdm, ip, iq, it, iikp, pr_proc
  REAL*8     :: t1c, t2c, t1w, t2w

  DO is=1,iso
     itape=8+is
     rewind(itape)
     do i=1,nat
        read(itape) emist
        read(itape) emist
     enddo
  ENDDO

  allocate( Olapmk(maxdim,maxdim,ncix), olp(maxdim2,maxdim2) )
  Olapm=0

  call cputim(t1c)
  call walltim(t1w)
  
  pr_proc  = floor((nkpt-1)/DBLE(nprocs)+0.999)  ! The maximum number of points calculated per processor
  WRITE(6,'(A,I3,2x,A,I3)') 'pr_proc=', pr_proc, 'tot-k=', nkpt-1
  !print *, 'pr_proc=', pr_proc, 'myrank=', myrank, 'nprocs=', nprocs, 'nkpt=', nkpt
 
  max_nbands=0
  DO ikp=1,nkpt ! kpoint loop begin

     iikp = ikp-myrank*pr_proc            ! The index of the point to compute. If negative, do not compute!                                                                                  
     if (iikp.GT.pr_proc) EXIT            ! Processor finished. The rest of the points will be taken care of by the other processors.                                                        
     Tcompute=.FALSE.                                                                                                                                                                        
     if (iikp.gt.0) Tcompute=.TRUE.       ! If Tcompute is true, the point needs to be computed.                                                                                             
 

     CALL Read_Vec_Spin(ikp, E, wgh(ikp), As, As_lo, kx, ky, kz, kxlo, kylo, kzlo, bkx, bky, bkz, bkxlo, bkylo, bkzlo, nemin, nemax, DM_nemin, DM_nemax, more_kpoints, n0, emin, emax, DM_Emin, DM_Emax, iso, nmat, nume, nnlo)

     nbands = DM_nemax-DM_nemin+1
     max_nbands = max(nbands, max_nbands)

     IF (.NOT.Tcompute) CYCLE                                                                                                                                                                
     IF (.NOT.more_kpoints) EXIT                                                                                                                                                              
     
     do jatom=1,nat
        isize=n0-nnlo
        CALL HARMON(isize,bkx,bky,bkz,lmax2,fj(:,:,jatom),dfj(:,:,jatom),rmt(jatom))
     enddo
     
     allocate( DMFTU(nbands,maxdim2,norbitals) )
     CALL Build_DMFT_Projection(DMFTU, alm, blm, clm, h_yl, h_alyl, h_blyl, cfX, iorbital, norbitals, n0, nnlo, nbands, cix_orb, nindo, DM_nemin, DM_nemax, maxdim2)


     Olapmk=0
     DO iorb1=1,norbitals
        icix = cix_orb(iorb1)
        if ( icix.EQ.0 ) CYCLE
        nind1 = nindo(iorb1)
        DO iorb2=1,norbitals
           if ( icix.NE.cix_orb(iorb2) ) CYCLE
           nind2 = nindo(iorb2)
           olp=0
           call zgemm('C','N', nind1, nind2, nbands, (1.d0,0.d0), DMFTU(:,:,iorb1),nbands, DMFTU(:,:,iorb2),nbands, (0.d0,0.d0), olp,maxdim2)
           do ind1=1,nind1
              do ind2=1,nind2
                 Olapmk( iSx(ind1,iorb1), iSx(ind2,iorb2), icix ) = olp(ind1,ind2)
              enddo
           enddo
                    
        enddo
     ENDDO
     Olapm(:,:,:) = Olapm(:,:,:) + Olapmk(:,:,:) * (wgh(ikp)/sumw) ! proper weight for the reducible k-point
     deallocate( DMFTU )
     WRITE(*,'(I3,A,1x,I3,1x,I3,1x,A,I4)') myrank, ') Finished k-point number', ikp, iikp, 'with #bands=', nbands
  ENDDO         ! kpoint loop ends
  
  CALL Reduce_MPI0(Olapm, maxdim, ncix, max_nbands)
  
  deallocate( olapmk, olp )
  
  Olapc=0
  DO icix=1,ncix
     cixdm = cixdim(icix)
     !---- Olap to vector form, and s_oo to matrix form
     DO ip=1,cixdm
        do iq=1,cixdm
           it = Sigind(ip,iq,icix)
           if (it.gt.0) then
              Olapc(it, icix) =  Olapc(it, icix) + dble(Olapm(ip,iq,icix))
           endif
        enddo
     ENDDO
     DO it=1,csize(icix)
        Olapc(it, icix) = Olapc(it, icix)/noccur(it,icix)
     ENDDO
  ENDDO

  call cputim(t2c)
  call walltim(t2w)
  time_dmf0 = t2c-t1c
  time_dmf0w= t2w-t1w
  
  WRITE(*,*) 'Renormalizing Gloc to account for the interstitials'
  WRITE(*,*) 'Z due to missing-interstitials=', Olapc
  
END SUBROUTINE cmp_overlap

!------------------------------------------------------
! To renormalize the DMFT transformation
!------------------------------------------------------
SUBROUTINE RenormalizeTrans(DMFTU, Olapm0, cix_orb, nindo, iSx, nbands, maxdim2, norbitals, maxdim, ncix)
  IMPLICIT NONE
  COMPLEX*16, intent(inout) :: DMFTU(nbands,maxdim2,norbitals)
  COMPLEX*16, intent(in)    :: Olapm0(maxdim,maxdim,ncix)
  INTEGER, intent(in)       :: cix_orb(norbitals), nindo(norbitals), iSx(maxdim2,norbitals)
  INTEGER, intent(in)       :: nbands, maxdim2, norbitals, maxdim, ncix
  ! locals
  INTEGER :: iorb1, icix, nind1, ind1
  REAL*8  :: olocef

  DO iorb1=1,norbitals
     icix = cix_orb(iorb1)
     if ( icix.EQ.0 ) CYCLE
     nind1 = nindo(iorb1)
     
     do ind1=1,nind1
        olocef = 1/sqrt(real(Olapm0( iSx(ind1,iorb1), iSx(ind1,iorb1), icix )))
        DMFTU(:,ind1,iorb1) = DMFTU(:,ind1,iorb1) * olocef
     enddo
     
  ENDDO
END SUBROUTINE RenormalizeTrans

!!--------------------------------------------------------
!! For determining the chemical potential
!!--------------------------------------------------------
!MODULE muzero
!  REAL*8                :: w_sum, w_gamma, w_norm1, w_beta
!  INTEGER               :: w_nomega, w_npomega
!  INTEGER               :: n0_om, nkp, max_nbands
!  LOGICAL               :: wprint, wmatsubara, wprint1
!  REAL*8,    ALLOCATABLE:: Ek(:,:), wgh(:)
!  COMPLEX*16,ALLOCATABLE:: zEk(:,:,:)
!  INTEGER,   ALLOCATABLE:: nemm(:,:)
!  REAL*8,   ALLOCATABLE :: abom(:,:), w_omega(:)
!  INTEGER,  ALLOCATABLE :: nomq(:), iomq(:,:), jomq(:)
!  REAL*8,   ALLOCATABLE :: womq(:,:)
!  !
!CONTAINS
!  
!  SUBROUTINE init_muzero(nomega, qmax)
!    INTEGER, intent(in) :: nomega, qmax
!    ALLOCATE( nomq(nomega), jomq(nomega), iomq(nomega,qmax), womq(nomega,qmax), w_omega(nomega) )
!    ALLOCATE( abom(2,nomega) )
!    wprint1=.FALSE.
!  END SUBROUTINE init_muzero
!  SUBROUTINE fini_muzero()
!    DEALLOCATE( abom )
!    DEALLOCATE( nomq, jomq, iomq, womq, w_omega )
!  END SUBROUTINE fini_muzero
!
!END MODULE muzero

REAL*8 FUNCTION ferm(x)
  IMPLICIT NONE
  REAL*8, intent(in) :: x
  !print *, 'ferm', x
  if (x.LT.-100.) then
     ferm = 1.0
     RETURN
  endif
  if (x.GT.100.) then
     ferm = 0.0
     RETURN
  endif
  ferm = 1/(exp(x)+1)
  !print *, 'ferm(x)=', ferm
  RETURN
END FUNCTION ferm

REAL*8 FUNCTION Density(EF)
  USE defs, ONLY: PI, IMAG
  USE com,  ONLY: elecn
  USE muzero,ONLY: w_sum, w_gamma, w_norm1, nkp, w_nomega, w_npomega, Ek, wgh, abom, zEk, nemm, wprint, wmatsubara, n0_om, w_omega, jomq, nomq, iomq, w_beta, womq, wprint, wprint1, Qcheckbands
  IMPLICIT NONE
  REAL*8, intent(in)    :: EF
  ! functions
  REAL*8 :: ferm
  ! locals
  real*8, PARAMETER       :: Ry2eV = 13.60569193
  REAL*8    :: cc, zw0, wkp, dE, ek0, Om, drest, ci 
  INTEGER   :: ikp, num, num0, iom, nemin, DM_nemin, DM_nemax, j0, j1, j2, i
  COMPLEX*16:: cE, ccn, cek, e0, e1, e2, ca, cb, omn, csum1, csum

  IF (wmatsubara) THEN
     if (wprint1) WRITE(*,'(A2,1x,A2,1x,A4,1x,A4,1x,A4,1x,A14,1x,A40,1x,A20,1x,A20)') 'ik','i','iom','j1','iomq','omn', 'cek', '1./(omn-cek)', 'dsum'
     zw0=0

     do ikp=1,nkp
        nemin    = nemm(1,ikp)
        DM_nemin = nemm(2,ikp)
        DM_nemax = nemm(3,ikp)
        wkp = (wgh(ikp)/w_sum*2.0)*w_norm1
        if (DM_nemin.GT.nemin) zw0 = zw0 + wkp*(DM_nemin-nemin) ! These bands are fully filled
        
        cc=0
        DO num=DM_nemin,DM_nemax
           num0 = num-DM_nemin+1
           ek0 = dble(zEk(num0,w_nomega,ikp))-EF
           csum1=0
           csum=0
           do iom=1,n0_om-1
              cek = zEk(num0,iom,ikp)-EF
              omn = dcmplx(0, w_omega(iom) )
              csum1 = csum1 + 1./(omn-cek) - 1./(omn-ek0)
              if (wprint1) WRITE(*,'(I2,1x,I2,1x,I4,1x,I4,1x,I4,1x,f14.10,1x,2f20.15,1x,f20.15,1x,f20.15)') ikp,num,iom,iom, iom, aimag(omn), cek, dble(1./(omn-cek)-1./(omn-ek0)), dble(csum1)
           enddo
           
           do iom=n0_om,w_nomega-1
              j0 = jomq(iom-1)
              j1 = jomq(iom)
              j2 = jomq(iom+1)
              e0 = zEk(num0,iom-1,ikp)-EF
              e1 = zEk(num0,iom,  ikp)-EF
              e2 = zEk(num0,iom+1,ikp)-EF
              do i=1,nomq(iom)
                 omn = dcmplx(0, (2*iomq(iom,i)-1)*pi/w_beta)
                 if (iomq(iom,i).LT.j1) then
                    cek = e1 + (e0-e1)*(iomq(iom,i)-j1)/(j0-j1)
                 else if (iomq(iom,i).GT.j1) then
                    cek = e1 + (e2-e1)*(iomq(iom,i)-j1)/(j2-j1)
                 else
                    cek = e1
                 endif
                 csum = csum + womq(iom,i)*(1./(omn-cek) - 1./(omn-ek0))
                 if (wprint1) WRITE(*,'(I2,1x,I2,1x,I4,1x,I4,1x,I4,1x,f14.10,1x,2f20.15,1x,f20.15,1x,f20.15)') ikp,num,iom,j1,iomq(iom,i),aimag(omn), cek, dble(womq(iom,i)*(1./(omn-cek) - 1/(omn-ek0))), dble(csum)
              enddo
           enddo
           iom = w_nomega
           j0 = jomq(iom-1)
           j1 = jomq(iom)
           e0 = zEk(num0,iom-1,ikp)-EF
           e1 = zEk(num0,iom,  ikp)-EF
           do i=1,nomq(iom)
              omn = dcmplx(0, (2*iomq(iom,i)-1)*pi/w_beta)
              cek = e1 + (e0-e1)*(iomq(iom,i)-j1)/(j0-j1)
              csum = csum + womq(iom,i)*(1./(omn-cek) - 1./(omn-ek0))
              if (wprint1) WRITE(*,'(I2,1x,I2,1x,I4,1x,I4,1x,I4,1x,f14.10,1x,2f20.15,1x,f20.15,1x,f20.15)') ikp,num,iom,j1,iomq(iom,i),aimag(omn), cek, dble(1./(omn-cek)), dble(csum)
           enddo
        
           Om = (2*jomq(w_nomega)*pi/w_beta)
           drest = (atan(ek0/Om)-atan(dble(cek)/Om))/pi
           ci = 2*dble(csum+csum1)/w_beta + drest + ferm(ek0*w_beta)
        
           if (Qcheckbands) then
              if (ci.GT.1.0) ci=1.0
              if (ci.LT.0.0) ci=0.0
           endif
           cc = cc + ci
        ENDDO
        zw0 = zw0 + wkp * cc
     enddo
     
  ELSE
     zw0=0
     do ikp=1,nkp
        nemin    = nemm(1,ikp)
        DM_nemin = nemm(2,ikp)
        DM_nemax = nemm(3,ikp)
        wkp = (wgh(ikp)/w_sum*2.0)*w_norm1
        !DO num=nemin,DM_nemin-1
        !   do iom=1,w_npomega
        !      ca = dcmplx(abom(1,iom),w_gamma)
        !      cb = dcmplx(abom(2,iom),w_gamma)
        !      dE = Ek(num,ikp)
        !      cc = log(cb+EF-dE)-log(ca+EF-dE)
        !      zw0 = zw0 - wkp * real((cc - conjg(cc))/(2*pi*IMAG))
        !   enddo
        !ENDDO
        if (DM_nemin.GT.nemin) zw0 = zw0 + wkp*(DM_nemin-nemin) ! These bands are fully filled
        DO num=DM_nemin,DM_nemax
           do iom=1,w_npomega
              ca = dcmplx(abom(1,iom),w_gamma)
              cb = dcmplx(abom(2,iom),w_gamma)

              !print *, 'need zEk of ', num-DM_nemin+1, ikp
              cE = zEk(num-DM_nemin+1,iom,ikp)
              ccn = log(cb+EF-cE)-log(ca+EF-cE)
              zw0 = zw0 - wkp * dble((ccn - conjg(ccn))/(2*pi*IMAG))
           enddo
        ENDDO
     enddo
  ENDIF
  if (wprint) print *, 'EF', EF*Ry2eV, 'Density=', zw0
  Density = zw0-elecn
  RETURN
END FUNCTION Density

SUBROUTINE cmp_EF(EF, recomputeEF, wmax_nbands, Olapm, omega, sigma, nkpt, nnlo, norbitals, natom, maxdim2, nomega, npomega, emin, emax, iorbital, cix_orb, iSx, nindo, noccur, cixdim, cfX, sumw, wgamma, beta, vnorm1, LowE, time_dmf0, time_dmf0w)
  USE xa,    ONLY: fj, dfj
  USE xa3,   ONLY: bkx, bky, bkz, bkxlo, bkylo, bkzlo, kx, ky, kz, kxlo, kylo, kzlo, As, As_lo
  USE param, ONLY: lmax2, nume, nmat, nloat, iblock
  USE struk, ONLY: rmt
  USE com,   ONLY: nat, elecn
  USE defs,  ONLY: PI, IMAG
  USE dmf,   ONLY: DM_Emin, DM_Emax, DM_EF, maxsize, iso, ncix, Sigind, iSx, cix, csize, ll, nl, maxdim, Qrenormalize, matsubara, mixEF
  USE muzero,ONLY: w_sum, w_gamma, w_norm1, nkp, w_nomega, w_npomega, Ek, wgh, zEk, nemm, wprint, w_beta, w_omega, wmatsubara, wprint1, max_nbands, Qcheckbands
  USE com_mpi
  IMPLICIT NONE
  COMPLEX*16, intent(in) :: Olapm(maxdim,maxdim,ncix)
  INTEGER, intent(in)    :: recomputeEF
  INTEGER, intent(inout) :: wmax_nbands
  REAL*8, intent(out)    :: EF, time_dmf0, time_dmf0w
  REAL*8, intent(in)     :: omega(nomega)
  COMPLEX*16, intent(in) :: sigma(maxsize,ncix,nomega)
  INTEGER, intent(in)    :: nkpt, nnlo, norbitals, natom, maxdim2, nomega, npomega
  REAL*8, intent(in)     :: emin, emax, sumw, wgamma, beta, vnorm1
  INTEGER, intent(in)    :: iorbital(natom,lmax2+1), cix_orb(norbitals), iSx(maxdim2, norbitals), nindo(norbitals), noccur(maxsize,ncix), cixdim(ncix)
  complex*16, intent(in) :: cfX(maxdim2,maxdim2,norbitals,norbitals)
  REAL*8, intent(in)     :: LowE(5,maxsize,ncix)
  !
  REAL*8 :: Density
  ! locals
  real*8, PARAMETER       :: Ry2eV = 13.60569193
  COMPLEX*16 :: alm((lmax2+1)*(lmax2+1),nume),blm((lmax2+1)*(lmax2+1),nume),clm((lmax2+1)*(lmax2+1),nume,nloat)
  complex*16 :: h_yl((LMAX2+1)*(LMAX2+1),iblock), h_alyl((LMAX2+1)*(LMAX2+1),iblock), h_blyl((LMAX2+1)*(LMAX2+1),iblock)
  complex*16, ALLOCATABLE :: DMFTU(:,:,:), STrans(:,:,:,:), Eij(:,:), zw1(:), tzek(:)
  INTEGER    :: ikp, nemin, nemax, DM_nemin, DM_nemax, n0, num
  REAL*8     :: E(nume), emist 
  COMPLEX*16 :: cc, cE, ca, cb, gtot(nomega)
  LOGICAL    :: more_kpoints, Tcompute
  INTEGER    :: jatom, isize, nbands, itape, is, i, iorb, icix, ip, iq, it, iom, itmax, fh_EF, pr_proc, iikp, ind, iband, j
  REAL*8     :: tEF, t1c, t2c, t1w, t2w, dd, dEF, Ea, Eb, fatol, xatol, xrtol, twgh, dsm, wkp, zw0, EFnew
  LOGICAL    :: Need_EF_update
  INTEGER, ALLOCATABLE :: indHa(:,:)
  INTEGER    :: dNHa, ncandidates
  COMPLEX*16, ALLOCATABLE :: Ha(:,:)
  INTEGER    ::  lwork, lrwork, liwork, lhda
  complex*16, allocatable :: work(:)
  real*8,     allocatable :: rwork(:), Ebnd(:), weib(:), wg_bnd(:), Ebmin(:), Ebmax(:), candidate(:,:)
  integer,    allocatable :: iwork(:)
  integer :: info, icn
  COMPLEX*16  :: soo(maxsize,ncix)
  REAL*8, PARAMETER :: small_density_mismatch = 1.0
  
  if (recomputeEF.gt.1) then
     soo(:,:) = LowE(5,:,:)  ! self-energy at zero frequency
     ! Will use a quasiparticle approximation for Mott insulators 
     ! to compute the chemical potential for insulators!
     ALLOCATE( indHa(maxdim*ncix,5) )
     dNHa=0 ! Number of poles which will be added
     DO iorb=1,norbitals
        icix = cix_orb(iorb)
        if (icix.EQ.0) CYCLE
        do ind=1,nindo(iorb)
           ip = iSx(ind,iorb)
           it = Sigind(ip,ip,icix)
           if (it.gt.0 .and. abs(LowE(1,it,icix)-1.0).LT.1e-6) then
              dNHa = dNHa + 1
              indHa(dNHa,1) = ip
              indHa(dNHa,2) = ind
              indHa(dNHa,3) = iorb
              indHa(dNHa,4) = icix
              !WRITE(*,'(A,I2,1x,A,I2,1x,A,I2,1x,A,I2,1x,A,I2,1x,A,I2)') 'iorb=', iorb, 'icix=', icix, 'ind=', ind, 'ip=', ip, 'it=', it, 'dNHa=', dNHa
           endif
        ENDDO
     ENDDO
  endif
  
  Qcheckbands=.TRUE.
  def = 0.02
  itmax = 500
  fatol = 1e-10
  xatol = 1e-10
  xrtol = 1e-10
  
  if (wmax_nbands.EQ.0) then
     itape=9
     rewind(itape)
     do i=1,nat
        read(itape) emist
        read(itape) emist
     enddo
     DO ikp=1,nkpt ! kpoint loop begin
        CALL Read_Vec_Spin_DontStore(nemin, DM_nemin, DM_nemax, more_kpoints, n0)
        IF (.NOT.more_kpoints) EXIT
        wmax_nbands = max(DM_nemax-DM_nemin+1, wmax_nbands)
     ENDDO
  endif
  max_nbands=wmax_nbands
  
  !print *, 'MAX_NBANDS=', max_nbands

  if (recomputeEF.gt.1) then
     lhda = max_nbands+dNHa
     ALLOCATE( Ha(lhda,lhda) )
     ALLOCATE( Ebnd(lhda), weib(nume+dNHa), wg_bnd(lhda), Ebmin(nume+dNHa), Ebmax(nume+dNHa) )
  
     lwork = 2*lhda+lhda*lhda
     lrwork =  5*lhda + 2*lhda*lhda + 1
     liwork = 3+5*lhda
     ALLOCATE ( work(lwork), rwork(lrwork), iwork(liwork) )
  endif

  w_sum = sumw; w_gamma = wgamma; w_norm1 = vnorm1
  w_nomega = nomega; w_npomega = npomega; w_beta=beta
  w_omega(:) = omega(:)

  DO is=1,iso
     itape=8+is
     rewind(itape)
     do i=1,nat
        read(itape) emist
        read(itape) emist
     enddo
  ENDDO

  call cputim(t1c)
  call walltim(t1w)

  pr_proc  = floor((nkpt-1)/DBLE(nprocs)+0.999)  ! The maximum number of points calculated per processor
  WRITE(6,'(A,I3,2x,A,I3)') 'pr_proc=', pr_proc, 'tot-k=', nkpt-1
  !print *, 'pr_proc=', pr_proc, 'myrank=', myrank, 'nprocs=', nprocs, 'nkpt=', nkpt


  ! Ek, zEk, nemm
  ALLOCATE( wgh(pr_proc), Ek(nume,pr_proc), zEk(max_nbands,nomega,pr_proc), nemm(3,pr_proc) )
  wprint = .TRUE.
  
  Ek(:,:) = 0.0
  zEk(:,:,:) = 0.0
  wgh(:) = 0

  if (recomputeEF.gt.1) then
     weib(:) = 0
     Ebmin(:) = 1e10
     Ebmax(:) = -1e10
     gtot=0
  endif

  nkp=0
  DO ikp=1,nkpt ! kpoint loop begin

     iikp = ikp-myrank*pr_proc            ! The index of the point to compute. If negative, do not compute!                                                                                  
     if (iikp.GT.pr_proc) EXIT            ! Processor finished. The rest of the points will be taken care of by the other processors.                                                        
     Tcompute=.FALSE.                                                                                                                                                                        
     if (iikp.gt.0) Tcompute=.TRUE.       ! If Tcompute is true, the point needs to be computed.
 
     CALL Read_Vec_Spin(ikp, E, twgh, As, As_lo, kx, ky, kz, kxlo, kylo, kzlo, bkx, bky, bkz, bkxlo, bkylo, bkzlo, nemin, nemax, DM_nemin, DM_nemax, more_kpoints, n0, emin, emax, DM_Emin, DM_Emax, iso, nmat, nume, nnlo)
     IF (.NOT.Tcompute) CYCLE
     IF (.NOT.more_kpoints) EXIT
     
     wgh(iikp) = twgh
     do jatom=1,nat
        isize=n0-nnlo
        CALL HARMON(isize,bkx,bky,bkz,lmax2,fj(:,:,jatom),dfj(:,:,jatom),rmt(jatom))
     enddo

     nbands = DM_nemax-DM_nemin+1
     allocate( DMFTU(nbands,maxdim2,norbitals) )
     CALL Build_DMFT_Projection(DMFTU, alm, blm, clm, h_yl, h_alyl, h_blyl, cfX, iorbital, norbitals, n0, nnlo, nbands, cix_orb, nindo, DM_nemin, DM_nemax, maxdim2)

     if (Qrenormalize) CALL RenormalizeTrans(DMFTU, Olapm, cix_orb, nindo, iSx, nbands, maxdim2, norbitals, maxdim, ncix)
     
     allocate( STrans(maxsize,ncix,nbands,nbands) )
     CALL CompressSigmaTransformation2(STrans, DMFTU, Sigind, iSx, cix, csize, iorbital, ll, nl, natom, iso, ncix, maxdim, maxdim2, lmax2, norbitals, nbands, maxsize)
     
     allocate( Eij(nbands,nbands) )

     if (recomputeEF.gt.1) then

        ! Using pole approximation for the self-energy and the trick described in 
        ! PRL 96, 036404 (2006)
        ! to obtain good approximation for the chemical potential. 
        ! 
        Eij=0
        DO iband=1,nbands
           Eij(iband,iband) = E(iband+DM_nemin-1)  !---   preparing hamiltonian: epsk+sigma
        ENDDO
        CALL AddSigma_optimized2(Eij, soo, STrans, csize, 1, nbands, ncix, maxsize)
        Ha=0
        Ha(:nbands,:nbands) = Eij(:,:)
        DO i=1,dNHa
           ip  = indHa(i,1)
           ind = indHa(i,2)
           iorb = indHa(i,3)
           icix = indHa(i,4)
           it = Sigind(ip,ip,icix)
           do iband=1,nbands
              Ha(iband,nbands+i) = DMFTU(iband,ind,iorb)*sqrt(LowE(2,it,icix))
              Ha(nbands+i,iband) = conjg(DMFTU(iband,ind,iorb))*sqrt(LowE(2,it,icix))
           enddo
        ENDDO
        DO i=1,dNHa
           ip  = indHa(i,1)
           ind = indHa(i,2)
           iorb = indHa(i,3)
           icix = indHa(i,4)
           it = Sigind(ip,ip,icix)
           Ha(nbands+i,nbands+i) = LowE(3,it,icix)+DM_EF
        ENDDO
        
        CALL ZHEEVD('V','U', nbands+dNHa, Ha, lhda, Ebnd, work, lwork, rwork, lrwork, iwork, liwork, info )
        if (info .ne. 0) then
           print *, 'Diagonalization of extended Hamiltonian in computing EF failed. Info-zheevd=', info
        endif

        wkp = (twgh/w_sum*2.0)*w_norm1
        zw0=0
        do i=1,DM_nemin-1 ! Fully filled bands not treated by DMFT
           zw0 = zw0+1.
           weib(i) = weib(i)+ zw0*wkp
           if (E(i).GT.Ebmax(i)) Ebmax(i) = E(i)
           if (E(i).LT.Ebmin(i)) Ebmin(i) = E(i)
           !WRITE(*,'(I3,1x,F12.7,1x,F10.7,1x,F10.7,1x,F10.7)') i, E(i)*Ry2eV, 1., zw0, weib(i)
        enddo
        DO i=1,nbands+dNHa ! Bands treated by DMFT
           dsm=0.0
           DO iband=1,nbands
              dsm = dsm + abs(Ha(iband,i))**2 ! DMFT bands carry a fractional charge
           ENDDO
           wg_bnd(i) = dsm  ! The fractional charge of Mott-bands
           zw0 = zw0 + dsm  ! The total weight up to this band
           weib(DM_nemin-1+i) = weib(DM_nemin-1+i) + zw0*wkp  ! storing the total weight (summed ove k) up to this band
           if (Ebnd(i).GT.Ebmax(DM_nemin-1+i)) Ebmax(DM_nemin-1+i) = Ebnd(i)  ! Useful to estimate the gap
           if (Ebnd(i).LT.Ebmin(DM_nemin-1+i)) Ebmin(DM_nemin-1+i) = Ebnd(i)  ! Useful to estimate the gap
           !WRITE(*,'(I3,1x,F12.7,1x,F10.7,1x,F10.7,1x,F10.7)') i+DM_nemin-1, Ebnd(i)*Ry2eV, dsm, zw0, weib(DM_nemin-1+i)
        ENDDO
        
        !DO iom=1,nomega
        !   ! Computing the total Green's function using the quasiparticle approximation.
        !   ! This is just for debugging purposes to compare it to the actual Green's function.
        !   DO i=1,nbands+dNHa
        !      gtot(iom) = gtot(iom) + wkp*wg_bnd(i)/(omega(iom)*IMAG+DM_EF-Ebnd(i) + IMAG*wgamma)
        !   ENDDO
        !   ! The rest of the bands added to total g!
        !   DO i=1,DM_nemin-1 
        !      gtot(iom) = gtot(iom) + wkp/(omega(iom)*IMAG+DM_EF-E(i) + IMAG*wgamma*5)
        !   ENDDO
        !   DO i=DM_nemax+1,nume
        !      gtot(iom) = gtot(iom) + wkp/(omega(iom)*IMAG+DM_EF-E(i) + IMAG*wgamma*5)
        !   ENDDO
        !ENDDO
     endif
     
     deallocate( DMFTU )
     allocate( zw1(nbands), tzek(nbands) )

     do iom=1,npomega
        Eij=0
        DO i=1,nbands
           Eij(i,i) = E(i+DM_nemin-1)  !---   preparing hamiltonian: epsk+sigma
        ENDDO
        ! Adding self-energy
        CALL AddSigma_optimized2(Eij, sigma(:,:,iom), STrans, csize, 1, nbands, ncix, maxsize)
        CALL eigvals(Eij, tzek, nbands)
        zEk(:nbands,iom,iikp) = tzek(:)
     enddo
     DEALLOCATE( Eij, zw1, tzek )

     nemm(1,iikp) = nemin
     nemm(2,iikp) = DM_nemin
     nemm(3,iikp) = DM_nemax
     Ek(:,iikp) = E(:)
     
     DEALLOCATE( STrans )
     WRITE(*,'(I3,A,1x,I3,1x,I3,1x,A,I4)') myrank, ') Finished k-point number', ikp, iikp, 'with #bands=', nbands
     nkp=nkp+1
  ENDDO         ! kpoint loop ends  

  ! Ebmax <- max(Ebmax)
  ! Ebmin <- min(Ebmin)
  ! weib(i) <- sum(weib)
  ! gtot(iom) <- sum(gtot)
        
  CALL Reduce_MPI1(pr_proc, nomega, nume, Ebmax, Ebmin, weib, gtot, nume+dNHa, recomputeEF)


  if (myrank.EQ.master) then
     wmatsubara = matsubara

     Need_EF_update=.True.
     

     if (recomputeEF.gt.1) then
        ! Print g computed by quasiparticle approximation.
        ! Only for debugging purposes.
        !open(599,file='gtot.debug1',status='unknown',form='formatted')
        !DO iom=1,nomega
        !   WRITE(599,*) omega(iom), dble(gtot(iom))/2., aimag(gtot(iom))/2.
        !ENDDO
        !close(599)
        
        wprint=.FALSE.
        print *, 'Weights and bands'
        ncandidates=0
        ALLOCATE(candidate(DM_nemax+dNHa-1,5))
        candidate=0
        DO i=DM_nemin,DM_nemax+dNHa-1
           IF (Ebmax(i).LT.Ebmin(i+1) .AND. abs(weib(i)-elecn)<5.0) THEN ! There is a gap and the density is not crazy!
              ncandidates = ncandidates + 1       ! One more gap. Is this the best gap?
              candidate(ncandidates,1) = 0.5*(Ebmin(i+1)+Ebmax(i)) ! The middle of the gap.
              candidate(ncandidates,2) = Density(candidate(ncandidates,1))  ! Actual density in the middle of the gap
              candidate(ncandidates,3) = weib(i)-elecn ! The estimated density by quasiparticle approximation
              candidate(ncandidates,4) = (Ebmin(i+1)-Ebmax(i)) ! Quasiparticle estimation for the gap size
              WRITE(*,'(I3,1x,F13.7,1x,F13.7,1x,F13.7,2x,A,F8.3,2x,A,F8.3,2x,A,F8.3)') i, Ebmax(i)*Ry2eV, Ebmin(i+1)*Ry2eV, weib(i), 'gap-size=', (Ebmin(i+1)-Ebmax(i))*Ry2eV, 'middle-point=', 0.5*(Ebmin(i+1)+Ebmax(i))*Ry2eV, 'charge-density=', elecn+candidate(ncandidates,2)
           ELSE
              WRITE(*,'(I3,1x,F13.7,1x,F13.7,1x,F13.7)') i, Ebmax(i)*Ry2eV, Ebmin(i+1)*Ry2eV, weib(i)
           ENDIF
        ENDDO
        if (ncandidates.gt.0) then
           ! Which candidate has best density
           IF (recomputeEF.GT.2) THEN ! For recomputeEF=3 we take take the one with density closer to charge neutrality, but density of electrons should larger or equal than required by charge neutrality
              icn=ncandidates
              !DO ip=1,ncandidates ! Finding the best candidate
              !   IF (candidate(ip,2).GE.0.0 ) THEN
              !      icn=ip
              !      EXIT
              !   ENDIF
              !ENDDO
              !DO ip=1,ncandidates ! Finding the best candidate
              !   IF (abs(candidate(ip,2)).LT.abs(candidate(icn,2)) .AND. candidate(ip,2).GE.0.0 ) icn=ip
              !ENDDO
           ELSE  ! For recomputeEF=2 we always take the one with density closer to charge neutrality
              icn=1 
              DO ip=2,ncandidates ! Finding the best candidate
                 IF (abs(candidate(ip,2)).LT.abs(candidate(icn,2))) icn=ip
              ENDDO
           ENDIF
           IF (abs(candidate(icn,2)).LT.small_density_mismatch) THEN ! Tolerable mismatch in density
              tEF = candidate(icn,1)
              Need_EF_update=.False.
              WRITE(*,*) 'Found a quasiparticle-gap. EF is placed in the middle of this gap!'
              WRITE(*,'(A,F13.7,2x,A,F13.7,2x,A,F13.7,2x)') 'Estimated-gap-size=', candidate(icn,4)*Ry2eV, 'mismatch-density-integration=', candidate(icn,2), 'mismatch-density-quasiparticle=', candidate(icn,3)
           ENDIF
        endif
        DEALLOCATE( candidate )
        IF (Need_EF_update) print *, 'Failed to put EF in the gap. Computing EF in the regular way.'
     endif

     if (Need_EF_update) then
        wprint=.TRUE.
        wprint1=.FALSE.
        
        tEF = DM_EF
        dd = Density(tEF)
        if (dd.lt.0) then
           do while (dd.lt.0)
              tEF = tEF + def
              dd = Density(tEF)
           end do
           Ea = tEF-def
           Eb = tEF
        else
           do while (dd.gt.0)
              tEF = tEF - def
              dd = Density(tEF)
           enddo
           Ea = tEF
           Eb = tEF+def
        endif
        wprint = .FALSE.
        CALL brent ( Density, fatol, itmax, Ea, Eb, xatol, xrtol )
        tEF = Ea
     endif

     if (abs(tEF-DM_EF)*Ry2eV .lt. 0.03) then ! If we are close to convergence, we start mixing EF
        EFnew = DM_EF + (tEF-DM_EF)*mixEF !!! mixing
     else ! When EF is changing a lot, one should just take the new EF.
        EFnew = tEF
        WRITE(*,*) 'Difference in EF too large to mix ', (tEF-DM_EF)*Ry2eV, 'cutoff=', 0.03
     endif
     WRITE(*,'(A,f15.10,A,f15.10,A,f15.10)') 'Difference in EF=', (tEF-DM_EF)*Ry2eV, ' EF set to : ', EFnew*Ry2eV, ' new EF (no-mixing): ', tEF*Ry2eV
     WRITE(*,*)
     EF = EFnew
     
     fh_EF=887
     OPEN(fh_EF,file='EF.dat',status='unknown',form='formatted')
     WRITE(fh_EF,'(f25.16)') EF*Ry2eV
     CLOSE(fh_EF)

  endif


  CALL Bcast_MPI(EF)
  
  if (recomputeEF.gt.1) then
     DEALLOCATE( Ha, Ebnd, weib, wg_bnd, Ebmin, Ebmax )
     DEALLOCATE ( work, rwork, iwork )
     DEALLOCATE( indHa )
  endif
  
  DEALLOCATE( wgh, Ek, zEk, nemm )
  call cputim(t2c)
  call walltim(t2w)
  time_dmf0 = t2c-t1c
  time_dmf0w= t2w-t1w

END SUBROUTINE cmp_EF

