SUBROUTINE L2MAIN(cform,nnlo,coord,zz,so,NSPIN1,vresp_write,sumw,nwave,recomputeEF,TCLM,TCLM_w,TFOUR,TFOUR_w)
  USE defs,  ONLY: PI, ZERO, TWO, ZEROC, IMAG
  USE param, ONLY: IBLOCK, LMAX2, LOMAX, NCOM, NLOAT, NRAD, NGAU, NMAT, NUME, NSYM, NKPT, fh_vec
  USE atspdt,ONLY: EL, P, DP, PE, DPE, PEI, e_store
  USE char,  ONLY: modus
  USE com,   ONLY: rel, NSPIN, NAT, NBAND, NK, MINWAV, MAXWAV, NB, EMIN, EF, ELECN, XWT, weigh, elecn
  USE charp, ONLY: init_charp, zero_charp, fini_charp
  USE chard, ONLY: init_chard, zero_chard, fini_chard
  USE charf, ONLY: init_charf, zero_charf, fini_charf
  USE lo,    ONLY: loor, lapw, nlo, nlov, nlon, ilo, a1lo, b1lo, elo_store, alo, blo, clo, pi12lo, pe12lo, pr12lo
  USE lohelp,ONLY: u21, ue21, u12, ue12, u22, init_lohelp, zerotc_lohelp, fini_lohelp, sum12, sum21, sum22, sume21, sume12
  USE struk, ONLY: iatnr, mult, isplit, jri, pos, rotij, tauij, rmt, v, rotloc, r0, dx, vol, br1, br2
  USE xa,    ONLY: LM, R, AVEC, BK, BKROT, BKRLOC, fj, dfj, E, WEIGHT, TC100, TCA100, TCB100, init_xa, fini_xa, SUMA, SUMB, SUMAB, SUMBA
  USE xa3,   ONLY: bkx, bky, bkz, bkxlo, bkylo, bkzlo, init_xa3, fini_xa3, kx, ky, kz, kxlo, kylo, kzlo, As, As_lo!, A, A_lo
  USE reclat,ONLY: inst, tauk, kzz
  USE muzero,ONLY: nomq, jomq, iomq, womq, abom, n0_om, init_muzero, fini_muzero
  USE com_mpi,ONLY: nprocs, myrank, master, FilenameMPI, Reduce_MPI, FindMax_MPI, cpuID
  USE w_atpar
  USE dmf
  IMPLICIT NONE
  CHARACTER*4, intent(in)  :: cform
  INTEGER, intent(out)     :: nnlo
  CHARACTER*5, intent(in)  :: coord
  REAL*8, intent(in)       :: ZZ(*), sumw
  LOGICAL, intent(in)      :: SO
  INTEGER, intent(in)      :: NSPIN1, nwave
  LOGICAL, intent(inout)   :: vresp_write
  INTEGER, intent(in)      :: recomputeEF
  REAL*8, intent(out)      :: TCLM,TCLM_w,TFOUR,TFOUR_w
  ! Functions
  INTEGER :: NOTRI
  REAL*8  :: GAUNT
  INTEGER :: CountSelfenergy
  REAL*8  :: ferm
  ! Common blocks
  COMMON /FACT/   FCT(100)
  REAL*8     :: FCT
  COMMON /RADFU/  RRAD1(NRAD,0:LMAX2),RADE1(NRAD,0:LMAX2),RRAD2(NRAD,0:LMAX2),RADE2(NRAD,0:LMAX2)
  REAL*8     :: RRAD1, RADE1, RRAD2, RADE2
  COMMON /UHELP/  UA(NRAD),UB(NRAD),UBA(NRAD),UAB(NRAD)
  REAL*8     :: UA, UB, UBA, UAB
  common /xmean/  xwteh(0:3),xwtel(0:3),xwt1h(0:3),xwt1l(0:3) 
  REAL*8     :: xwteh, xwtel, xwt1h, xwt1l
  common /mkef/delef,ts2
  REAL*8     :: delef, ts2
  ! Locals
  real*8, PARAMETER       :: Ry2eV = 13.60569193
  !
  LOGICAL       :: debug, testLDA
  CHARACTER*10  :: KNAME
  CHARACTER*150 :: parseline
  LOGICAL       :: more_kpoints
  COMPLEX*16    :: YL((LMAX2+1)*(LMAX2+1))
  COMPLEX*16    :: PHSHEL,CFAC,IMAG1
  REAL*8        :: tc_buf(nrad),vtc_buf(nrad)
  CHARACTER*100 :: CDUMMY
  COMPLEX*16    :: cc, gtc, CCC
  INTEGER       :: I, J, N, JK, ISCF, LFIRST, LMX, jatom, ilm1, ilm3, n0, ne, nm
  INTEGER       :: jlm, lmmax, imax, nemin, nemax, DM_nemin, DM_nemax, DM_nemaxx, label, i1
  INTEGER       :: ii, ibb, i3, isize, latom, mu, index, l, m, maxx, lda, ldb, ldc, num, num0, ilm2
  INTEGER       :: jlo, ilm, li, mi, L1, MMAX, LP, LP1, mpmax, jlop, MP, MS, MPS, MTEST, LY, LPY
  REAL*8        :: arg, arg1, arg2, arg3, argt, argt2, emist, fac, rmt2, GNT
  REAL*8        :: TWOPI, TEST1, ETOT, ETOT2, SQRT2, SQRT3, SQFP, Y, CIN, jatombad, lbad
  !
  REAL*8     :: time_bl, time_bl_w, time_reduc, time_reduc_w, time_write, time_writeclm, time_writescf, time4_w, time3, time4
  REAL*8     :: time_write_w, time_writeclm_w, time_ilm, time_ilm_w, time_radprod, time_m, time_rad, time3_w
  REAL*8     :: time_rd_w, time_rd_c, time_atpar_w, time_atpar_c, time_writescf_w, time_r_w, time_r_c, trw, trc
  REAL*8     :: time_writeefg, time_writeeefg_w, time_writeefg_w, t1c, t1w, t2c, t2w, time1, time1_w, time2, time2_w
  REAL*8     :: time_dmf, time_dmfw, time_int, time_intw, time_ed, time_edw, time_dmf0, time_dmf0w, time_dmf1, time_dmf1w
  !
  COMPLEX*16 :: gint, wkp, w0, p_w0
  !COMPLEX*16 :: dh_alm(nume,(LMAX2+1)*(LMAX2+1)), dh_blm(nume,(LMAX2+1)*(LMAX2+1)), dh_clm(nume,(LMAX2+1)*(LMAX2+1),nloat)
  COMPLEX*16 :: tsa, tsb, tsab, tsba, ts12(nloat), tse12(nloat), ts21(nloat), tse21(nloat), ts22(nloat,nloat)
  COMPLEX*16 :: tsuma,tsumb,tsumab,tsumba,tsum21(nloat),tsume21(nloat),tsum12(nloat),tsume12(nloat),tsum22(nloat,nloat)
  COMPLEX*16 :: SA, SB, SAB, SBA, s12(nloat), se12(nloat), s21(nloat), se21(nloat), s22(nloat,nloat)
  COMPLEX*16 :: vsa, vsb, vsab, vsba, vs12(nloat), vse12(nloat), vs21(nloat), vse21(nloat), vs22(nloat,nloat)
  REAL*8     :: facv, EQBAD, OVRDIV, TC, EFGFACT, EFG20, EFG22, EFG2M, QXX, QYY, QZZ, QXY, VXX, VYY, VZZ
  INTEGER    :: LM_MAX, ikp, is, itape, ios, icase, lcase, iw, nind, icix, num1, m1, ind, iom, max_nbands
  REAL*8     :: S,T,Z, vnorm1, BKROT2(3), BKROT3(3), zero3(3), ff, twgh, emax, wgamma
  integer    :: iorbital(natom,lmax2+1), norbitals, maxdim2, iorb, nbands, nbandsx, it, nomega, npomega, fh_sig, im
  real*8     :: h_al(iblock),h_bl(iblock)
  complex*16 :: h_yl((LMAX2+1)*(LMAX2+1),iblock), h_alyl((LMAX2+1)*(LMAX2+1),iblock), h_blyl((LMAX2+1)*(LMAX2+1),iblock)
  REAL*8     :: zw0(nume), LDA_weight(nume)
  REAL*8,     ALLOCATABLE :: zw2(:)
  COMPLEX*16, ALLOCATABLE :: alm(:,:),blm(:,:),clm(:,:,:), dh_alm(:,:,:), dh_blm(:,:,:), dh_clm(:,:,:,:)
  COMPLEX*16, ALLOCATABLE :: tmp(:,:), p_tmp(:,:), cfX(:,:,:,:), DMFTU(:,:,:), STrans(:,:,:,:), zw1(:), w1(:,:), Aweight(:,:), Olapm0(:,:,:), Wsum(:,:), Winf(:,:), Wferm(:,:)
  INTEGER,    ALLOCATABLE :: nindo(:), cix_orb(:), cixdim(:), iSx(:,:), noccur(:,:)
  complex*16, allocatable :: sigma(:,:,:), s_oo(:,:), Eij(:,:), zek(:), p_zek(:), gloc(:), gij(:,:),  zar(:,:), p_zar(:,:), zal(:,:), p_zal(:,:), zar_inf(:,:), zal_inf(:,:)
  real*8,     allocatable :: omega(:), zek_inf(:)
  ! interstitials
  INTEGER    :: keigen(3,nmat), kmax(3), iff1, iff2, iff3, iff1t, iff2t, iff3t, isig, ierr, ia1, ia2, jj, jx, ij, k
  REAL*8     :: volin, Tx, beta, ek_inf, dsum, drest, Om
  COMPLEX*16, ALLOCATABLE :: fft(:,:,:),tp(:,:,:),sumfft(:,:,:),vsumfft(:,:,:),tloc(:,:,:)
  DOUBLE PRECISION,ALLOCATABLE :: dwork(:)
  COMPLEX*16, ALLOCATABLE :: cwork(:)
  COMPLEX*16, ALLOCATABLE :: rho1(:),vrho1(:)
  COMPLEX*16, ALLOCATABLE :: rhok_buf(:),vrhok_buf(:)
  COMPLEX*16, ALLOCATABLE :: rhok(:),vrhok(:), Asc(:,:), w0inf(:), s_inf(:,:)
  COMPLEX*16 :: cek, omn, e0, e1, csum(nume)
  INTEGER :: qmax, j0, j1, j2, iomt, pr_proc, iikp
  LOGICAL :: Rho_Renormalize, Tcompute
  REAL*8,ALLOCATABLE  :: LowE(:,:,:)
  
  Rho_Renormalize = .FALSE.
  testLDA=.FALSE.
  debug = .FALSE.
  wgamma = 1e-10
  
  fh_sig = 80
  emax = ef
  TWOPI=TWO*PI

  TEST1=0.0D0                                                        
  ETOT=0.0D0                                                        
  ETOT2=0.0
  XWT=0.0                                                           
  SQRT2=SQRT(2.0D0)                                                 
  SQRT3=SQRT(3.D0)                                                  
  SQFP=SQRT(4.D0*PI)                                                
  zero3(:) = 0.0

  CALL init_lohelp
  CALL init_xa(nat)
  
  CALL Get_A_Dimensions(norbitals, maxdim2, iso, natom, nl, ll)
  allocate( nindo(norbitals), cix_orb(norbitals), cixdim(ncix) )
  allocate( iSx(maxdim2, norbitals) )
  allocate( cfX(maxdim2,maxdim2,norbitals,norbitals) )
  allocate( noccur(maxsize,ncix) )
  CALL Set_A_Arrays(iorbital, nindo, cix_orb, iSx, noccur, cixdim, cfX, CF, norbitals, iso, natom, nl, ll, cix, ncix, maxdim, maxdim2, lmax2, Sigind, csize, maxsize)
  
  
  !---------------- Reading self-energy ------------------------------------------------------------------!
  !---------------- Input self-energy must be in eV units. Will convert to Rydbergs below ----------------!
  !---------------- Resulting gloc written to file is also in eV units -----------------------------------!
  if (ncix.gt.0) then
     nomega = CountSelfenergy(fh_sig+1, csize(1))-1 !--- How many frequency point exists in the input file? ---!
  else                                           !--- For non-correlated case we do not have self-energy ---!
     nomega = nom_default                        !--- using default ----------------------------------------!
  endif                                        
  
  allocate( sigma(maxsize,ncix,nomega), omega(nomega), s_oo(maxsize,ncix) ) !----- allocating necessary arrays for self-energy ---!
  
  if (ncix.eq.0) then
     do iom=1,nomega
        omega(iom) = aom_default + (bom_default-aom_default)*iom/(nomega-1.)     !-- default frequency mesh --!
     enddo
  endif
  
  !----------- Actual reading of the self-energy -------------!
  !WRITE(6,*) '------------------------------------------------------------------------------'
  !WRITE(6,*) '----------------- SELF ENERGY AND ITS STRUCTURE ------------------------------'
  do icix=1,ncix
     CALL ReadSelfenergy(fh_sig+icix, sigma(:,icix,:), omega, s_oo(:,icix), gammac, csize(icix), nomega, maxsize)
     if (debug) then
        do iom=1,nomega
           WRITE(6,'(f15.10,1x)',advance='no') omega(iom)
           do it=1,csize(icix)
              WRITE(6,'(2f15.10,1x)',advance='no') sigma(it,icix,iom)
           enddo
           WRITE(6,*)
        enddo
     endif
  enddo
  
  !--------------  change from eV to Rydbergs --------------------------!
  omega(:) = omega(:)/Ry2eV
  sigma(:,:,:) = sigma(:,:,:)/Ry2eV
  s_oo(:,:) = s_oo(:,:)/Ry2eV
  gamma = gamma/Ry2eV
  !---------------- Reading self-energy --------------------------------!
  
  
  ALLOCATE( LowE(5,maxsize,ncix) )
  LowE = 0.0
  do icix=1,ncix
     IF (recomputeEF.gt.1) THEN
        CALL ApproximateSelfenergy(LowE(:,:,icix), sigma(:,icix,:), omega, csize(icix), nomega, maxsize)
     ENDIF
  enddo
  
  CALL CountFrequencyArrays(n0_om, qmax, beta, omega, nomega, matsubara)
  
  CALL init_muzero(nomega,qmax)
  
  CALL CreateFrequencyArrays(nomq, jomq, iomq, womq, abom, npomega, n0_om, qmax, beta, omega, nomega, matsubara)
  
  vnorm1=1.d0
  IF((iso.EQ.2).AND.(nspin1.EQ.1)) vnorm1=0.5d0
  
  Y=1.0D0                                                           
  DO I=1,49
     J=2*I-1
     FCT(J)=Y  ! FCT(i) = ((i+1)/2)!
     Y=Y*I
  END DO
  
  CIN=1.d0/137.0359895d0**2                       
  IF (.NOT.REL) CIN=4.0*1.0D-22                                     
  
  READ(18,2032) ISCF                                                     

  if (myrank.eq.master) then
     WRITE(8,787) ISCF                        
     WRITE(8,*) '   NORM OF CLM(R) =          '                        
     WRITE(8,*)                                                 
     if (vresp_write)  then       
        WRITE(28,787) ISCF                        
        WRITE(28,*) '   NORM OF CLM(R) =          '                        
        WRITE(28,*)  
     endif
     WRITE(6,800)
  endif
  
  LFIRST=1
  nnlo=0
  time_bl=zero; time_bl_w=zero; time_reduc=zero; time_reduc_w=zero
  time_write=zero; time_writeclm=zero; time_writescf=zero; time_write_w=zero
  time_writeclm_w=zero; time_writescf_w=zero; time_ilm=zero; time_ilm_w=zero
  time_radprod=zero; time_m=zero; time_rad=zero; time_rd_w=zero; time_rd_c=zero
  time_r_w=zero; time_r_c=zero; time_atpar_w=zero; time_atpar_c=zero; time_writeefg=zero; time_writeefg_w=zero
  time_dmf=zero; time_dmfw=zero; time_int=zero; time_intw=zero; time_ed=zero; time_edw=zero
  
  ALLOCATE(alm((lmax2+1)*(lmax2+1),nume),blm((lmax2+1)*(lmax2+1),nume),clm((lmax2+1)*(lmax2+1),nume,nloat))
  ALLOCATE(dh_alm(nume,(lmax2+1)*(lmax2+1),iso),dh_blm(nume,(lmax2+1)*(lmax2+1),iso),dh_clm(nume,(lmax2+1)*(lmax2+1),nloat,iso))
  CALL init_charp(nume)
  CALL init_chard(nume)
  CALL init_charf(nume)
  
  LMX=LMAX2                                                    
  
  allocate (e_store(0:lmax2,nat),elo_store(0:lomax,1:nloat,nat))
  
  rewind(30)
  DO i=1,nat
     READ(30,'(a)') parseline
     READ(parseline,'(100(f9.5))') e_store(0:lmax2,i)
     READ(30,'(100(f9.5))') elo_store(0:lomax,1:nloat,i)
  enddo
  rewind(30)
  
  
  CALL w_allocate0(nat)
  ! Reads case.in2 to determin LM array
  ! and maximum LM -> LM_MAX=max(LM(1,:))
  LM_MAX=0
  do jatom=1,nat
     ! neg L MEANS NEGATIVE SPHERICAL HARMONIC COMB (SEE KURKI-SUONIO)   
     read(5,1003) ( (lm(j,jlm),j=1,2), jlm=1,ncom )
     ! Find maximum LMMAX
     DO JLM=2,NCOM
        IF(LM(1,JLM).EQ.0) EXIT
     ENDDO
     LMMAX=JLM-1
     if (LMMAX.GT.LM_MAX) LM_MAX = LMMAX
     
     write(6,*) ' atom',jatom,' ncomu',0,' lmmax',LMMAX
     WRITE(6, 1005) LMMAX,((LM(J,JLM),J=1,2), JLM=1,LMMAX)             

     if (myrank.EQ.master) then
        WRITE(21,13)   JATOM,IATNR(JATOM),(POS(I,lfirst),I=1,3),MULT(JATOM)
        WRITE(21,1005) LMMAX,((LM(J,JLM),J=1,2), JLM=1,lmmax)             
     endif
     w_lm(1:2,1:NCOM,jatom) = lm(1:2,1:NCOM)
     w_lmmax(jatom) = lmmax
  enddo
  
  ! allocates memory to store radial wave functions and 
  ! all results of subroutine "atpar", which is called outside
  ! the k - loop.
  CALL w_allocate(LM_MAX,nat)
  
  do jatom=1,nat
     ! Here we calculate all radial wave functions and other quantities
     ! computed by atpar, which do not depend on k vector.
     
     lfirst=1
     do i=1,jatom-1
        lfirst=lfirst + mult(i)
     enddo

     ! calculate radial functions U(r), UE(R), ...                       
     call atpar (rel,nat,jatom,lfirst,cform,zz(jatom))               
     
     IMAX=JRI(JATOM)
     DO I=1,IMAX
        R(I)=R0(JATOM)*EXP((I-1)*DX(JATOM)) ! Radial mesh
     ENDDO
     
     nnlo=nlo+nlon+nlov
     
     w_lfirst(jatom) = lfirst
     w_nlo(jatom) = nlo
     w_nlov(jatom) = nlov
     w_nlon(jatom) = nlon

     w_ilo(0:lmax2,jatom) = ilo(0:lmax2)
     w_loor(1:nloat,0:lomax,jatom) = loor(1:nloat,0:lomax)
     w_lapw(0:lmax2,jatom) = lapw(0:lmax2)
     w_alo(0:lomax,1:nloat,jatom) = alo(0:lomax,1:nloat)
     w_blo(0:lomax,1:nloat,jatom) = blo(0:lomax,1:nloat)
     w_clo(0:lomax,1:nloat,jatom) = clo(0:lomax,1:nloat)
     
     w_a1lo(1:nrad,1:nloat,0:lomax,jatom) = a1lo(1:nrad,1:nloat,0:lomax)
     w_b1lo(1:nrad,1:nloat,0:lomax,jatom) = b1lo(1:nrad,1:nloat,0:lomax)
     w_RRAD1(1:nrad,0:lmax2,jatom) = RRAD1(1:nrad,0:lmax2)
     w_RRAD2(1:nrad,0:lmax2,jatom) = RRAD2(1:nrad,0:lmax2)
     w_RADE1(1:nrad,0:lmax2,jatom) = RADE1(1:nrad,0:lmax2)
     w_RADE2(1:nrad,0:lmax2,jatom) = RADE2(1:nrad,0:lmax2) 
     
     w_P(0:LMAX2,jatom) = P(0:LMAX2)
     w_DP(0:LMAX2,jatom) = DP(0:LMAX2)
     w_PE(0:LMAX2,jatom) = PE(0:LMAX2)
     w_DPE(0:LMAX2,jatom) = DPE(0:LMAX2)
     w_PEI(0:LMAX2,jatom) = PEI(0:LMAX2)
     w_pi12lo(1:nloat,0:lomax,jatom) = pi12lo(1:nloat,0:lomax)
     w_pe12lo(1:nloat,0:lomax,jatom) = pe12lo(1:nloat,0:lomax)
     w_pr12lo(1:nloat,1:nloat,0:lomax,jatom) = pr12lo(1:nloat,1:nloat,0:lomax)
     
     w_R(1:nrad,jatom) = R(1:nrad)
  enddo

  !---------------------------------
  ! START LOOP OVER ALL k-POINTS
  !---------------------------------
  CALL init_xa3(nmat,nnlo,nume,iso)
  

  max_nbands=0
  ! If DMFT-transformation need to be normalized, we compute the renormalization coefficients
  if (Qrenormalize) then
     allocate(Olapm0(maxdim,maxdim,ncix) )
!!!!! Should be paralelized
     CALL cmp_overlap(Olapm0, max_nbands, nkpt, nnlo, norbitals, natom, maxdim2, emin, emax, iorbital, cix_orb, iSx, nindo, noccur, cixdim, cfX, sumw, time_dmf0, time_dmf0w)
  endif
  
  ! Chemical potential is recomputed on DMFT-self-energy
  if (recomputeEF.GT.0) then
!!!!! Should be paralelized
     CALL cmp_EF(DM_EF, recomputeEF, max_nbands, Olapm0, omega, sigma, nkpt, nnlo, norbitals, natom, maxdim2, nomega, npomega, emin, emax, iorbital, cix_orb, iSx, nindo, noccur, cixdim, cfX, sumw, wgamma, beta, vnorm1, LowE, time_dmf1, time_dmf1w)
  endif
  ! The new chemical potential
  WRITE(6,1060)  ELECN,DM_EF
  if (myrank.EQ.master) then
     WRITE(21,1060) ELECN,DM_EF    
  endif
  
  ! ---- for interstitial ----
  kmax(:)=0
  ! ..... FIND MAX RECIPROCAL LATTICE VECTORS
  REWIND fh_vec
  DO i=1,nat
     READ(fh_vec) emist
     READ(fh_vec) emist
  ENDDO
  READ(fh_vec) s,t,z,kname,n,ne
  READ(fh_vec) (keigen(1,i),keigen(2,i),keigen(3,i),i=1,n)
  REWIND fh_vec
  DO i=n-nnlo,1,-1
     kmax(1)=MAX(keigen(1,i),kmax(1))
     kmax(2)=MAX(keigen(2,i),kmax(2))
     kmax(3)=MAX(keigen(3,i),kmax(3))
  ENDDO
  WRITE(6,*) 'max k indices:',kmax(1),kmax(2),kmax(3)
  kmax(1)=kmax(1)+1
  kmax(2)=kmax(2)+1
  kmax(3)=kmax(3)+1
  ! -----  set iff values for FFT calculation
  iff1=2*kmax(1)
  iff2=2*kmax(2)
  iff3=2*kmax(3)
  iff1=(iff1+1)*2
  iff2=(iff2+1)*2
  iff3=(iff3+1)*2
  iff1t=iff1
  iff2t=iff2
  iff3t=iff3
  CALL IFFLIM(iff1t,iff1)
  CALL IFFLIM(iff2t,iff2)
  CALL IFFLIM(iff3t,iff3)
  WRITE(6,*) 'n,iff1,iff2,iff3',n-nnlo,iff1,iff2,iff3
  !
  ALLOCATE (fft(iff1,iff2,iff3),tp(iff1,iff2,iff3),sumfft(iff1,iff2,iff3),vsumfft(iff1,iff2,iff3),tloc(iff1,iff2,iff3))
  ALLOCATE (dwork(4*(iff1+iff2+iff3)+15),cwork(iff1+iff2+iff3))
  fft=0.0
  tp=0.0
  sumfft=0.0
  vsumfft=0.0
  tloc=0.0
  ! --- finished for interstitial

  w_vRHOLM(:,:,:)=0.0
  w_RHOLM(:,:,:)=0.0
  w_xwt1(:,:)=0.0
  w_xwt1l(:,:)=0.0
  w_xwt1h(:,:)=0.0
  w_xwteh(:,:)=0.0
  w_xwtel(:,:)=0.0
     
  REWIND 5
  READ(5,fmt='(//,1A)') CDUMMY
  
  rewind(30)
  rewind(18)
  READ(18,2032) ISCF                                                     
  
  DO is=1,iso
     itape=8+is
     rewind(itape)
     do i=1,nat
        read(itape) emist
        read(itape) emist
     enddo
  ENDDO
  
  allocate( gloc(nomega) )

!!! ---------- Preparation of arrays for paralel executaion --------------                                                     
  pr_proc  = floor((nkpt-1)/DBLE(nprocs)+0.999)  ! The maximum number of points calculated per processor                                          
  WRITE(6,'(A,I3,2x,A,I3)') 'pr_proc=', pr_proc, 'tot-k=', nkpt-1
  print *, 'mpr_proc=', pr_proc, 'myrank=', myrank, 'nprocs=', nprocs, 'nkpt=', nkpt

  gloc=0
  NB(:)=0
  DO ikp=1,nkpt ! kpoint loop begin

     iikp = ikp-myrank*pr_proc            ! The index of the point to compute. If negative, do not compute! 
     if (iikp.GT.pr_proc) EXIT            ! Processor finished. The rest of the points will be taken care of by the other processors.
     Tcompute=.FALSE.
     if (iikp.gt.0) Tcompute=.TRUE.       ! If Tcompute is true, the point needs to be computed.

     call cputim(t1c)
     call walltim(t1w)

     !!! Need to read both spins!
     CALL Read_Vec_Spin(ikp, E, twgh, As, As_lo, kx, ky, kz, kxlo, kylo, kzlo, bkx, bky, bkz, bkxlo, bkylo, bkzlo, nemin, nemax, DM_nemin, DM_nemax, more_kpoints, n0, emin, emax, DM_Emin, DM_Emax, iso, nmat, nume, nnlo)

     IF (.NOT.Tcompute) CYCLE
     IF (.NOT.more_kpoints) EXIT

     LDA_weight=0
     DO num=nemin,nemax
        IF(E(num).GE.emin.AND.E(num).LE.emax) THEN
           LDA_weight(num)=weigh(ikp,num)
           IF(ABS(LDA_weight(num)).GT.1.d-8) THEN
              NB(ikp)=NB(ikp)+1
              etot=etot+E(num)*LDA_weight(num)*vnorm1
           ENDIF
           IF(ABS(LDA_weight(num)).LE.1.d-8) nemax=nemax-1
        ENDIF
     ENDDO
     
     call cputim(t2c)
     call walltim(t2w)
     time_rd_c=time_rd_c+t2c-t1c
     time_rd_w=time_rd_w+t2w-t1w

     do jatom=1,nat
        isize=n0-nnlo
        CALL HARMON(isize,bkx,bky,bkz,lmax2,fj(:,:,jatom),dfj(:,:,jatom),rmt(jatom))
     enddo

     call cputim(t1c)
     call walltim(t1w)

     nbands = DM_nemax-DM_nemin+1
     allocate( DMFTU(nbands,maxdim2,norbitals) )

     ! DMFT-projection is build
     CALL Build_DMFT_Projection(DMFTU, alm, blm, clm, h_yl, h_alyl, h_blyl, cfX, iorbital, norbitals, n0, nnlo, nbands, cix_orb, nindo, DM_nemin, DM_nemax, maxdim2)

     if (Qrenormalize) CALL RenormalizeTrans(DMFTU, Olapm0, cix_orb, nindo, iSx, nbands, maxdim2, norbitals, maxdim, ncix)
     
     allocate( STrans(maxsize,ncix,nbands,nbands) )
     CALL CompressSigmaTransformation2(STrans, DMFTU, Sigind, iSx, cix, csize, iorbital, ll, nl, natom, iso, ncix, maxdim, maxdim2, lmax2, norbitals, nbands, maxsize)

     DEALLOCATE( DMFTU )

     call cputim(t2c)
     call walltim(t2w)
     
     time_dmf=time_dmf+t2c-t1c
     time_dmfw=time_dmfw+t2w-t1w
     
     call cputim(t1c)
     call walltim(t1w)
     allocate( Eij(nbands,nbands), gij(nbands,nbands), Aweight(nbands,nbands), zw2(nbands) )
     ALLOCATE( zek(nbands), zar(nbands,nbands), zal(nbands,nbands) )
     allocate( tmp(nbands,nbands) )
     if (matsubara) then
        ALLOCATE( Wsum(nbands,nbands), w0inf(nbands) )
        ALLOCATE( p_tmp(nbands,nbands), zek_inf(nbands) )
        ALLOCATE( p_zek(nbands), p_zar(nbands,nbands), p_zal(nbands,nbands) )
        ALLOCATE( zar_inf(nbands,nbands), zal_inf(nbands,nbands) )
     else
        ALLOCATE( zw1(nbands), w1(nbands,nbands) )
     endif

     Aweight(:,:)=0
     wkp = (twgh/sumw*2.0)
     
     zw0(:)=0
     DO num=nemin,DM_nemin-1
        zw0(num) = wkp ! These bands are fully filled
     ENDDO
     
     if (matsubara) then
        !----------- Computes the infinite frequency limit
        Eij=0
        DO i=1,nbands
           Eij(i,i) = E(i+DM_nemin-1)  !---   preparing hamiltonian: epsk+sigma
        ENDDO
        ! Adding self-energy
        if (.NOT.TestLDA) then
           allocate( s_inf(maxsize,ncix) )
           s_inf(:,:) = dble(sigma(:,:,nomega))
           CALL AddSigma_optimized2(Eij, s_inf, STrans, csize, 1, nbands, ncix, maxsize)
           deallocate(s_inf)
        endif
        ! Here we might want to use Hermitian eigsys!!!!????
        CALL eigsys(Eij, zek, zal, zar, nbands) ! eigenvalues and eigenvectors
        
        zek_inf(:) = dble(zek(:))-DM_EF
        zal_inf(:,:) = zal(:,:)
        zar_inf(:,:) = zar(:,:)

        p_zek(:)   = zek(:)
        p_zal(:,:) = zal(:,:)
        p_zar(:,:) = zar(:,:)
     endif

     if (matsubara) then
        w0inf=0
        Wsum=0
     endif

     do iom=1,npomega
        ! Total hamiltonian (H+Sigma) in Kohn-Sham basis
        Eij=0
        DO i=1,nbands
           Eij(i,i) = E(i+DM_nemin-1)  !---   preparing hamiltonian: epsk+sigma
        ENDDO
        ! Adding self-energy
        if (.NOT.TestLDA) then
           CALL AddSigma_optimized2(Eij, sigma(:,:,iom), STrans, csize, 1, nbands, ncix, maxsize)
        endif
        
        CALL eigsys(Eij, zek, zal, zar, nbands) ! eigenvalues and eigenvectors


        if (.NOT.matsubara) then
           !-------- Real axis calculation
           
           DO num=DM_nemin,DM_nemax
              cc = log(dcmplx(abom(2,iom),wgamma)+DM_EF-zek(num-DM_nemin+1))-log(dcmplx(abom(1,iom),wgamma)+DM_EF-zek(num-DM_nemin+1))
              zw1(num-DM_nemin+1) = wkp*cc
           ENDDO
           ! Aweight = ( Ar.zw1.Al - (Ar.zw1.Al)^+ )/(2*pi*i)
           do num=1,nbands
              tmp(:,num) = zar(:,num)*zw1(num)
           enddo
           w1 = matmul(tmp,zal)
           Aweight(:,:) = Aweight(:,:) - (w1-conjg(transpose(w1)))/(2*pi*IMAG)
           
           gtc=0
           do i=1,nbands
              gtc = gtc + 1/(omega(iom)+DM_EF-zek(i)+gamma*IMAG)
           enddo
           
        else
           
           gtc=0
           DO num=DM_nemin,DM_nemax
              num0 = num-DM_nemin+1
              ek_inf = zek_inf(num0)
              if (iom.LT.n0_om) then
                 ! These frequencies are not yet in logarithmic mesh (Where all consecutive matsubara frequencies are present)
                 cek = zek(num0)-DM_EF
                 omn = dcmplx(0, omega(iom) )
                 w0inf(num0) = w0inf(num0) + 1./(omn-ek_inf)
                 w0          = 1./(omn-cek)
                 tmp(:,num0) = zar(:,num0)*w0
              else
                 ! Frequencies in logarithmic mesh
                 j0 = jomq(iom-1)
                 j1 = jomq(iom)
                 e0 = p_zEk(num0)-DM_EF
                 e1 =   zEk(num0)-DM_EF
                 
                 iomt = iom-1
                 p_w0=0
                 ! Here we interpolate forward. Current and next frequency are needed.
                 ! Since we do not know yet quantities in the next frequency, we 
                 ! do the calculation for the previous frequency (iom-1).
                 do i=1,nomq(iomt)
                    if (iomq(iomt,i).GT.jomq(iomt) .AND. iom.GT.n0_om) then
                       omn = dcmplx(0, (2*iomq(iomt,i)-1)*pi/beta)
                       cek = e0 + (e1-e0)*(iomq(iomt,i)-j0)/(j1-j0)
                       p_w0 = p_w0 + womq(iomt,i)*1./(omn-cek)
                       w0inf(num0) = w0inf(num0) + womq(iomt,i)*1./(omn-ek_inf)
                    endif
                 enddo
                 p_tmp(:,num0) = p_zar(:,num0)*p_w0


                 iomt = iom
                 w0=0
                 ! Here we interpolate backward. Current and previous frequency are needed
                 do i=1,nomq(iomt)
                    if (iomq(iomt,i).LE.jomq(iomt)) then
                       omn = dcmplx(0, (2*iomq(iomt,i)-1)*pi/beta)
                       cek = e0 + (e1-e0)*(iomq(iomt,i)-j0)/(j1-j0)
                       w0 = w0 + womq(iomt,i)*1./(omn-cek)
                       w0inf(num0) = w0inf(num0) + womq(iomt,i)*1./(omn-ek_inf)
                    endif
                 enddo
                 tmp(:,num0) =  zar(:,num0)*w0
              endif
              gtc = gtc + 1/(omega(iom)*IMAG+DM_EF-zek(num0))
           ENDDO
           
           Wsum(:,:) = Wsum(:,:) + matmul(tmp,zal)

           if (iom.GT.n0_om) Wsum(:,:) = Wsum(:,:) + matmul(p_tmp,p_zal)

           p_zek(:) = zek(:)
           p_zal(:,:) = zal(:,:)
           p_zar(:,:) = zar(:,:)
        endif

        gloc(iom) = gloc(iom) + gtc * (twgh/sumw)
     enddo

     if (matsubara) then
        ALLOCATE( Winf(nbands,nbands), Wferm(nbands,nbands) )
        
        do num0=1,nbands
           tmp  (:,num0) =   zar_inf(:,num0)*w0inf(num0)
        enddo
        Winf = matmul(tmp,zal_inf)
        do num0=1,nbands
           tmp  (:,num0) =   zar_inf(:,num0)*ferm(zek_inf(num0)*beta)
        enddo
        Wferm = matmul(tmp,zal_inf)
        
        tmp(:,:) = (Wsum(:,:) - Winf(:,:))*(2/beta) + Wferm(:,:)
        Aweight(:,:) = (0.5*wkp)*(tmp(:,:) + transpose(conjg(tmp(:,:))))

        DEALLOCATE( Winf, Wferm )
     endif
     
     DEALLOCATE( tmp )
     IF (matsubara) then
        DEALLOCATE( Wsum, w0inf )
        DEALLOCATE( p_tmp, zek_inf )
        DEALLOCATE( p_zek, p_zar, p_zal )
        DEALLOCATE( zal_inf, zar_inf )
     ELSE
        DEALLOCATE( w1, zw1 )
     ENDIF
     
     ! We use the following formula to implement the total energy:
     ! dE = \sum_{k,i} E_{k,i}^{LDA} * n_{i,i}^{DMFT}
     ! where E_{k,i} are Kohn-Sham eigenvalues
     ! and n_{i,i}^{DMFT}= T*sum_{iom}g_{k,ii}^{DMFT} is the DMFT density matrix in KS base
     DO i=nemin,DM_nemin-1
        ETOT2 = ETOT2 + E(i)*dble(wkp)
        !WRITE(*,'(I3,2x,F12.8,2x,F12.8)') i, weigh(ikp,i)/dble(wkp), E(i)*Ry2eV
     ENDDO
     DO i=1,nbands
        ETOT2 = ETOT2 + E(i+DM_nemin-1)*dble(Aweight(i,i))
        !WRITE(*,'(I3,2x,F12.8,2x,F12.8,1x,F12.8)') i, dble(Aweight(i,i))/dble(wkp), E(i+DM_nemin-1)*Ry2eV, weigh(ikp,i)/dble(wkp)
     ENDDO
     
     CALL DMFT_WEIGHTS(zw2, Aweight, nbands, debug)
     
     call cputim(t2c)
     call walltim(t2w)
     time_ed=time_ed+t2c-t1c
     time_edw=time_edw+t2w-t1w
     
     ! Weights for all bands, which are needed below
     weight=0
     weight(:DM_nemin-1) = zw0(:DM_nemin-1)
     weight(DM_nemin:DM_nemax) = zw2(:)
     
     
     DM_nemaxx=DM_nemax
     DO num=DM_nemin,DM_nemax
        IF(abs(zw2(num-DM_nemin+1)).LE.1.d-8) DM_nemaxx=DM_nemaxx-1
     ENDDO
     
     if (testLDA) DM_nemaxx = max(DM_nemaxx,nemax)
     ! we need to have alm up to DM_nemax
     nemax     = max(DM_nemax,nemax)

     do num=nemin,DM_nemaxx
        xwt=xwt+weight(num)*vnorm1
     enddo

     if (debug) then
        print *, 'xwt=', xwt, vnorm1
        print *, 'DM=', nemin, nemax, DM_nemin, DM_nemax, DM_nemaxx
        do num=nemin,nemax
           write(*,'(I3,1x,f20.10,1x)',advance='no') num, E(num)-DM_EF
           if (num.ge.DM_nemin) then
              write(*,'(f20.10,1x)',advance='no') dble(zek(num-DM_nemin+1))-DM_EF
           else
              write(*,'(f20.10,1x)',advance='no') 0.0
           endif
           write(*,'(f20.10,1x)', advance='no') LDA_weight(num)  !-(cc-conjg(cc))/(2*pi*IMAG)
           write(*,'(2f20.10,1x)') weight(num)
        enddo
     endif

     !WRITE(*,'(A,I4,1x,A,I3,1x,A,I4,1x,A,I3,1x,A,I4,1x,A,I4,1x)') 'ikp=', ikp, 'nemin=', nemin, 'nemax=', nemax, 'DM_nemin=', DM_nemin, 'DM_nemax=', DM_nemax, 'DM_nemaxx', DM_nemaxx
     WRITE(*,'(I3,A,1x,I3,1x,I3,1x,A,I3,1x,A,I3,1x,A,I3,1x,A,I3,1x,A,I3,1x)') myrank, ') Finished k-point', ikp, iikp, 'with nemin=', nemin, 'nemax=', nemax, 'DM_nemin=', DM_nemin, 'DM_nemax=', DM_nemax, 'DM_nemaxx', DM_nemaxx

     deallocate( Eij, gij, zw2 )
     DEALLOCATE( zek, zar, zal )
     
     DEALLOCATE( STrans )

     if (TestLDA) then
        weight(:) = LDA_weight(:)
     endif
     
     nbandsx = DM_nemaxx-DM_nemin+1


     do jatom=1,nat
        ! Quantities computed by "atpar" which do not depend on k-point
        lfirst = w_lfirst(jatom)
        lm(1:2,1:NCOM) = w_lm(1:2,1:NCOM,jatom)
        lmmax = w_lmmax(jatom)
        nlo = w_nlo(jatom)
        nlov = w_nlov(jatom)
        nlon = w_nlon(jatom)
        ilo(0:lmax2) = w_ilo(0:lmax2,jatom)
        loor(1:nloat,0:lomax) = w_loor(1:nloat,0:lomax,jatom)
        lapw(0:lmax2) = w_lapw(0:lmax2,jatom)
        alo(0:lomax,1:nloat) = w_alo(0:lomax,1:nloat,jatom)
        blo(0:lomax,1:nloat) = w_blo(0:lomax,1:nloat,jatom)
        clo(0:lomax,1:nloat) = w_clo(0:lomax,1:nloat,jatom)
        a1lo(1:nrad,1:nloat,0:lomax) = w_a1lo(1:nrad,1:nloat,0:lomax,jatom)
        b1lo(1:nrad,1:nloat,0:lomax) = w_b1lo(1:nrad,1:nloat,0:lomax,jatom)
        RRAD1(1:nrad,0:lmax2) = w_RRAD1(1:nrad,0:lmax2,jatom)
        RRAD2(1:nrad,0:lmax2) = w_RRAD2(1:nrad,0:lmax2,jatom)
        RADE1(1:nrad,0:lmax2) = w_RADE1(1:nrad,0:lmax2,jatom)
        RADE2(1:nrad,0:lmax2) = w_RADE2(1:nrad,0:lmax2,jatom)
        P(0:LMAX2) = w_P(0:LMAX2,jatom)
        DP(0:LMAX2) = w_DP(0:LMAX2,jatom)
        PE(0:LMAX2) = w_PE(0:LMAX2,jatom)
        DPE(0:LMAX2) = w_DPE(0:LMAX2,jatom)
        PEI(0:LMAX2) = w_PEI(0:LMAX2,jatom)
        pi12lo(1:nloat,0:lomax) = w_pi12lo(1:nloat,0:lomax,jatom)
        pe12lo(1:nloat,0:lomax) = w_pe12lo(1:nloat,0:lomax,jatom)
        pr12lo(1:nloat,1:nloat,0:lomax) = w_pr12lo(1:nloat,1:nloat,0:lomax,jatom)
        R(1:nrad) = w_R(1:nrad,jatom)
           
        !.....CALCULATE  BESSELFUNCTIONS                                        
        !     YLM ARE CALCULATED FOR EACH ENERGY SEPARATLY TO CONSERVE CM-SPACE
        !     CALL HARMON(N-(nlo+nlon+nlov),bkx,bky,bkz,lmax2,fj,dfj,rmt(jatom))
        !isize=n0-nnlo
        !CALL HARMON(isize,bkx,bky,bkz,lmax2,fj(:,:,jatom),dfj(:,:,jatom),rmt(jatom))
        
        ! zero koeff. for charge analysis
        CALL zero_charp(nemin,nemax)
        CALL zero_chard(nemin,nemax)
        CALL zero_charf(nemin,nemax)
        CALL zerotc_lohelp(nemin,nemax)
        TC100(0:lmax2,nemin:nemax)=0.0
        TCA100(0:lmax2,nemin:nemax)=0.0
        TCB100(0:lmax2,nemin:nemax)=0.0
        
        ! CALCULATE ALM, BLM                                                
        fac=4.0d0*pi*rmt(jatom)**2/SQRT(vol)                              
        latom=lfirst-1                                                    

        equiv_atom_loop: DO mu=1,mult(jatom)
           
           latom=latom+1

           alm(:,:)=0.0
           blm(:,:)=0.0
           clm(:,:,:)=0.0


           DO is=1,iso !!! over spin: Mar 25, 2010
              
              CALL cputim(time1)
              CALL walltim(time1_w)
           
              blocked_loop: DO ii=1,n0-nnlo,iblock !iblock*ibpp,iblock
                 ibb=MIN(iblock,n0-(nlo+nlon+nlov)-ii+1)
                 if(ibb.le.0) EXIT
                 i3=0
                 DO i=ii,min(ii+iblock-1,n0-nnlo) !ii+iblock-1
                    !---------  rotates ylm(k+K) to ylm(k'+K) where k' is in star of irreducible k. ------------!
                    i3=i3+1
                    bk(1)=bkx(i) !-----  reciprocal vector and irreducible vector: G=K+k ----!
                    bk(2)=bky(i)
                    bk(3)=bkz(i)
                    ! BKROT = R_g.(k+K)
                    CALL ROTATE (bk,rotij(1,1,latom),bkrot)
                    !---- BR1 transforms integer reciprocal lattice vectors, as given in the VECTORLIST of LAPW1, into cartesian system ----!
                    bk(1)=bkrot(1)*br1(1,1)+bkrot(2)*br1(1,2)+bkrot(3)*br1(1,3)   
                    bk(2)=bkrot(1)*br1(2,1)+bkrot(2)*br1(2,2)+bkrot(3)*br1(2,3)   
                    bk(3)=bkrot(1)*br1(3,1)+bkrot(2)*br1(3,2)+bkrot(3)*br1(3,3)   
                    !---- BKRLOC = Rotloc.R_g.(k+K),  is rotates Rotloc.R.(k+K) . Rotation Rotloc entered by user
                    CALL ROTATE (bk,rotloc(1,1,jatom),bkrloc)
                    !!!! CALL ROTATE (BK,crotloc(1,1,icase),BKRLOC) might beed to do that
                    !---- YLM = Y_{L}(Rotloc.R_g.(k+K))
                    CALL YLM (bkrloc,lmax2,yl)
                    arg1=bkrot(1)*(pos(1,lfirst))*twopi ! Might need to add shift!!
                    arg2=bkrot(2)*(pos(2,lfirst))*twopi
                    arg3=bkrot(3)*(pos(3,lfirst))*twopi
                    ! ARGT = (K+k)*tau(isym) 
                    argt=(bkx(i)*tauij(1,latom)+bky(i)*tauij(2,latom)+bkz(i)*tauij(3,latom))*twopi
                    ! PHSEHL = e^{I*2pi*( (R_g.(k+K)) *  R(iatom) + (K+k)*tau(isym))}
                    phshel=EXP( imag*(arg1+arg2+arg3+argt) )
                    index=0
                    DO  l=0,lmx
                       maxx=2*l+1
                       DO  m=1,maxx
                          index=index+1
                          h_yl(index,i3)=CONJG(yl(index))*phshel
                       ENDDO
                    ENDDO
                 ENDDO
                 
                 index=0
                 rmt2=1.D0/(rmt(jatom)**2)
                 DO l=0,lmx
                    i3=0
                    DO i=ii,ii+iblock-1
                       IF(i.GT.n0-(nlo+nlon+nlov)) EXIT
                       i3=i3+1
                       if(lapw(l)) then
                          h_al(i3)=dfj(l,i,jatom)*pe(l)-fj(l,i,jatom)*dpe(l) 
                          h_bl(i3)=fj(l,i,jatom)*dp(l)-dfj(l,i,jatom)*p(l)
                       ELSE
                          h_al(i3) = rmt2*fj(l,i,jatom)/p(l)
                          h_bl(i3) = 0.d0
                       ENDIF
                    ENDDO
                    maxx=2*l+1
                    DO m=1,maxx
                       index=index+1
                       i3=0
                       DO i=ii,ii+iblock-1
                          IF(i.GT.n0-(nlo+nlon+nlov)) EXIT
                          i3=i3+1
                          h_alyl(index,i3)=h_al(i3)*h_yl(index,i3)
                          h_blyl(index,i3)=h_bl(i3)*h_yl(index,i3)
                       ENDDO
                    ENDDO
                 ENDDO
                 !
                 lda=(LMAX2+1)*(LMAX2+1)
                 ldc=lda
                 ldb=nmat 
                 
                 !!! Mar 25, 2010
                 CALL zgemm('N','N',index,nemax-nemin+1,ibb,(1.d0,0.d0),h_alyl,lda,As(ii,nemin,is),ldb,(1.d0,0.d0),alm(1,nemin),ldc)
                 CALL zgemm('N','N',index,nemax-nemin+1,ibb,(1.d0,0.d0),h_blyl,lda,As(ii,nemin,is),ldb,(1.d0,0.d0),blm(1,nemin),ldc)
                 
              ENDDO blocked_loop
           
           
              CALL cputim(time2)
              CALL walltim(time2_w)
              time_bl=time_bl+time2-time1
              time_bl_w=time_bl_w+time2_w-time1_w
           
              CALL cputim(time1)
              CALL walltim(time1_w)
              
              ldc=(LMAX2+1)*(LMAX2+1)

              !!! Mar 25, 2010
              if (nlo.ne.0) call lomain (rotloc(:,:,jatom),zero3,is,nemin,nemax,lfirst,latom,n0,jatom,alm,blm,clm)
           
              index=0
              DO l=0,lmax2
                 maxx=2*l+1
                 cfac=imag**l
                 cfac=cfac*fac
                 DO m=1,maxx
                    index=index+1
                    DO num=nemin,nemax
                       alm(index,num)=alm(index,num)*cfac
                       blm(index,num)=blm(index,num)*cfac
                    ENDDO
                    DO jlo=1,ilo(l)
                       DO num=nemin,nemax
                          clm(index,num,jlo)=clm(index,num,jlo)*cfac
                       ENDDO
                    ENDDO
                 ENDDO
              ENDDO
           
              ! Chenging alm,blm,clm to make them DMFT-like
              alm(:,DM_nemin:DM_nemaxx)= matmul( alm(:,DM_nemin:DM_nemax), Aweight(:nbands,:nbandsx) )
              blm(:,DM_nemin:DM_nemaxx)= matmul( blm(:,DM_nemin:DM_nemax), Aweight(:nbands,:nbandsx) )
              DO jlo=1,nloat
                 clm(:,DM_nemin:DM_nemaxx,jlo)= matmul( clm(:,DM_nemin:DM_nemax,jlo), Aweight(:nbands,:nbandsx) )
              ENDDO
              
              
              dh_alm(:,:,is) = transpose( alm(:,:) )
              dh_blm(:,:,is) = transpose( blm(:,:) )
              DO jlo=1,nloat
                 dh_clm(:,:,jlo,is) = transpose( clm(:,:,jlo) )
              ENDDO
              
           ENDDO !!! over spin: Mar 25, 2010


           alm(:,:) = transpose( (dh_alm(:,:,1)+dh_alm(:,:,iso))/iso )
           blm(:,:) = transpose( (dh_blm(:,:,1)+dh_blm(:,:,iso))/iso )
           DO jlo=1,nloat
              clm(:,:,jlo) = transpose( (dh_clm(:,:,jlo,1)+dh_clm(:,:,jlo,iso))/iso )
           ENDDO

           
           CALL cputim(time2)
           CALL walltim(time2_w)
           time_reduc=time_reduc+time2-time1
           time_reduc_w=time_reduc_w+time2_w-time1_w
           
           !.....C(L,M) TO BE CALCULATED                                           
           CALL cputim(time1)
           CALL walltim(time1_w)
           
           ilm_loop: DO ILM=1,LMMAX
              Li=IABS(LM(1,ILM))                                                
              Mi=LM(2,ILM)                                                      
              !     SEE KURKI-SUONI  FACTOR FOR  LM+ (1,0), LM-(0,-1), M.NE.2N *(-1)  
              IMAG1=(1.0,0.0)                                                   

              IF(LM(1,ILM).LT.0) IMAG1= IMAG
              IF(MOD(Mi,2).EQ.1) IMAG1=-IMAG1
              
              l_sum: DO L=0,lmx
                 L1=L+1
                 MMAX=2*L+1
                 lp_sum: DO LP=0,lmx
                    CALL cputim(time3)
                    LP1=LP+1
                    IF(NOTRI(Li,L,LP).LT.0) CYCLE
                    MPMAX=2*LP+1
                    IMAX=JRI(JATOM)
                    
                    ! Radial functions are constructed
                    DO I=1,IMAX
                       UA(I) =RRAD1(I,L)*RRAD1(I,LP)+CIN*RRAD2(I,L)*RRAD2(I,LP)    
                       UB(I) =RADE1(I,L)*RADE1(I,LP)+CIN*RADE2(I,L)*RADE2(I,LP)    
                       UAB(I)=RRAD1(I,L)*RADE1(I,LP)+CIN*RRAD2(I,L)*RADE2(I,LP)   
                       UBA(I)=RRAD1(I,LP)*RADE1(I,L)+CIN*RRAD2(I,LP)*RADE2(I,L)   
                    ENDDO
                    ! Radial functions as product of local orbitals and u,dot{u}
                    DO jlo=1,ilo(l)
                       IF(loor(jlo,l)) THEN
                          DO I=1,IMAX
                             U21(I,jlo) =a1lo(I,jlo,L)*RRAD1(I,LP)+CIN*b1lo(I,jlo,L)*RRAD2(I,LP)    
                             Ue21(I,jlo)=a1lo(I,jlo,L)*RADE1(I,LP)+CIN*b1lo(I,jlo,L)*RADE2(I,LP)    
                          ENDDO
                       ENDIF
                    ENDDO
                    DO jlop=1,ilo(lp)
                       IF(loor(jlop,lp)) THEN
                          DO i=1,imax
                             u12(i,jlop) =RRAD1(i,l)*a1lo(i,jlop,lp)+CIN*RRAD2(i,l)*b1lo(i,jlop,lp)    
                             ue12(i,jlop)=RADE1(i,l)*a1lo(i,jlop,lp)+CIN*RADE2(i,l)*b1lo(i,jlop,lp) 
                          ENDDO
                       ENDIF
                    ENDDO
                    ! Radial functions for local orbitals
                    DO jlo=1,ilo(l)
                       DO jlop=1,ilo(lp) 
                          IF(loor(jlo,l).AND.loor(jlop,lp)) THEN
                             DO i=1,imax
                                u22(i,jlop,jlo)=a1lo(i,jlo,l)*a1lo(i,jlop,lp)+cin*b1lo(i,jlo,l)*b1lo(i,jlop,lp) 
                             ENDDO
                          ENDIF
                       ENDDO
                    ENDDO
                    CALL cputim(time4)
                    time_radprod=time_radprod+time4-time3
                    !.....M SUM                           

                    sa=0.0d0; sb=0.0d0; sab=0.0d0; sba=0.0d0; s12=0.0d0; 
                    se12=0.0d0; s21=0.0d0; se21=0.0d0; s22=0.0d0
                    vsa=0.0d0; vsb=0.0d0; vsab=0.0d0; vsba=0.0d0; vs12=0.0d0
                    vse12=0.0d0; vs21=0.0d0; vse21=0.0d0; vs22=0.0d0
                    
                    
                    CALL cputim(time3)
                    DO num=nemin,DM_nemaxx
                       tsuma = 0.0; tsumb = 0.0; tsumab= 0.0; tsumba= 0.0
                       tsum21 (:ilo(l))  = 0.0;  tsume21(:ilo(l))  = 0.0
                       tsum12 (:ilo(lp)) = 0.0;  tsume12(:ilo(lp)) = 0.0
                       tsum22 (:ilo(lp),:ilo(l))=0.0
                       
                       !do is=1,iso ! Mar 26: correct
                       is=2
                       
                       M=-(L+1) 
                       MP=-(LP+1)
                       DO MS=1,2*L+1
                          M=M+1
                          MP=-LP1
                          DO MPS=1,2*LP+1
                             MP=MP+1
                             MTEST=-M+Mi+MP
                             IF(MTEST.NE.0) CYCLE
                             LY  = L*(L+1)+M+1
                             LPY = LP*(LP+1)+MP+1
                             GNT=GAUNT(L,Li,LP,M,Mi,MP)
                             gint = IMAG1*GNT
                             
                             tSA = dh_ALM(num,LY,is)*dconjg(dh_ALM(num,LPY,is))*gint
                             tSB = dh_BLM(num,LY,is)*dconjg(dh_BLM(num,LPY,is))*gint
                             tSAB= dh_ALM(num,LY,is)*dconjg(dh_BLM(num,LPY,is))*gint
                             tSBA= dh_BLM(num,LY,is)*dconjg(dh_ALM(num,LPY,is))*gint
                             DO jlo=1,ilo(l)
                                tS21(jlo)  = dh_cLM(num,LY,jlo,is)*dconjg(dh_ALM(num,LPY,is))*gint
                                tSe21(jlo) = dh_cLM(num,LY,jlo,is)*dconjg(dh_BLM(num,LPY,is))*gint
                             ENDDO
                             DO jlop=1,ilo(lp)
                                tS12(jlop)  = dh_ALM(num,LY,is)*dconjg(dh_cLM(num,LPY,jlop,is))*gint
                                tSe12(jlop) = dh_BLM(num,LY,is)*dconjg(dh_cLM(num,LPY,jlop,is))*gint
                             ENDDO
                             DO jlo=1,ilo(l)
                                DO jlop=1,ilo(lp)
                                   tS22(jlop,jlo) = dh_CLM(num,LY,jlo,is)*dconjg(dh_CLM(num,LPY,jlop,is))*gint
                                ENDDO
                             ENDDO
                             
                             tSUMA  = tSUMA  + tSA
                             tSUMB  = tSUMB  + tSB
                             tSUMAB = tSUMAB + tSAB
                             tSUMBA = tSUMBA + tSBA
                             DO jlo=1,ilo(l)
                                tSUM21 (jlo) = tSUM21 (jlo) + tS21 (jlo)
                                tSUMe21(jlo) = tSUMe21(jlo) + tSe21(jlo)
                             ENDDO
                             DO jlop=1,ilo(lp)
                                tSUM12 (jlop) = tSUM12 (jlop) + tS12(jlop)
                                tSUMe12(jlop) = tSUMe12(jlop) + tSe12(jlop)
                             ENDDO
                             DO jlo=1,ilo(l)
                                DO jlop=1,ilo(lp)
                                   tSUM22(jlop,jlo) = tSUM22(jlop,jlo) + tS22(jlop,jlo)
                                ENDDO
                             ENDDO
                             
                          ENDDO
                       ENDDO
                       
                       !enddo
                       
                       tSUMA = tSUMA/iso
                       tSUMB = tSUMB/iso
                       tSUMAB = tSUMAB/iso
                       tSUMBA = tSUMBA/iso
                       tSUM21(:ilo(l)) = tSUM21(:ilo(l))/iso
                       tSUMe21(:ilo(l)) = tSUMe21(:ilo(l))/iso
                       tSUM12 (:ilo(lp)) = tSUM12(:ilo(lp))/iso
                       tSUMe12(:ilo(lp)) = tSUMe12(:ilo(lp))/iso
                       tSUM22(:ilo(lp),:ilo(l)) = tSUM22(:ilo(lp),:ilo(l))/iso
                       
                       wkp = weight(num)
                       facv = (-e(num))*wkp
                       sa  = sa  + tsuma  * wkp
                       sb  = sb  + tsumb  * wkp
                       sab = sab + tsumab * wkp
                       sba = sba + tsumba * wkp
                       vsa = vsa + tsuma  * facv
                       vsb = vsb + tsumb  * facv
                       vsab= vsab+ tsumab * facv
                       vsba= vsba+ tsumba * facv
                       DO jlo=1,ilo(l)
                          s21(jlo)   = s21(jlo)  + tsum21 (jlo) * wkp
                          se21(jlo)  = se21(jlo) + tsume21(jlo) * wkp
                          vs21(jlo)  = vs21(jlo) + tsum21 (jlo) * facv
                          vse21(jlo) = vse21(jlo)+ tsume21(jlo) * facv
                       ENDDO
                       DO jlop=1,ilo(lp)
                          s12  (jlop) = s12  (jlop) + tsum12 (jlop) * wkp
                          se12 (jlop) = se12 (jlop) + tsume12(jlop) * wkp
                          vs12 (jlop) = vs12 (jlop) + tsum12 (jlop) * facv
                          vse12(jlop) = vse12(jlop) + tsume12(jlop) * facv
                       ENDDO
                       DO jlo=1,ilo(l)
                          DO jlop=1,ilo(lp)
                             s22 (jlop,jlo) = s22 (jlop,jlo) + tsum22(jlop,jlo) * wkp
                             vs22(jlop,jlo) = vs22(jlop,jlo) + tsum22(jlop,jlo) * facv
                          ENDDO
                       ENDDO

                       suma  (num) = tsuma
                       sumb  (num) = tsumb
                       sumab (num) = tsumab
                       sumba (num) = tsumba
                       sum21 (num,:ilo(l))  = tsum21 (:ilo(l))
                       sume21(num,:ilo(l))  = tsume21(:ilo(l))
                       sum12 (num,:ilo(lp)) = tsum12 (:ilo(lp))
                       sume12(num,:ilo(lp)) = tsume12(:ilo(lp))
                       sum22 (num,:ilo(lp),:ilo(l)) = tsum22 (:ilo(lp),:ilo(l))
                    ENDDO
                    CALL cputim(time4)
                    time_m=time_m+time4-time3
                    
                    IF(Li.eq.0) call csplit(nemin,DM_nemaxx,l,jatom,mu,alm,blm,clm,coord) 
                    
                    CALL cputim(time3)
                    IMAX=JRI(JATOM)
                    DO I=1,IMAX
                       TC_buf(i)=SA*UA(I)+SB*UB(I)+SAB*UAB(I)+SBA*UBA(I)
                       vTC_buf(i)=vSA*UA(I)+vSB*UB(I)+vSAB*UAB(I)+vSBA*UBA(I)
                    ENDDO
                    DO jlo=1,ilo(l)
                       DO i=1,imax
                          tc_buf(i)=tc_buf(i)+S21(jlo)*U21(I,jlo)+Se21(jlo)*Ue21(I,jlo)
                          vtc_buf(i)=vtc_buf(i)+vS21(jlo)*U21(I,jlo)+vSe21(jlo)*Ue21(I,jlo)
                       ENDDO
                    ENDDO
                    DO jlop=1,ilo(lp)
                       DO i=1,imax
                          tc_buf(i)=tc_buf(i)+S12(jlop)*U12(I,jlop)+Se12(jlop)*Ue12(I,jlop)
                          vtc_buf(i)=vtc_buf(i)+vS12(jlop)*U12(I,jlop)+vSe12(jlop)*Ue12(I,jlop)
                       ENDDO
                    ENDDO
                    DO jlo=1,ilo(l)
                       DO jlop=1,ilo(lp)
                          DO i=1,imax
                             tc_buf(i)=tc_buf(i)+s22(jlop,jlo)*u22(i,jlop,jlo)
                             vtc_buf(i)=vtc_buf(i)+vs22(jlop,jlo)*u22(i,jlop,jlo)
                          ENDDO
                       ENDDO
                    ENDDO
                    DO i=1,imax
                       w_RHOLM(I,ILM,jatom)=w_RHOLM(I,ILM,jatom)+TC_buf(i)/MULT(JATOM)
                       w_vRHOLM(I,ILM,jatom)=w_vRHOLM(I,ILM,jatom)+vTC_buf(i)/MULT(JATOM)
                    ENDDO
                    CALL cputim(time4)
                    time_rad=time_rad+time4-time3
                 ENDDO lp_sum
              ENDDO l_sum
           ENDDO ilm_loop
           
           CALL cputim(time2)
           CALL walltim(time2_w)
           time_ilm=time_ilm+time2-time1
           time_ilm_w=time_ilm_w+time2_w-time1_w
        ENDDO equiv_atom_loop
        
        call psplit(w_xwt1(:,jatom),w_xwteh(:,jatom),w_xwtel(:,jatom),w_xwt1h(:,jatom),w_xwt1l(:,jatom),jatom,nemin,DM_nemaxx,test1,EQBAD,jatombad,lbad)
     ENDDO

     CALL cputim(time1)
     CALL walltim(time1_w)
     ! INTERSTITIAL CHARGE
     ! FFT eigenvectors and accumulate weighted square in sumfft
     keigen(1,:)=kx(:)
     keigen(2,:)=ky(:)
     keigen(3,:)=kz(:)
     isig=-1

     ALLOCATE( Asc(n0-nnlo,1:DM_nemaxx) )

     Asc(:,:) = As(:n0-nnlo,:DM_nemaxx,1)
     Asc(:,DM_nemin:DM_nemaxx) = matmul( As(:n0-nnlo,DM_nemin:DM_nemax,1), Aweight(:nbands,:nbandsx) )

     DO num=nemin,DM_nemaxx
        !  puts eigenvector into fft array for FFT
        CALL setfft1c(n0-nnlo,iff1,iff2,iff3,Asc(:,num),fft,keigen)
        !  computes a(k,r) = FFT(a(k,K))
        CALL c3fft(iff1,iff2,iff3,fft,iff1,iff2,isig,cwork,dwork,ierr)  
        !  |a(k,r)|^2 w(k)
        CALL sumupfft(iff1,iff2,iff3, weight(num),       fft,sumfft)    
        ! -|a(k,r)|^2 w(k)*e(k)
        CALL sumupfft(iff1,iff2,iff3,-weight(num)*E(num),fft,vsumfft)   
     ENDDO
     
     DEALLOCATE( Asc, Aweight )

     CALL cputim(time2)
     CALL walltim(time2_w)
     time_int =time_int +time2-time1
     time_intw =time_intw +time2_w-time1_w
  ENDDO     !  kpoint loop end

  CALL Reduce_MPI(xwt, etot2, gloc, w_RHOLM, w_vRHOLM, w_xwt1, w_xwteh, w_xwtel, w_xwt1h, w_xwt1l, sumfft, vsumfft, nomega, NRAD, LM_MAX, nat, iff1, iff2, iff3)


  if (myrank.eq.master) then
     print *, 'Sum of eigenvalues=', ETOT2*Ry2eV, 'eV'
     print *, 'Ratio to renormalize=', elecn/xwt
     if (Rho_Renormalize) then
        w_RHOLM = w_RHOLM * (elecn/xwt)
        w_vRHOLM = w_vRHOLM * (elecn/xwt)
     endif
     
     do iom=1,nomega
        WRITE(100,'(f18.10,1x,2f18.10)') omega(iom)*Ry2eV, -aimag(gloc(iom))/(pi*Ry2eV)
     enddo
  endif
  
  DEALLOCATE( gloc, sigma, omega, s_oo )
  CALL fini_muzero
  
  if (myrank.eq.master) then
     

     DO jatom=1,nat
        lm(1:2,1:NCOM) = w_lm(1:2,1:NCOM,jatom)
        LMMAX = w_lmmax(jatom)
        R(:) = w_R(:,jatom)
        
        CALL cputim(time1)
        CALL walltim(time1_w)
        
        DO ILM=1,LMMAX
           OVRDIV=1.0
           Li=LM(1,ILM)
           Mi=LM(2,ILM)
           IF(Li.NE.0) THEN
              IF(Mi.NE.0) THEN
                 IMAX=JRI(JATOM)
                 DO I=1,IMAX
                    w_vRHOLM(I,ILM,jatom)=w_vRHOLM(I,ILM,jatom)*SQRT2
                    w_RHOLM(I,ILM,jatom)=w_RHOLM(I,ILM,jatom)*SQRT2
                 enddo
              ENDIF
              CYCLE
           ENDIF
           CALL CHARGE(R,OVRDIV,SQFP,w_RHOLM(1,ILM,jatom),DX(JATOM),JRI(JATOM),TC)
           WRITE(6,207)  JATOM,TC
           WRITE(21,720) jatom,jatom,TC
           IF(ISPLIT(JATOM).EQ.1) THEN
              WRITE(6,250) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,250) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.2) THEN                               
              WRITE(6,251) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,251) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.3) THEN                               
              WRITE(6,252) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,252)jatom,JATOM, JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.-2) THEN                              
              WRITE(6,253) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,253) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.4) THEN                               
              WRITE(6,254) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,254) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.5) THEN                               
              WRITE(6,255) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,255) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.6) THEN                               
              WRITE(6,256) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,256) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.8) THEN                               
              WRITE(6,257) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
              WRITE(21,257) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,14)
           ELSE IF(ISPLIT(JATOM).EQ.15) THEN                               
              WRITE(6,258) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,21)
              WRITE(21,258) jatom,JATOM,JATOM,(w_XWT1(I,jatom),I=0,3),(w_XWT1(I,jatom),I=7,21)
           ENDIF
           do i=0,3
              if(w_xwt1l(i,jatom).lt.0.00005d0) then
                 w_XWT1l(i,jatom)=0.00001d0
                 w_XWTel(i,jatom)=w_XWT1l(i,jatom)*10.00001d0
              endif
              if(w_xwt1h(i,jatom).lt.0.00005d0) then
                 w_XWT1h(i,jatom)=0.00001d0
                 w_XWTeh(i,jatom)=w_XWT1h(i,jatom)*10.00001d0
              endif
           enddo
           write(6,260)
           WRITE(6,261) jatom,(w_XWT1l(I,jatom),w_XWTel(I,jatom)/w_XWT1l(I,jatom),I=0,3)
           write(6,262)
           WRITE(6,263) jatom,(w_XWT1h(I,jatom),w_XWTeh(I,jatom)/w_XWT1h(I,jatom),I=0,3)
           write(21,260)
           WRITE(21,261) jatom,(w_XWT1l(I,jatom),w_XWTel(I,jatom)/w_XWT1l(I,jatom),I=0,3)
           write(21,262)
           WRITE(21,263) jatom,(w_XWT1h(I,jatom),w_XWTeh(I,jatom)/w_XWT1h(I,jatom),I=0,3)
           !
           IF(Mi.NE.0) THEN
              IMAX=JRI(JATOM)                                                   
              DO I=1,IMAX                                                    
                 w_vRHOLM(I,ILM,jatom)=w_vRHOLM(I,ILM,jatom)*SQRT2
                 w_RHOLM(I,ILM,jatom)=w_RHOLM(I,ILM,jatom)*SQRT2
              enddo
           ENDIF
        enddo
     
        call cputim(time3)
        call walltim(time3_w)
        
        ! Writting case.clmval
        WRITE(8,1990) JATOM
        WRITE(8,2001) LMMAX
        DO ILM=1,LMMAX
           Li=LM(1,ILM)
           Mi=LM(2,ILM)
           WRITE(8,2011) Li,Mi
           WRITE(8,2022) ( w_RHOLM(I,ILM,jatom), I=1,IMAX )
           WRITE(8,2031)
        end DO
        WRITE(8,2030)
        
        if(vresp_write) then
           WRITE(28,1990) JATOM
           WRITE(28,2001) LMMAX
           DO ILM=1,LMMAX
              Li=LM(1,ILM)
              Mi=LM(2,ILM)
              WRITE(28,2011) Li,Mi
              WRITE(28,2022) ( w_vRHOLM(I,ILM,jatom), I=1,IMAX )
              WRITE(28,2031)
           end DO
           WRITE(28,2030)
        endif
        
        call cputim(time4)
        call walltim(time4_w)
        time_writeclm=time_writeclm+time4-time3
        time_writeclm_w=time_writeclm_w+time4_w-time3_w
        
        DO ILM1=1,LMMAX
           IF (LM(1,ILM1).EQ.2.AND.LM(2,ILM1).EQ.0) THEN
              DO I=1,IMAX                                                
                 w_RHOLM(I,ILM1,jatom)=w_RHOLM(I,ILM1,jatom)/R(I)**3
              enddo
              LABEL=1
              DO ILM2=ILM1+1,LMMAX
                 IF (LM(1,ILM2).EQ.2.AND.LM(2,ILM2).EQ.2) THEN
                    DO I=1,IMAX
                       w_RHOLM(I,ILM2,jatom)=w_RHOLM(I,ILM2,jatom)/R(I)**3
                    enddo
                    LABEL=2
                    DO ILM3=ILM2+1,LMMAX
                       IF (LM(1,ILM3).EQ.-2.AND.LM(2,ILM3).EQ.2) THEN
                          DO I=1,IMAX
                             w_RHOLM(I,ILM3,jatom)=w_RHOLM(I,ILM3,jatom)/R(I)**3
                          enddo
                          LABEL=3
                          GOTO 7372
                       ENDIF
                    ENDDO
                    GOTO 7372
                 ENDIF
              ENDDO
              GOTO 7372
           ENDIF
        ENDDO
     
        GOTO 7371
     
7372 CONTINUE 
     
        EFGFACT=0.02997925
        FAC=0.8D0*PI*324.14D0
        DO I1=0,jri(jatom)-5,1000   ! 7374
           ! integrates: TC = integrate(R*RHOLM)
           CALL CHARGE(R,1.D0,1.D0,w_RHOLM(1,ILM1,jatom),DX(JATOM),JRI(JATOM)-I1,TC) 
           TC=TC*FAC
           EFG20=TC
           IF (LABEL.GT.1) THEN
              CALL CHARGE(R,1.D0,1.D0,w_RHOLM(1,ILM2,jatom),DX(JATOM),JRI(JATOM)-I1,TC) 
              TC=TC*FAC
              EFG22=TC
              IF (LABEL.EQ.3) THEN
                 CALL CHARGE(R,1.D0,1.D0,w_RHOLM(1,ILM3,jatom),DX(JATOM),JRI(JATOM)-I1,TC)
                 TC=TC*FAC
                 EFG2M=TC
                 QXX=(-EFG20/SQRT(3.D0)+EFG22)*SQRT(15.D0/4.D0/PI)
                 QYY=(-EFG20/SQRT(3.D0)-EFG22)*SQRT(15.D0/4.D0/PI)
                 QZZ=(EFG20*2.D0/SQRT(3.D0))*SQRT(15.D0/4.D0/PI)
                 QXY=EFG2M*SQRT(15.D0/4.D0/PI)
                 QXX=-QXX*EFGFACT
                 QXY=-QXY*EFGFACT
                 QYY=-QYY*EFGFACT
                 QZZ=-QZZ*EFGFACT
                 IF (I1.EQ.0) WRITE(6,3019)
                 IF (I1.EQ.0) WRITE(21,3019)
                 WRITE(6,3121) jatom,QXX,QXY,QYY,QZZ,R(JRI(JATOM)-I1)
                 IF (I1.EQ.0) WRITE(21,3121) jatom,QXX,QXY,QYY,QZZ,R(JRI(JATOM)-I1)      
              ELSE
                 VXX=(-EFG20/SQRT(3.D0)+EFG22)*SQRT(15.D0/4.D0/PI)
                 VYY=(-EFG20/SQRT(3.D0)-EFG22)*SQRT(15.D0/4.D0/PI)
                 VZZ=(EFG20*2.D0/SQRT(3.D0))*SQRT(15.D0/4.D0/PI)
                 IF (I1.EQ.0) WRITE(6,3017)
                 VXX=-VXX*EFGFACT
                 VYY=-VYY*EFGFACT
                 VZZ=-VZZ*EFGFACT
                 IF (I1.EQ.0) WRITE(21,3017)
                 WRITE(6,3021) jatom,VXX,VYY,VZZ,R(JRI(JATOM)-I1)
                 IF (I1.EQ.0) WRITE(21,3021) jatom,VXX,VYY,VZZ,R(JRI(JATOM)-I1)
              ENDIF
           ELSE
              EFG20=EFG20*2.D0/SQRT(3.D0)*SQRT(15.D0/4.D0/PI)
              EFG20=-EFG20*EFGFACT
              WRITE(6,7207)  JATOM,EFG20,R(JRI(JATOM)-I1)
              IF (I1.EQ.0) WRITE(21,7720) jatom,JATOM,EFG20,R(JRI(JATOM)-I1)
           ENDIF
        ENDDO !7374       CONTINUE                                                          
     
     
7371 CONTINUE                                     
     
        REWIND fh_vec
        
        CALL cputim(time3) 
        call walltim(time3_w)
        time_writeefg=time_writeefg+time3-time4
        time_writeefg_w=time_writeefg_w+time3_w-time4_w
        
        
        CALL cputim(time2)
        CALL walltim(time2_w)
        time_writescf=time_writescf+time2-time3
        time_write=time_write+time2-time1
        time_writescf_w=time_writescf_w+time2_w-time3_w
        time_write_w=time_write_w+time2_w-time1_w
     ENDDO
     
     write(6,*)
     write(6,'(a,2f8.1)') '   atpar              (cpu,wall):',time_atpar_c,time_atpar_w
     write(6,'(a,2f8.1)') '   readvec            (cpu,wall):',time_rd_c,time_rd_w
     write(6,'(a,2f8.1)') '   readvec, read only (cpu,wall):',time_r_c,time_r_w
     WRITE(6,'(a,2f8.1)') '   blocked loop            (cpu):',time_bl,time_bl_w
     WRITE(6,'(a,2f8.1)') '   reduced                 (cpu):',time_reduc,time_reduc_w
     WRITE(6,'(a,2f8.1)') '   ilm-tot loop            (cpu):',time_ilm,time_ilm_w
     WRITE(6,'(a,f8.1)')  '   ilm-1 loop              (cpu):',time_radprod
     WRITE(6,'(a,f8.1)')  '   ilm-2 loop              (cpu):',time_m
     WRITE(6,'(a,f8.1)')  '   ilm-3 loop              (cpu):',time_rad
     WRITE(6,'(a,2f8.1)') '   write-clm          (cpu,wall):',time_writeclm,time_writeclm_w
     WRITE(6,'(a,2f8.1)') '   write-scf          (cpu,wall):',time_writescf,time_writescf_w
     WRITE(6,'(a,2f8.1)') '   write-efg          (cpu,wakk):',time_writeefg,time_writeefg_w
     WRITE(6,'(a,2f8.1)') '   write              (cpu,wall):',time_write,time_write_w
     WRITE(6,'(a,2f8.1)') '   dmft renorm-overlap(cpu,wall):',time_dmf0, time_dmf0w
     WRITE(6,'(a,2f8.1)') '   dmft chemical pot  (cpu,wall):',time_dmf1, time_dmf1w
     WRITE(6,'(a,2f8.1)') '   dmft transformation(cpu,wall):',time_dmf, time_dmfw
     WRITE(6,'(a,2f8.1)') '   dmft exact-diag    (cpu,wall):',time_ed, time_edw
     WRITE(6,'(a,2f8.1)') '   interstitial charge(cpu,wall):',time_int, time_intw
     
     WRITE(6,881)  XWT
     WRITE(21,881) XWT
     WRITE(21,725) ETOT2 !+ ts2
     WRITE(6,882) ETOT2  !+ ts2
     !
  endif

  REWIND fh_vec


  deallocate (e_store,elo_store)
  DEALLOCATE(dh_alm,dh_blm,dh_clm)
  DEALLOCATE(alm,blm,clm)
  DEALLOCATE( nindo, cix_orb, cixdim, iSx )
  deallocate( cfX, noccur )
  CALL fini_charp
  CALL fini_chard
  CALL fini_charf
  CALL fini_lohelp
  CALL fini_xa
  CALL fini_xa3
  CALL w_deallocate

  if (Qrenormalize) then
     deallocate(Olapm0 )
  endif

  
  CALL cputim(time2)
  TCLM = time2
  CALL walltim(time2_w)
  TCLM_w = time2

  
  if (myrank.EQ.master) then
     
     ! ---- Interstitials ---
     !
     ! Back transform cumulative grids
     isig=1
     ! computes rho(K)=FFT(rho(r))
     CALL c3fft(iff1,iff2,iff3,sumfft,iff1,iff2,isig,cwork,dwork,ierr) 
     CALL c3fft(iff1,iff2,iff3,vsumfft,iff1,iff2,isig,cwork,dwork,ierr)
     sumfft(:,:,:)=sumfft(:,:,:)/dble(iff1*iff2*iff3)
     vsumfft(:,:,:)=vsumfft(:,:,:)/dble(iff1*iff2*iff3)
     
     ALLOCATE( rho1(nwave*nsym),vrho1(nwave*nsym) )
     rho1(:)=0.0 ; vrho1(:)=0.0
     
     call getfft(nwave,iff1,iff2,iff3,rho1,sumfft,kmax)
     call getfft(nwave,iff1,iff2,iff3,vrho1,vsumfft,kmax)
     
     ALLOCATE( rhok(nwave),vrhok(nwave) )
     vrhok(:)=0.0;  rhok(:)=0.0
     
     !.....SUM OVER ALL RECPR. LATTIC VECTORS OF ONE STAR
     ia1=1
     volin = 1.0d0/vol
     DO j=1,nwave
        ia2=ia1+inst(j)-1
        DO jj=ia1,ia2
           rhok(j)  = rhok(j)  + rho1(jj)*CONJG(tauk(jj))
           vrhok(j) = vrhok(j) + vrho1(jj)*CONJG(tauk(jj))
        ENDDO
        ia1=ia2+1
        vrhok(j) = vrhok(j) * volin
        rhok(j)  = rhok(j)  * volin
     ENDDO
     
     if (Rho_Renormalize) then
        rhok = rhok * (elecn/xwt)
        vrhok = vrhok * (elecn/xwt)
     endif
     
     WRITE(8,*) '   VALENCE CHARGE DENSITY IN INTERSTITIAL '
     WRITE(8,*)
     WRITE(8,2061)  NWAVE
     WRITE(8,2071)  ( (KZZ(JX,J),JX=1,3),RHOK(J), J=1,NWAVE)
     
     if(vresp_write) then
        WRITE(28,*) '   VALENCE CHARGE DENSITY IN INTERSTITIAL '
        WRITE(28,*)
        WRITE(28,2061)  NWAVE
        WRITE(28,2071)  ( (KZZ(JX,J),JX=1,3),VRHOK(J), J=1,NWAVE)
     endif
     WRITE(6,204) NWAVE,kmax
     
     close(8)
     
     DEALLOCATE(rhok,vrhok)
     DEALLOCATE(rho1,vrho1)
  endif

  DEALLOCATE (fft, tp, sumfft, vsumfft, tloc )
  DEALLOCATE (dwork, cwork)
  ! --- Interstitials ---

  CALL cputim(time2)
  TFOUR = time2
  CALL walltim(time2_w)
  TFOUR_w = time2

  RETURN
  

205 FORMAT(/,1X,' K-POINT:',3F8.4,1X,I5,I4,2X,A10)                      
207 FORMAT(1H0,' TOTAL CHARGE INSIDE SPHERE',I5,1H:,F12.6)            
250 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PZ,PXY',/,':QTL',i3.3,':',12F7.4)               
251 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,      ','D-EG,D-T2G ',/,':QTL',i3.3,':',12F7.4)  
252 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,      ','D-Z2,D-XY,X2Y2,D-XZ,YZ ',/,':QTL',i3.3,':',12F7.4)
253 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PZ,PXY,,','D-Z2,D-XY,D-X2Y2,D-XZ,YZ ',/,':QTL',i3.3,':',12F7.4)                          
254 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PZ,PXY, ','D-Z2,D-XY,X2Y2,D-XZ,YZ ',/,':QTL',i3.3,':',12F7.4)                            
255 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,      ','D-Z2,D-X2Y2,D-XY,D-XZ,D-YZ ',/,':QTL',i3.3,':',12F7.4)                        
256 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PX,PY,PZ,',' ',/,':QTL',i3.3,':',12F7.4)
257 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PX,PY,PZ,','D-Z2,D-X2Y2,D-XY,D-XZ,D-YZ ',/,':QTL',i3.3,':',12F7.4)                        
258 FORMAT(':PCS',i3.3,':',1X,'PARTIAL CHARGES SPHERE =',I3,' S,P,D,F,PX,PY,PZ,D-Z2,D-X2Y2,D-XY,D-XZ,D-YZ,F00,F11,F22',',F33,','F1M,F2M,F3M ',/,':QTL',i3.3,':',19F7.4)
260 FORMAT(8x,'Q-s-low E-s-low   Q-p-low E-p-low   Q-d-low E-d-low','   Q-f-low E-f-low')
261 FORMAT(':EPL',i3.3,':',4(2F8.4,2x))
262 FORMAT(8x,'Q-s-hi  E-s-hi    Q-p-hi  E-p-hi    Q-d-hi  E-d-hi ','   Q-f-hi  E-f-hi ')
263 FORMAT(':EPH',i3.3,':',4(2F8.4,2x))
501 FORMAT(2i5,' k-point, nband')
503 FORMAT(5e17.9)
720 FORMAT(/,':CHA',i3.3,':',1X,'TOTAL CHARGE INSIDE SPHERE ',I3,' = ',F12.6)         
725 FORMAT(/,':SUM  :',1X,'SUM OF EIGENVALUES =  ',F20.9,/)            
787 FORMAT('    VALENCE CHARGE DENSITY   IN  MT SPHERES',5X,I3,' ITERATION')
800 FORMAT(/,10X,68(1H-),/,11X,'W A V E F U N C T I O N S','   AND   C H A R G E S   IN   S P H E R E S',/,10X,68(1H-))                                         
881 FORMAT(/,':CHA  :',' TOTAL CHARGE INSIDE UNIT CELL =',F15.6) 
882 FORMAT(//,3X,'SUM OF EIGENVALUES:'/24X,F15.6/)                    
1003 FORMAT(251(I3,I2))                                                 
1005 FORMAT(/,7X,'LMMAX',I3,/,7x,'LM= ',17(i3,I2),(/,7x,18(i3,i2)))          
1990 FORMAT(3X,'ATOMNUMBER   ',I3,5X,10A4)                             
2001 FORMAT(3X,'NUMBER OF LM',I3//)                                   
2011 FORMAT(3X,'CLM(R) FOR L',I3,3X,'M=',I2/)                         
2022 FORMAT(3X,4E19.12)                                                 
2030 FORMAT(///)                                                       
2031 FORMAT(/)                                                         
2032 FORMAT(49X,I3,//)  
2055 FORMAT(/,1X,' K-POINT:',3F14.10,1X,I5,I4,2X,A10)
3017 FORMAT(/,22X,'VXX',9X,'VYY',9X,'VZZ',7X,'UP TO R',/)
3018 FORMAT(/'  EFG COMPONENTS BEFORE TRANSFORMATION [10**21 V/(M*M)]:',/,15X,'QXX (-V20/2. + V22)     =',F10.3,/,15X,'QYY (-V20/2. - V22)     =',F10.3,/,15X,'QZZ ( V20)              =',F10.3,/,15X,'QXY ( V2M/2. * SQRT(3.))=',F10.3)  
3019 FORMAT(/,22X,'QXX',9X,'QXY',9X,'QYY',9X,'QZZ',7X,'UP TO R',/)
3020 FORMAT(/'  EFG COMPONENTS AFTER TRANSFORMATION [10**21 V/(M*M)]:',/,15X,'VXX                     =',F10.3,/,15X,'VYY                     =',F10.3,/,15X,'VZZ                     =',F10.3,/)
3121 FORMAT(':VZZ',i3.3,':',8x,4F12.5,F12.3)
3021 FORMAT(':VZZ',i3.3,':',8x,3F12.5,F12.3)
3022 FORMAT(  15X,'QXX=',F10.3,/,15X,'QYY=',F10.3,/,15X,'QZZ=',F10.3,15X,'QXY=',F10.3,' UP TO R= ',F10.5)
4645 FORMAT(2i4,3f15.10)
4646 FORMAT(8e20.10)
4893 FORMAT(3i4,4(2e16.8,2x))  
13   FORMAT(////,':POS',i3.3,':',1x,'AT.NR.',I4,1X,'POSITION =',3F8.5,2X,'MULTIPLICITY =',I3)
7207 FORMAT(1H ,' EFG INSIDE SPHERE',I5,1H:,F12.6,5X,' UP TO R = ',F10.7)                                                          
7720 FORMAT(':VZZ',i3.3,':',1X,'EFG INSIDE SPHERE ',I3,' = ',F12.6,5X,' UP TO R =',F10.5)


204 FORMAT(I10,' FOURIER COEFFICIENTS CALCULATED',/' LARGEST COMPONENTS:',3I6)
2061 FORMAT(1X,'        ',I10,1X,'NUMBER OF PW')
2071 FORMAT(3X,3I5,2E19.12)
1060 FORMAT(//,':NOE  :',1X,'NUMBER OF ELECTRONS',10X,'=',F8.3,//   ,':FER  :',1X,'F E R M I - ENERGY',11X,'= ',F9.5)            

END SUBROUTINE L2MAIN

SUBROUTINE CountFrequencyArrays(n0_om, qmax, beta, omega, nomega, matsubara)
  USE defs,  ONLY: PI
  IMPLICIT NONE
  INTEGER,intent(out):: n0_om, qmax
  REAL*8, intent(out):: beta
  REAL*8, intent(in) :: omega(nomega)
  INTEGER,intent(in) :: nomega
  LOGICAL,intent(in) :: matsubara
  ! locals
  real*8, PARAMETER       :: Ry2eV = 13.60569193
  INTEGER :: i,j,ij,k,iom
  INTEGER :: nomq(nomega)
  
  qmax=0
  beta=0
  IF (matsubara) THEN
     beta = PI/omega(1)
     do iom=1,nomega
        if (abs((omega(iom)*beta/PI+1)/2. - iom).GT.1e-1) EXIT
     enddo
     n0_om = iom-1

     nomq(:)=0
     do iom=n0_om,nomega-1
        i = nint((omega(iom)*beta/PI+1)/2.)
        j = nint((omega(iom+1)*beta/PI+1)/2.)
        ij = (i+j)/2
        do k=i,ij
           nomq(iom)=nomq(iom)+1
        enddo
        do k=ij,j-1
           nomq(iom+1)=nomq(iom+1)+1
        enddo
     enddo
     nomq(nomega)=nomq(nomega)+1
     do iom=n0_om,nomega
        qmax = max(qmax,nomq(iom))
     enddo

     print *, 'beta....=', beta/Ry2eV, 'n0_om...=', n0_om
  ENDIF
END SUBROUTINE CountFrequencyArrays

SUBROUTINE CreateFrequencyArrays(nomq, jomq, iomq, womq, abom, npomega, n0_om, qmax, beta, omega, nomega, matsubara)
  USE defs,  ONLY: PI
  IMPLICIT NONE
  INTEGER,intent(in) :: n0_om, qmax, nomega
  INTEGER,intent(out):: nomq(nomega), jomq(nomega), iomq(nomega,qmax)
  REAL*8, intent(out):: womq(nomega,qmax), abom(2,nomega)
  INTEGER,intent(out):: npomega
  REAL*8, intent(in) :: beta, omega(nomega)
  LOGICAL,intent(in) :: matsubara
  ! locals
  REAL*8  :: emist, Large
  INTEGER :: i,j,ij,k,iom,ic

  nomq(:)=0; iomq(:,:)=0; jomq(:)=0; womq(:,:)=0
  abom(:,:)=0
  npomega = nomega

  IF (matsubara) THEN
     do iom=1,n0_om-1
        nomq(iom)=1
        iomq(iom,1)=iom
        womq(iom,1)=1.0
        jomq(iom)=iom
     enddo

     do iom=n0_om,nomega-1
        i = nint((omega(iom)*beta/PI+1)/2.)     ! current matsubara frequency from log mesh (in integer representation)
        j = nint((omega(iom+1)*beta/PI+1)/2.)   ! next matsubara frequency from log mesh (in integer representation)
        ij = (i+j)/2                      ! center 
        jomq(iom) = i

        if (MOD(j-i,2).eq.1) then
           do k=i,ij
              nomq(iom)=nomq(iom)+1
              iomq(iom,nomq(iom))=k
              womq(iom,nomq(iom))=1.0
           enddo
           do k=ij+1,j-1
              nomq(iom+1)=nomq(iom+1)+1
              iomq(iom+1,nomq(iom+1))=k
              womq(iom+1,nomq(iom+1))=1.0
           enddo
        else
           do k=i,ij
              nomq(iom)=nomq(iom)+1
              iomq(iom,nomq(iom))=k
              womq(iom,nomq(iom))=1.0
           enddo
           womq(iom,nomq(iom))=0.5
           ic = nomq(iom+1)+1
           do k=ij,j-1
              nomq(iom+1)=nomq(iom+1)+1
              iomq(iom+1,nomq(iom+1))=k
              womq(iom+1,nomq(iom+1))=1.0
           enddo
           womq(iom+1,ic)=0.5
        endif
     enddo
     k = nint((omega(nomega)*beta/PI+1)/2.)
     nomq(nomega)=nomq(nomega)+1
     iomq(nomega,nomq(nomega))=k
     womq(nomega,nomq(nomega))=1.0
     jomq(nomega)=k

  ELSE
     Large = 10000.
     !-- creates integration intervals
     do npomega=1,nomega
        if (omega(npomega).gt.0) exit
     enddo
     npomega=npomega-1

     abom(1,1) = -Large
     abom(2,1) = 0.5*(omega(1)+omega(2))
     do iom=2,npomega-1
        abom(1,iom) = 0.5*(omega(iom)+omega(iom-1)) ! always start at midpoint
        abom(2,iom) = 0.5*(omega(iom)+omega(iom+1)) ! and end at midpoint
     enddo
     abom(1,npomega) = 0.5*(omega(npomega)+omega(npomega-1))
     abom(2,npomega) = 0.0
  ENDIF
END SUBROUTINE CreateFrequencyArrays

!SUBROUTINE EnergyCorrection(EF,nkp)
!  !
!  !     Caluculate energycorrection caused by gaussian smearing
!  !     Start loop over k-points (for spinpol.systems divide by 2
!  eta=0.d0
!  do i = 1,nkp
!     !     Start loops over bands
!     do j = 1,NE(i)
!        de = (E(i,j) - efermi)/del1
!        de = de * de
!        if (de.lt.15.) then
!           eta = eta + 0.5*del1*EXP(-de)*WEIGHT(i)
!        endif
!     enddo
!  enddo
!  eta = -eta*2./sqrt(pi) / jspin
!  
!  write(6,154) eta/2.d0 
!  write(21,154) eta /2.d0
!  
!  ts2=eta/2.d0
!END SUBROUTINE EnergyCorrection
