#include "sfunction.h"

void Multiply(function2D<double>& C, const function2D<double>& A, const function2D<double>& B)
{
  int N = A.size_N();
  int K = A.size_Nd();
  int M = B.size_Nd();
  C.N = N; C.Nd = M;
  if (K<20){

    const double* a = A.MemPt();
    const double* b = B.MemPt();
    double* c = C.MemPt();
    int lda = A.lda();
    int ldb = B.lda();
    int ldc = C.lda();
    for (int i=0; i<N; i++){
      for (int j=0; j<M; j++){
  	double sum=0;
  	for (int k=0; k<K; k++) sum += a[i*lda+k]*b[k*ldb+j];
  	c[i*ldc+j] = sum;
      }
    }
    
//       for (int i=0; i<N; i++){
//         for (int j=0; j<M; j++){
//   	double sum=0;
//   	for (int k=0; k<K; k++) sum += A(i,k)*B(k,j);
//   	C(i,j) = sum;
//         }
//       }
    
  }else{
    C.MProduct(A,B); // Call to BLAS
  }
}
