#!/usr/bin/env python
import sys, shutil, os
from scipy import *

dir0 = os.getcwd()
dir1 = os.path.realpath(os.path.dirname(sys.argv[0]))

#print dir0, dir1
#sys.exit(0)

if len(sys.argv)<3:
    print 'give input file G(iom) and number of orbitals'
    sys.exit(0)
Gfile = sys.argv[1]
nb = int(sys.argv[2])

# input to maxent code
params = [("Nq number of spins",                           1),
          ("number of time slices +1",                     200),
          ("idg, delta-G (0 - propotional G, 1 = const)", '1 0.0015'),
          ("beta",                                         50),
          ("Nw number of frequencies",                     600),
          ("Dw frequency increment",                       0.06),
          ("anealing steps",                               2000),
          ("alpha0",                                       1200),
          ("number of smoothing runs nr",                  0),
          ("seed",                                         1234),
          ("iflat,eim",                                   '0  0.049'),
          ("mu  U_pot ict -  only used for transport",    '0  2  1'),
          ("imaxent",                                      1),
          ("normalization",                                1)]


fi = open('input', 'w')
for k in params:
    print >> fi, k[1], '! '+k[0]
fi.close()

# Inverse fourier transform
#shutil.copy2(sys.argv[1], 'Gtau1.dat')

#cmd = dir1+'/inverseF ' +str(params[1][1])+' '+sys.argv[1]+' > Gtau1.dat'
#print cmd
#print os.popen(cmd).read()
#print os.popen(dir1+'/maxentropy < input >> nohup.out.me').read()



Gf = io.read_array(Gfile)
gcur = zeros((shape(Gf)[0],3))
gcur[:,0] = Gf[:,0]
for b in range(nb):
    send = str(b)
    gcur[:,1] = Gf[:,2*b+1]
    gcur[:,2] = Gf[:,2*b+2]
    io.write_array('Gf.'+send, gcur)
    shutil.copy2('Gf.'+send, 'Gf.out')
    cmd = dir1+'/inverseF ' +str(params[1][1])+' Gf.'+send+' > Gtau.'+send
    print cmd
    print os.popen(cmd).read()

print 'Starting Maxent'

for b in range(nb):
    send = str(b)
    shutil.copy2('Gtau.'+send, 'Gtau1.dat')
    print os.popen('./maxentropy < input >> nohup.out.me').read()
    shutil.copy2('dos', 'dos.'+send)

dos0 = io.read_array('dos.0')
DOSt=zeros((shape(dos0)[0],nb+2))
DOSt[:,0] =  dos0[:,0]
DOSt[:,2] =  dos0[:,1]
DOSt[:,1] += dos0[:,1]
for b in range(1,nb):
    send = str(b)
    dosb = io.read_array('dos.'+send)
    DOSt[:,b+2] = dosb[:,1]
    DOSt[:,1]  += dosb[:,1]
io.write_array('dos.tot', DOSt)   
        
