#!/usr/env/bin python

from scipy import *
from pylab import *
from scipy import weave

code="""
     using namespace std;

     double Ry2eV = 13.6056920311654;

     double Ax = 0;
     for (int ib=0; ib<nbands; ib++){
        complex<double> ekom( data(1+2*ib),  min(data(2+2*ib), -small) );
        complex<double> gc = 1./(omega+mu-ekom);
        Ax += -gc.imag()/M_PI;
     }
     return_val = Ax;
     
     """
if __name__ == '__main__':

    small = 1e-5
    
    fEF = open('EF.dat', 'r')
    mu = float(fEF.next().split()[0])
    print 'mu=', mu
    
    fdat = open('eigvals.dat', 'r')

    wdata = fdat.readlines()

    ikp=0
    Akom=[]
    ii=0
    while (ii<len(wdata)):
        
        data = wdata[ii].split()
        ii += 1
        #print data
        
        (ikp, isym, nbands, nemin, nomega) = map(int, data[1:6])

        ekom = zeros(nbands, dtype=complex)
        Aom=[]
        om=[]
        for iom in range(nomega):
            data = array(map(float, wdata[ii].split()))
            ii += 1
            omega = float(data[0])
            
            Ax = weave.inline(code, ['nbands', 'omega', 'mu', 'data', 'small', 'ikp'],
                              type_converters=weave.converters.blitz, compiler = 'gcc')
            
            om.append(omega)
            Aom.append(Ax)
        Akom.append( Aom )
        ikp += 1

    Akom = array(Akom).transpose()
    print shape(Akom)
    
    vmm = [0,20]
    xmm = [0, shape(Akom)[1]]
    ymm = [om[0], om[-1]]
    
    imshow(Akom, interpolation='bilinear', cmap=cm.hot, origin='lower', vmin=vmm[0], vmax=vmm[1], extent=[xmm[0],xmm[1],ymm[0],ymm[1]], aspect=(xmm[1]-xmm[0])*0.8/(ymm[1]-ymm[0]) )
    colorbar()
    show()
    
    #print shape(Akom)
    
    #print len(Aom)
        
    #print ikp, isym, nbands, nomega
    
    
